/*
 * QEMU model of the DDR_PHY ddr_phy
 *
 * Copyright (c) 2015 Xilinx Inc.
 *
 * Autogenerated by xregqemu.py 2015-09-16.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include "qemu/osdep.h"
#include "hw/sysbus.h"
#include "hw/register-dep.h"
#include "qemu/bitops.h"
#include "qemu/log.h"

#ifndef XILINX_DDR_PHY_ERR_DEBUG
#define XILINX_DDR_PHY_ERR_DEBUG 0
#endif

#define TYPE_XILINX_DDR_PHY "xlnx.zynqmp-ddr-phy"

#define XILINX_DDR_PHY(obj) \
     OBJECT_CHECK(DDR_PHY, (obj), TYPE_XILINX_DDR_PHY)

DEP_REG32(RIDR, 0x0)
    DEP_FIELD(RIDR, UDRID, 8, 24)
    DEP_FIELD(RIDR, PHYMJR, 4, 20)
    DEP_FIELD(RIDR, PHYMDR, 4, 16)
    DEP_FIELD(RIDR, PHYMNR, 4, 12)
    DEP_FIELD(RIDR, PUBMJR, 4, 8)
    DEP_FIELD(RIDR, PUBMDR, 4, 4)
    DEP_FIELD(RIDR, PUBMNR, 4, 0)
DEP_REG32(PIR, 0x4)
    DEP_FIELD(PIR, RESERVED_31, 1, 31)
    DEP_FIELD(PIR, ZCALBYP, 1, 30)
    DEP_FIELD(PIR, DCALPSE, 1, 29)
    DEP_FIELD(PIR, RESERVED_28_21, 8, 21)
    DEP_FIELD(PIR, DQS2DQ, 1, 20)
    DEP_FIELD(PIR, RDIMMINIT, 1, 19)
    DEP_FIELD(PIR, CTLDINIT, 1, 18)
    DEP_FIELD(PIR, VREF, 1, 17)
    DEP_FIELD(PIR, SRD, 1, 16)
    DEP_FIELD(PIR, WREYE, 1, 15)
    DEP_FIELD(PIR, RDEYE, 1, 14)
    DEP_FIELD(PIR, WRDSKW, 1, 13)
    DEP_FIELD(PIR, RDDSKW, 1, 12)
    DEP_FIELD(PIR, WLADJ, 1, 11)
    DEP_FIELD(PIR, QSGATE, 1, 10)
    DEP_FIELD(PIR, WL, 1, 9)
    DEP_FIELD(PIR, DRAMINIT, 1, 8)
    DEP_FIELD(PIR, DRAMRST, 1, 7)
    DEP_FIELD(PIR, PHYRST, 1, 6)
    DEP_FIELD(PIR, DCAL, 1, 5)
    DEP_FIELD(PIR, PLLINIT, 1, 4)
    DEP_FIELD(PIR, RESERVED_3, 1, 3)
    DEP_FIELD(PIR, CA, 1, 2)
    DEP_FIELD(PIR, ZCAL, 1, 1)
    DEP_FIELD(PIR, INIT, 1, 0)
DEP_REG32(PGCR0, 0x10)
    DEP_FIELD(PGCR0, ADCP, 1, 31)
    DEP_FIELD(PGCR0, RESERVED_30_27, 4, 27)
    DEP_FIELD(PGCR0, PHYFRST, 1, 26)
    DEP_FIELD(PGCR0, OSCACDL, 2, 24)
    DEP_FIELD(PGCR0, RESERVED_23_19, 5, 19)
    DEP_FIELD(PGCR0, DTOSEL, 5, 14)
    DEP_FIELD(PGCR0, RESERVED_13, 1, 13)
    DEP_FIELD(PGCR0, OSCDIV, 4, 9)
    DEP_FIELD(PGCR0, OSCEN, 1, 8)
    DEP_FIELD(PGCR0, RESERVED_7_0, 8, 0)
DEP_REG32(PGCR1, 0x14)
    DEP_FIELD(PGCR1, LBMODE, 1, 31)
    DEP_FIELD(PGCR1, RESERVED_30_29, 2, 29)
    DEP_FIELD(PGCR1, LBGSDQS, 1, 28)
    DEP_FIELD(PGCR1, DLTST, 1, 27)
    DEP_FIELD(PGCR1, DLTMODE, 1, 26)
    DEP_FIELD(PGCR1, PHYHRST, 1, 25)
    DEP_FIELD(PGCR1, ACVLDTRN, 1, 24)
    DEP_FIELD(PGCR1, ACVLDDLY, 3, 21)
    DEP_FIELD(PGCR1, LRDIMMST, 1, 20)
    DEP_FIELD(PGCR1, RESERVED_19, 1, 19)
    DEP_FIELD(PGCR1, UPDMSTRC0, 1, 18)
    DEP_FIELD(PGCR1, DISDIC, 1, 17)
    DEP_FIELD(PGCR1, ACPDDC, 1, 16)
    DEP_FIELD(PGCR1, DUALCHN, 1, 15)
    DEP_FIELD(PGCR1, FDEPTH, 2, 13)
    DEP_FIELD(PGCR1, LPFDEPTH, 2, 11)
    DEP_FIELD(PGCR1, LPFEN, 1, 10)
    DEP_FIELD(PGCR1, MDLEN, 1, 9)
    DEP_FIELD(PGCR1, RESERVED_8_7, 2, 7)
    DEP_FIELD(PGCR1, PUBMODE, 1, 6)
    DEP_FIELD(PGCR1, CAST, 1, 5)
    DEP_FIELD(PGCR1, DX_DQSOUT_DIFF, 1, 4)
    DEP_FIELD(PGCR1, AC_CKOUT_DIFF, 1, 3)
    DEP_FIELD(PGCR1, WLSTEP, 1, 2)
    DEP_FIELD(PGCR1, WLMODE, 1, 1)
    DEP_FIELD(PGCR1, DTOMODE, 1, 0)
DEP_REG32(PGCR2, 0x18)
    DEP_FIELD(PGCR2, CLRTSTAT, 1, 31)
    DEP_FIELD(PGCR2, CLRZCAL, 1, 30)
    DEP_FIELD(PGCR2, CLRPERR, 1, 29)
    DEP_FIELD(PGCR2, ICPC, 1, 28)
    DEP_FIELD(PGCR2, DTPMXTMR, 8, 20)
    DEP_FIELD(PGCR2, INITFSMBYP, 1, 19)
    DEP_FIELD(PGCR2, PLLFSMBYP, 1, 18)
    DEP_FIELD(PGCR2, TREFPRD, 18, 0)
DEP_REG32(PGCR3, 0x1c)
    DEP_FIELD(PGCR3, CKNEN, 8, 24)
    DEP_FIELD(PGCR3, CKEN, 8, 16)
    DEP_FIELD(PGCR3, RESERVED_15, 1, 15)
    DEP_FIELD(PGCR3, GATEACRDCLK, 2, 13)
    DEP_FIELD(PGCR3, GATEACDDRCLK, 2, 11)
    DEP_FIELD(PGCR3, GATEACCTLCLK, 2, 9)
    DEP_FIELD(PGCR3, RESERVED_8, 1, 8)
    DEP_FIELD(PGCR3, DDLBYPMODE, 2, 6)
    DEP_FIELD(PGCR3, IOLB, 1, 5)
    DEP_FIELD(PGCR3, RDMODE, 2, 3)
    DEP_FIELD(PGCR3, DISRST, 1, 2)
    DEP_FIELD(PGCR3, CLKLEVEL, 2, 0)
DEP_REG32(PGCR4, 0x20)
    DEP_FIELD(PGCR4, RESERVED_31_30, 2, 30)
    DEP_FIELD(PGCR4, ACDDLLD, 1, 29)
    DEP_FIELD(PGCR4, ACDDLBYP, 5, 24)
    DEP_FIELD(PGCR4, OEDDLBYP, 1, 23)
    DEP_FIELD(PGCR4, TEDDLBYP, 1, 22)
    DEP_FIELD(PGCR4, PDRDDLBYP, 1, 21)
    DEP_FIELD(PGCR4, RRRMODE, 1, 20)
    DEP_FIELD(PGCR4, WRRMODE, 1, 19)
    DEP_FIELD(PGCR4, RESERVED_18_8, 11, 8)
    DEP_FIELD(PGCR4, LPWAKEUP_THRSH, 4, 4)
    DEP_FIELD(PGCR4, RESERVED_3_2, 2, 2)
    DEP_FIELD(PGCR4, LPPLLPD, 1, 1)
    DEP_FIELD(PGCR4, LPIOPD, 1, 0)
DEP_REG32(PGCR5, 0x24)
    DEP_FIELD(PGCR5, FRQBT, 8, 24)
    DEP_FIELD(PGCR5, FRQAT, 8, 16)
    DEP_FIELD(PGCR5, DISCNPERIOD, 8, 8)
    DEP_FIELD(PGCR5, VREF_RBCTRL, 4, 4)
    DEP_FIELD(PGCR5, RESERVED_3, 1, 3)
    DEP_FIELD(PGCR5, DXREFISELRANGE, 1, 2)
    DEP_FIELD(PGCR5, DDLPGACT, 1, 1)
    DEP_FIELD(PGCR5, DDLPGRW, 1, 0)
DEP_REG32(PGCR6, 0x28)
    DEP_FIELD(PGCR6, RESERVED_31_24, 8, 24)
    DEP_FIELD(PGCR6, DLDLMT, 8, 16)
    DEP_FIELD(PGCR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(PGCR6, ACDLVT, 1, 13)
    DEP_FIELD(PGCR6, ACBVT, 1, 12)
    DEP_FIELD(PGCR6, ODTBVT, 1, 11)
    DEP_FIELD(PGCR6, CKEBVT, 1, 10)
    DEP_FIELD(PGCR6, CSNBVT, 1, 9)
    DEP_FIELD(PGCR6, CKBVT, 1, 8)
    DEP_FIELD(PGCR6, RESERVED_7_2, 6, 2)
    DEP_FIELD(PGCR6, FVT, 1, 1)
    DEP_FIELD(PGCR6, INHVT, 1, 0)
DEP_REG32(PGCR7, 0x2c)
    DEP_FIELD(PGCR7, RESERVED_31_8, 24, 8)
    DEP_FIELD(PGCR7, ACRSVD_7_6, 2, 6)
    DEP_FIELD(PGCR7, ACCALCLK, 1, 5)
    DEP_FIELD(PGCR7, ACRCLKMD, 1, 4)
    DEP_FIELD(PGCR7, ACDLDT, 1, 3)
    DEP_FIELD(PGCR7, ACRSVD_2, 1, 2)
    DEP_FIELD(PGCR7, ACDTOSEL, 1, 1)
    DEP_FIELD(PGCR7, ACTMODE, 1, 0)
DEP_REG32(PGSR0, 0x30)
    DEP_FIELD(PGSR0, APLOCK, 1, 31)
    DEP_FIELD(PGSR0, SRDERR, 1, 30)
    DEP_FIELD(PGSR0, CAWRN, 1, 29)
    DEP_FIELD(PGSR0, CAERR, 1, 28)
    DEP_FIELD(PGSR0, WEERR, 1, 27)
    DEP_FIELD(PGSR0, REERR, 1, 26)
    DEP_FIELD(PGSR0, WDERR, 1, 25)
    DEP_FIELD(PGSR0, RDERR, 1, 24)
    DEP_FIELD(PGSR0, WLAERR, 1, 23)
    DEP_FIELD(PGSR0, QSGERR, 1, 22)
    DEP_FIELD(PGSR0, WLERR, 1, 21)
    DEP_FIELD(PGSR0, ZCERR, 1, 20)
    DEP_FIELD(PGSR0, VERR, 1, 19)
    DEP_FIELD(PGSR0, DQS2DQERR, 1, 18)
    DEP_FIELD(PGSR0, RESERVED_17_16, 2, 16)
    DEP_FIELD(PGSR0, DQS2DQDONE, 1, 15)
    DEP_FIELD(PGSR0, VDONE, 1, 14)
    DEP_FIELD(PGSR0, SRDDONE, 1, 13)
    DEP_FIELD(PGSR0, CADONE, 1, 12)
    DEP_FIELD(PGSR0, WEDONE, 1, 11)
    DEP_FIELD(PGSR0, REDONE, 1, 10)
    DEP_FIELD(PGSR0, WDDONE, 1, 9)
    DEP_FIELD(PGSR0, RDDONE, 1, 8)
    DEP_FIELD(PGSR0, WLADONE, 1, 7)
    DEP_FIELD(PGSR0, QSGDONE, 1, 6)
    DEP_FIELD(PGSR0, WLDONE, 1, 5)
    DEP_FIELD(PGSR0, DIDONE, 1, 4)
    DEP_FIELD(PGSR0, ZCDONE, 1, 3)
    DEP_FIELD(PGSR0, DCDONE, 1, 2)
    DEP_FIELD(PGSR0, PLDONE, 1, 1)
    DEP_FIELD(PGSR0, IDONE, 1, 0)
DEP_REG32(PGSR1, 0x34)
    DEP_FIELD(PGSR1, PARERR, 1, 31)
    DEP_FIELD(PGSR1, VTSTOP, 1, 30)
    DEP_FIELD(PGSR1, RESERVED_29_25, 5, 25)
    DEP_FIELD(PGSR1, DLTCODE, 24, 1)
    DEP_FIELD(PGSR1, DLTDONE, 1, 0)
DEP_REG32(PGSR2, 0x38)
    DEP_FIELD(PGSR2, RESERVED_31_25, 7, 25)
    DEP_FIELD(PGSR2, DLTCODE, 24, 1)
    DEP_FIELD(PGSR2, DLTDONE, 1, 0)
DEP_REG32(PTR0, 0x40)
    DEP_FIELD(PTR0, TPLLPD, 11, 21)
    DEP_FIELD(PTR0, TPLLGS, 15, 6)
    DEP_FIELD(PTR0, TPHYRST, 6, 0)
DEP_REG32(PTR1, 0x44)
    DEP_FIELD(PTR1, TPLLLOCK, 16, 16)
    DEP_FIELD(PTR1, RESERVED_15_13, 3, 13)
    DEP_FIELD(PTR1, TPLLRST, 13, 0)
DEP_REG32(PTR2, 0x48)
    DEP_FIELD(PTR2, RESERVED_31_20, 12, 20)
    DEP_FIELD(PTR2, TWLDLYS, 5, 15)
    DEP_FIELD(PTR2, TCALH, 5, 10)
    DEP_FIELD(PTR2, TCALS, 5, 5)
    DEP_FIELD(PTR2, TCALON, 5, 0)
DEP_REG32(PTR3, 0x4c)
    DEP_FIELD(PTR3, RESERVED_31_23, 9, 23)
    DEP_FIELD(PTR3, TDINIT0, 23, 0)
DEP_REG32(PTR4, 0x50)
    DEP_FIELD(PTR4, RESERVED_31_13, 19, 13)
    DEP_FIELD(PTR4, TDINIT1, 13, 0)
DEP_REG32(PTR5, 0x54)
    DEP_FIELD(PTR5, RESERVED_31_19, 13, 19)
    DEP_FIELD(PTR5, TDINIT2, 19, 0)
DEP_REG32(PTR6, 0x58)
    DEP_FIELD(PTR6, RESERVED_31_27, 5, 27)
    DEP_FIELD(PTR6, TDINIT4, 7, 20)
    DEP_FIELD(PTR6, RESERVED_19_12, 8, 12)
    DEP_FIELD(PTR6, TDINIT3, 12, 0)
DEP_REG32(PLLCR0, 0x68)
    DEP_FIELD(PLLCR0, PLLBYP, 1, 31)
    DEP_FIELD(PLLCR0, PLLRST, 1, 30)
    DEP_FIELD(PLLCR0, PLLPD, 1, 29)
    DEP_FIELD(PLLCR0, RSTOPM, 1, 28)
    DEP_FIELD(PLLCR0, FRQSEL, 4, 24)
    DEP_FIELD(PLLCR0, RLOCKM, 1, 23)
    DEP_FIELD(PLLCR0, CPPC, 6, 17)
    DEP_FIELD(PLLCR0, CPIC, 4, 13)
    DEP_FIELD(PLLCR0, GSHIFT, 1, 12)
    DEP_FIELD(PLLCR0, RESERVED_11_9, 3, 9)
    DEP_FIELD(PLLCR0, ATOEN, 1, 8)
    DEP_FIELD(PLLCR0, ATC, 4, 4)
    DEP_FIELD(PLLCR0, DTC, 4, 0)
DEP_REG32(PLLCR1, 0x6c)
    DEP_FIELD(PLLCR1, PLLPROG, 16, 16)
    DEP_FIELD(PLLCR1, RESERVED_15_6, 10, 6)
    DEP_FIELD(PLLCR1, BYPVREGCP, 1, 5)
    DEP_FIELD(PLLCR1, BYPVREGDIG, 1, 4)
    DEP_FIELD(PLLCR1, BYPVDD, 1, 3)
    DEP_FIELD(PLLCR1, LOCKPS, 1, 2)
    DEP_FIELD(PLLCR1, LOCKCS, 1, 1)
    DEP_FIELD(PLLCR1, LOCKDS, 1, 0)
DEP_REG32(PLLCR2, 0x70)
DEP_REG32(PLLCR3, 0x74)
DEP_REG32(PLLCR4, 0x78)
DEP_REG32(PLLCR5, 0x7c)
    DEP_FIELD(PLLCR5, RESERVED_31_8, 24, 8)
    DEP_FIELD(PLLCR5, PLLCTRL_103_96, 8, 0)
DEP_REG32(DXCCR, 0x88)
    DEP_FIELD(DXCCR, RESERVED_31_30, 2, 30)
    DEP_FIELD(DXCCR, RKLOOP, 1, 29)
    DEP_FIELD(DXCCR, RESERVED_28_7, 22, 7)
    DEP_FIELD(DXCCR, DQS2DQMPER, 4, 3)
    DEP_FIELD(DXCCR, RESERVED_2_0, 3, 0)
DEP_REG32(DSGCR, 0x90)
    DEP_FIELD(DSGCR, RESERVED_31_28, 4, 28)
    DEP_FIELD(DSGCR, RDBICLSEL, 1, 27)
    DEP_FIELD(DSGCR, RDBICL, 3, 24)
    DEP_FIELD(DSGCR, PHYZUEN, 1, 23)
    DEP_FIELD(DSGCR, RESERVED_22, 1, 22)
    DEP_FIELD(DSGCR, RSTOE, 1, 21)
    DEP_FIELD(DSGCR, SDRMODE, 2, 19)
    DEP_FIELD(DSGCR, RESERVED_18, 1, 18)
    DEP_FIELD(DSGCR, ATOAE, 1, 17)
    DEP_FIELD(DSGCR, DTOOE, 1, 16)
    DEP_FIELD(DSGCR, DTOIOM, 1, 15)
    DEP_FIELD(DSGCR, DTOPDR, 1, 14)
    DEP_FIELD(DSGCR, RESERVED_13, 1, 13)
    DEP_FIELD(DSGCR, DTOODT, 1, 12)
    DEP_FIELD(DSGCR, PUAD, 6, 6)
    DEP_FIELD(DSGCR, CUAEN, 1, 5)
    DEP_FIELD(DSGCR, RESERVED_4_3, 2, 3)
    DEP_FIELD(DSGCR, CTLZUEN, 1, 2)
    DEP_FIELD(DSGCR, RESERVED_1, 1, 1)
    DEP_FIELD(DSGCR, PUREN, 1, 0)
DEP_REG32(ODTCR, 0x98)
    DEP_FIELD(ODTCR, RESERVED_31_28, 4, 28)
    DEP_FIELD(ODTCR, WRODT_RSVD, 10, 18)
    DEP_FIELD(ODTCR, WRODT, 2, 16)
    DEP_FIELD(ODTCR, RESERVED_15_12, 4, 12)
    DEP_FIELD(ODTCR, RDODT_RSVD, 10, 2)
    DEP_FIELD(ODTCR, RDODT, 2, 0)
DEP_REG32(AACR, 0xa0)
    DEP_FIELD(AACR, AAOENC, 1, 31)
    DEP_FIELD(AACR, AAENC, 1, 30)
    DEP_FIELD(AACR, AATR, 30, 0)
DEP_REG32(GPR0, 0xc0)
DEP_REG32(GPR1, 0xc4)
DEP_REG32(DCR, 0x100)
    DEP_FIELD(DCR, GEARDN, 1, 31)
    DEP_FIELD(DCR, UBG, 1, 30)
    DEP_FIELD(DCR, UDIMM, 1, 29)
    DEP_FIELD(DCR, DDR2T, 1, 28)
    DEP_FIELD(DCR, NOSRA, 1, 27)
    DEP_FIELD(DCR, RESERVED_26_18, 9, 18)
    DEP_FIELD(DCR, BYTEMASK, 8, 10)
    DEP_FIELD(DCR, DDRTYPE, 2, 8)
    DEP_FIELD(DCR, MPRDQ, 1, 7)
    DEP_FIELD(DCR, PDQ, 3, 4)
    DEP_FIELD(DCR, DDR8BNK, 1, 3)
    DEP_FIELD(DCR, DDRMD, 3, 0)
DEP_REG32(DTPR0, 0x110)
    DEP_FIELD(DTPR0, RESERVED_31_29, 3, 29)
    DEP_FIELD(DTPR0, TRRD, 5, 24)
    DEP_FIELD(DTPR0, RESERVED_23, 1, 23)
    DEP_FIELD(DTPR0, TRAS, 7, 16)
    DEP_FIELD(DTPR0, RESERVED_15, 1, 15)
    DEP_FIELD(DTPR0, TRP, 7, 8)
    DEP_FIELD(DTPR0, RESERVED_7_5, 3, 5)
    DEP_FIELD(DTPR0, TRTP, 5, 0)
DEP_REG32(DTPR1, 0x114)
    DEP_FIELD(DTPR1, RESERVED_31, 1, 31)
    DEP_FIELD(DTPR1, TWLMRD, 7, 24)
    DEP_FIELD(DTPR1, RESERVED_23, 1, 23)
    DEP_FIELD(DTPR1, TFAW, 7, 16)
    DEP_FIELD(DTPR1, RESERVED_15_11, 5, 11)
    DEP_FIELD(DTPR1, TMOD, 3, 8)
    DEP_FIELD(DTPR1, RESERVED_7_5, 3, 5)
    DEP_FIELD(DTPR1, TMRD, 5, 0)
DEP_REG32(DTPR2, 0x118)
    DEP_FIELD(DTPR2, RESERVED_31_29, 3, 29)
    DEP_FIELD(DTPR2, TRTW, 1, 28)
    DEP_FIELD(DTPR2, RESERVED_27_25, 3, 25)
    DEP_FIELD(DTPR2, TRTODT, 1, 24)
    DEP_FIELD(DTPR2, RESERVED_23_20, 4, 20)
    DEP_FIELD(DTPR2, TCKE, 4, 16)
    DEP_FIELD(DTPR2, RESERVED_15_10, 6, 10)
    DEP_FIELD(DTPR2, TXS, 10, 0)
DEP_REG32(DTPR3, 0x11c)
    DEP_FIELD(DTPR3, TOFDX, 3, 29)
    DEP_FIELD(DTPR3, TCCD, 3, 26)
    DEP_FIELD(DTPR3, TDLLK, 10, 16)
    DEP_FIELD(DTPR3, RESERVED_15_12, 4, 12)
    DEP_FIELD(DTPR3, TDQSCKMAX, 4, 8)
    DEP_FIELD(DTPR3, RESERVED_7_3, 5, 3)
    DEP_FIELD(DTPR3, TDQSCK, 3, 0)
DEP_REG32(DTPR4, 0x120)
    DEP_FIELD(DTPR4, RESERVED_31_30, 2, 30)
    DEP_FIELD(DTPR4, TAOND_TAOFD, 2, 28)
    DEP_FIELD(DTPR4, RESERVED_27_26, 2, 26)
    DEP_FIELD(DTPR4, TRFC, 10, 16)
    DEP_FIELD(DTPR4, RESERVED_15_14, 2, 14)
    DEP_FIELD(DTPR4, TWLO, 6, 8)
    DEP_FIELD(DTPR4, RESERVED_7_5, 3, 5)
    DEP_FIELD(DTPR4, TXP, 5, 0)
DEP_REG32(DTPR5, 0x124)
    DEP_FIELD(DTPR5, RESERVED_31_24, 8, 24)
    DEP_FIELD(DTPR5, TRC, 8, 16)
    DEP_FIELD(DTPR5, RESERVED_15, 1, 15)
    DEP_FIELD(DTPR5, TRCD, 7, 8)
    DEP_FIELD(DTPR5, RESERVED_7_5, 3, 5)
    DEP_FIELD(DTPR5, TWTR, 5, 0)
DEP_REG32(DTPR6, 0x128)
    DEP_FIELD(DTPR6, PUBWLEN, 1, 31)
    DEP_FIELD(DTPR6, PUBRLEN, 1, 30)
    DEP_FIELD(DTPR6, RESERVED_29_14, 16, 14)
    DEP_FIELD(DTPR6, PUBWL, 6, 8)
    DEP_FIELD(DTPR6, RESERVED_7_6, 2, 6)
    DEP_FIELD(DTPR6, PUBRL, 6, 0)
DEP_REG32(RDIMMGCR0, 0x140)
    DEP_FIELD(RDIMMGCR0, RESERVED_31, 1, 31)
    DEP_FIELD(RDIMMGCR0, QCSEN, 1, 30)
    DEP_FIELD(RDIMMGCR0, RESERVED_29_28, 2, 28)
    DEP_FIELD(RDIMMGCR0, RDIMMIOM, 1, 27)
    DEP_FIELD(RDIMMGCR0, RESERVED_26_24, 3, 24)
    DEP_FIELD(RDIMMGCR0, ERROUTOE, 1, 23)
    DEP_FIELD(RDIMMGCR0, ERROUTIOM, 1, 22)
    DEP_FIELD(RDIMMGCR0, ERROUTPDR, 1, 21)
    DEP_FIELD(RDIMMGCR0, RESERVED_20, 1, 20)
    DEP_FIELD(RDIMMGCR0, ERROUTODT, 1, 19)
    DEP_FIELD(RDIMMGCR0, LRDIMM, 1, 18)
    DEP_FIELD(RDIMMGCR0, PARINIOM, 1, 17)
    DEP_FIELD(RDIMMGCR0, RESERVED_16_8, 9, 8)
    DEP_FIELD(RDIMMGCR0, RNKMRREN_RSVD, 2, 6)
    DEP_FIELD(RDIMMGCR0, RNKMRREN, 2, 4)
    DEP_FIELD(RDIMMGCR0, RESERVED_3, 1, 3)
    DEP_FIELD(RDIMMGCR0, SOPERR, 1, 2)
    DEP_FIELD(RDIMMGCR0, ERRNOREG, 1, 1)
    DEP_FIELD(RDIMMGCR0, RDIMM, 1, 0)
DEP_REG32(RDIMMGCR1, 0x144)
    DEP_FIELD(RDIMMGCR1, RESERVED_31_29, 3, 29)
    DEP_FIELD(RDIMMGCR1, A17BID, 1, 28)
    DEP_FIELD(RDIMMGCR1, RESERVED_27, 1, 27)
    DEP_FIELD(RDIMMGCR1, TBCMRD_L2, 3, 24)
    DEP_FIELD(RDIMMGCR1, RESERVED_23, 1, 23)
    DEP_FIELD(RDIMMGCR1, TBCMRD_L, 3, 20)
    DEP_FIELD(RDIMMGCR1, RESERVED_19, 1, 19)
    DEP_FIELD(RDIMMGCR1, TBCMRD, 3, 16)
    DEP_FIELD(RDIMMGCR1, RESERVED_15_14, 2, 14)
    DEP_FIELD(RDIMMGCR1, TBCSTAB, 14, 0)
DEP_REG32(RDIMMGCR2, 0x148)
DEP_REG32(RDIMMCR0, 0x150)
    DEP_FIELD(RDIMMCR0, RC7, 4, 28)
    DEP_FIELD(RDIMMCR0, RC6, 4, 24)
    DEP_FIELD(RDIMMCR0, RC5, 4, 20)
    DEP_FIELD(RDIMMCR0, RC4, 4, 16)
    DEP_FIELD(RDIMMCR0, RC3, 4, 12)
    DEP_FIELD(RDIMMCR0, RC2, 4, 8)
    DEP_FIELD(RDIMMCR0, RC1, 4, 4)
    DEP_FIELD(RDIMMCR0, RC0, 4, 0)
DEP_REG32(RDIMMCR1, 0x154)
    DEP_FIELD(RDIMMCR1, RC15, 4, 28)
    DEP_FIELD(RDIMMCR1, RC14, 4, 24)
    DEP_FIELD(RDIMMCR1, RC13, 4, 20)
    DEP_FIELD(RDIMMCR1, RC12, 4, 16)
    DEP_FIELD(RDIMMCR1, RC11, 4, 12)
    DEP_FIELD(RDIMMCR1, RC10, 4, 8)
    DEP_FIELD(RDIMMCR1, RC9, 4, 4)
    DEP_FIELD(RDIMMCR1, RC8, 4, 0)
DEP_REG32(RDIMMCR2, 0x158)
    DEP_FIELD(RDIMMCR2, RC4X, 8, 24)
    DEP_FIELD(RDIMMCR2, RC3X, 8, 16)
    DEP_FIELD(RDIMMCR2, RC2X, 8, 8)
    DEP_FIELD(RDIMMCR2, RC1X, 8, 0)
DEP_REG32(RDIMMCR3, 0x15c)
    DEP_FIELD(RDIMMCR3, RC8X, 8, 24)
    DEP_FIELD(RDIMMCR3, RC7X, 8, 16)
    DEP_FIELD(RDIMMCR3, RC6X, 8, 8)
    DEP_FIELD(RDIMMCR3, RC5X, 8, 0)
DEP_REG32(RDIMMCR4, 0x160)
    DEP_FIELD(RDIMMCR4, RCXX, 8, 24)
    DEP_FIELD(RDIMMCR4, RCBX, 8, 16)
    DEP_FIELD(RDIMMCR4, RCAX, 8, 8)
    DEP_FIELD(RDIMMCR4, RC9X, 8, 0)
DEP_REG32(SCHCR0, 0x168)
    DEP_FIELD(SCHCR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(SCHCR0, SCHDQV, 9, 16)
    DEP_FIELD(SCHCR0, RESERVED_15_12, 4, 12)
    DEP_FIELD(SCHCR0, SP_CMD, 4, 8)
    DEP_FIELD(SCHCR0, CMD, 4, 4)
    DEP_FIELD(SCHCR0, SCHTRIG, 4, 0)
DEP_REG32(SCHCR1, 0x16c)
    DEP_FIELD(SCHCR1, SCRNK, 4, 28)
    DEP_FIELD(SCHCR1, SCADDR, 20, 8)
    DEP_FIELD(SCHCR1, SCBG, 2, 6)
    DEP_FIELD(SCHCR1, SCBK, 2, 4)
    DEP_FIELD(SCHCR1, RESERVED_3, 1, 3)
    DEP_FIELD(SCHCR1, ALLRANK, 1, 2)
    DEP_FIELD(SCHCR1, RESERVED_1_0, 2, 0)
DEP_REG32(MR0, 0x180)
    DEP_FIELD(MR0, RESERVED_31_8, 24, 8)
    DEP_FIELD(MR0, CATR, 1, 7)
    DEP_FIELD(MR0, RSVD_6_5, 2, 5)
    DEP_FIELD(MR0, RZQI, 2, 3)
    DEP_FIELD(MR0, RSVD_2_0, 3, 0)
DEP_REG32(MR1, 0x184)
    DEP_FIELD(MR1, RESERVED_31_8, 24, 8)
    DEP_FIELD(MR1, RDPST, 1, 7)
    DEP_FIELD(MR1, NWR, 3, 4)
    DEP_FIELD(MR1, RDPRE, 1, 3)
    DEP_FIELD(MR1, WRPRE, 1, 2)
    DEP_FIELD(MR1, BL, 2, 0)
DEP_REG32(MR2, 0x188)
    DEP_FIELD(MR2, RESERVED_31_8, 24, 8)
    DEP_FIELD(MR2, WRL, 1, 7)
    DEP_FIELD(MR2, WLS, 1, 6)
    DEP_FIELD(MR2, WL, 3, 3)
    DEP_FIELD(MR2, RL, 3, 0)
DEP_REG32(MR3, 0x18c)
    DEP_FIELD(MR3, RESERVED_31_8, 24, 8)
    DEP_FIELD(MR3, DBIWR, 1, 7)
    DEP_FIELD(MR3, DBIRD, 1, 6)
    DEP_FIELD(MR3, PDDS, 3, 3)
    DEP_FIELD(MR3, RSVD, 1, 2)
    DEP_FIELD(MR3, WRPST, 1, 1)
    DEP_FIELD(MR3, PUCAL, 1, 0)
DEP_REG32(MR4, 0x190)
    DEP_FIELD(MR4, RESERVED_31_16, 16, 16)
    DEP_FIELD(MR4, RSVD_15_13, 3, 13)
    DEP_FIELD(MR4, WRP, 1, 12)
    DEP_FIELD(MR4, RDP, 1, 11)
    DEP_FIELD(MR4, RPTM, 1, 10)
    DEP_FIELD(MR4, SRA, 1, 9)
    DEP_FIELD(MR4, CS2CMDL, 3, 6)
    DEP_FIELD(MR4, RSVD1, 1, 5)
    DEP_FIELD(MR4, IVM, 1, 4)
    DEP_FIELD(MR4, TCRM, 1, 3)
    DEP_FIELD(MR4, TCRR, 1, 2)
    DEP_FIELD(MR4, MPDM, 1, 1)
    DEP_FIELD(MR4, RSVD_0, 1, 0)
DEP_REG32(MR5, 0x194)
    DEP_FIELD(MR5, RESERVED_31_16, 16, 16)
    DEP_FIELD(MR5, RSVD, 3, 13)
    DEP_FIELD(MR5, RDBI, 1, 12)
    DEP_FIELD(MR5, WDBI, 1, 11)
    DEP_FIELD(MR5, DM, 1, 10)
    DEP_FIELD(MR5, CAPPE, 1, 9)
    DEP_FIELD(MR5, RTTPARK, 3, 6)
    DEP_FIELD(MR5, ODTIBPD, 1, 5)
    DEP_FIELD(MR5, CAPES, 1, 4)
    DEP_FIELD(MR5, CRCEC, 1, 3)
    DEP_FIELD(MR5, CAPM, 3, 0)
DEP_REG32(MR6, 0x198)
    DEP_FIELD(MR6, RESERVED_31_16, 16, 16)
    DEP_FIELD(MR6, RSVD_15_13, 3, 13)
    DEP_FIELD(MR6, TCCDL, 3, 10)
    DEP_FIELD(MR6, RSVD_9_8, 2, 8)
    DEP_FIELD(MR6, VDDQTEN, 1, 7)
    DEP_FIELD(MR6, VDQTRG, 1, 6)
    DEP_FIELD(MR6, VDQTVAL, 6, 0)
DEP_REG32(MR7, 0x19c)
    DEP_FIELD(MR7, RESERVED_31_16, 16, 16)
    DEP_FIELD(MR7, RSVD_15_0, 16, 0)
DEP_REG32(MR11, 0x1ac)
    DEP_FIELD(MR11, RESERVED_31_8, 24, 8)
    DEP_FIELD(MR11, RSVD, 5, 3)
    DEP_FIELD(MR11, PDCTL, 1, 2)
    DEP_FIELD(MR11, DQODT, 2, 0)
DEP_REG32(MR12, 0x1b0)
    DEP_FIELD(MR12, RESERVED_31_8, 24, 8)
    DEP_FIELD(MR12, RSVD, 1, 7)
    DEP_FIELD(MR12, VR_CA, 1, 6)
    DEP_FIELD(MR12, VREF_CA, 6, 0)
DEP_REG32(MR13, 0x1b4)
    DEP_FIELD(MR13, RESERVED_31_8, 24, 8)
    DEP_FIELD(MR13, FSPOP, 1, 7)
    DEP_FIELD(MR13, FSPWR, 1, 6)
    DEP_FIELD(MR13, DMD, 1, 5)
    DEP_FIELD(MR13, RRO, 1, 4)
    DEP_FIELD(MR13, VRCG, 1, 3)
    DEP_FIELD(MR13, VRO, 1, 2)
    DEP_FIELD(MR13, RPT, 1, 1)
    DEP_FIELD(MR13, CBT, 1, 0)
DEP_REG32(MR14, 0x1b8)
    DEP_FIELD(MR14, RESERVED_31_8, 24, 8)
    DEP_FIELD(MR14, RSVD, 1, 7)
    DEP_FIELD(MR14, VR_DQ, 1, 6)
    DEP_FIELD(MR14, VREF_DQ, 6, 0)
DEP_REG32(MR22, 0x1d8)
    DEP_FIELD(MR22, RESERVED_31_8, 24, 8)
    DEP_FIELD(MR22, RSVD, 2, 6)
    DEP_FIELD(MR22, ODTD_CA, 1, 5)
    DEP_FIELD(MR22, ODTE_CS, 1, 4)
    DEP_FIELD(MR22, ODTE_CK, 1, 3)
    DEP_FIELD(MR22, CODT, 3, 0)
DEP_REG32(DTCR0, 0x200)
    DEP_FIELD(DTCR0, RFSHDT, 4, 28)
    DEP_FIELD(DTCR0, RESERVED_27_26, 2, 26)
    DEP_FIELD(DTCR0, DTDRS, 2, 24)
    DEP_FIELD(DTCR0, DTEXG, 1, 23)
    DEP_FIELD(DTCR0, DTEXD, 1, 22)
    DEP_FIELD(DTCR0, DTDSTP, 1, 21)
    DEP_FIELD(DTCR0, DTDEN, 1, 20)
    DEP_FIELD(DTCR0, DTDBS, 4, 16)
    DEP_FIELD(DTCR0, DTRDBITR, 2, 14)
    DEP_FIELD(DTCR0, RESERVED_13, 1, 13)
    DEP_FIELD(DTCR0, DTWBDDM, 1, 12)
    DEP_FIELD(DTCR0, RFSHEN, 4, 8)
    DEP_FIELD(DTCR0, DTCMPD, 1, 7)
    DEP_FIELD(DTCR0, DTMPR, 1, 6)
    DEP_FIELD(DTCR0, RESERVED_5_4, 2, 4)
    DEP_FIELD(DTCR0, DTRPTN, 4, 0)
DEP_REG32(DTCR1, 0x204)
    DEP_FIELD(DTCR1, RANKEN_RSVD, 14, 18)
    DEP_FIELD(DTCR1, RANKEN, 2, 16)
    DEP_FIELD(DTCR1, RESERVED_15_14, 2, 14)
    DEP_FIELD(DTCR1, DTRANK, 2, 12)
    DEP_FIELD(DTCR1, RESERVED_11, 1, 11)
    DEP_FIELD(DTCR1, RDLVLGDIFF, 3, 8)
    DEP_FIELD(DTCR1, RESERVED_7, 1, 7)
    DEP_FIELD(DTCR1, RDLVLGS, 3, 4)
    DEP_FIELD(DTCR1, RESERVED_3, 1, 3)
    DEP_FIELD(DTCR1, RDPRMVL_TRN, 1, 2)
    DEP_FIELD(DTCR1, RDLVLEN, 1, 1)
    DEP_FIELD(DTCR1, BSTEN, 1, 0)
DEP_REG32(DTAR0, 0x208)
    DEP_FIELD(DTAR0, RESERVED_31_30, 2, 30)
    DEP_FIELD(DTAR0, MPRLOC, 2, 28)
    DEP_FIELD(DTAR0, DTBGBK1, 4, 24)
    DEP_FIELD(DTAR0, DTBGBK0, 4, 20)
    DEP_FIELD(DTAR0, RESERVED_19_18, 2, 18)
    DEP_FIELD(DTAR0, DTROW, 18, 0)
DEP_REG32(DTAR1, 0x20c)
    DEP_FIELD(DTAR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DTAR1, DTCOL1, 9, 16)
    DEP_FIELD(DTAR1, RESERVED_15_9, 7, 9)
    DEP_FIELD(DTAR1, DTCOL0, 9, 0)
DEP_REG32(DTAR2, 0x210)
    DEP_FIELD(DTAR2, RESERVED_31_25, 7, 25)
    DEP_FIELD(DTAR2, DTCOL3, 9, 16)
    DEP_FIELD(DTAR2, RESERVED_15_9, 7, 9)
    DEP_FIELD(DTAR2, DTCOL2, 9, 0)
DEP_REG32(DTDR0, 0x218)
    DEP_FIELD(DTDR0, DTBYTE3, 8, 24)
    DEP_FIELD(DTDR0, DTBYTE2, 8, 16)
    DEP_FIELD(DTDR0, DTBYTE1, 8, 8)
    DEP_FIELD(DTDR0, DTBYTE0, 8, 0)
DEP_REG32(DTDR1, 0x21c)
    DEP_FIELD(DTDR1, DTBYTE7, 8, 24)
    DEP_FIELD(DTDR1, DTBYTE6, 8, 16)
    DEP_FIELD(DTDR1, DTBYTE5, 8, 8)
    DEP_FIELD(DTDR1, DTBYTE4, 8, 0)
DEP_REG32(DTEDR0, 0x230)
    DEP_FIELD(DTEDR0, DTWBMX, 8, 24)
    DEP_FIELD(DTEDR0, DTWBMN, 6, 18)
    DEP_FIELD(DTEDR0, DTWLMX, 9, 9)
    DEP_FIELD(DTEDR0, DTWLMN, 9, 0)
DEP_REG32(DTEDR1, 0x234)
    DEP_FIELD(DTEDR1, DTRBMX, 8, 24)
    DEP_FIELD(DTEDR1, DTRBMN, 6, 18)
    DEP_FIELD(DTEDR1, DTRLMX, 9, 9)
    DEP_FIELD(DTEDR1, DTRLMN, 9, 0)
DEP_REG32(DTEDR2, 0x238)
    DEP_FIELD(DTEDR2, DTRBMX, 8, 24)
    DEP_FIELD(DTEDR2, DTRBMN, 6, 18)
    DEP_FIELD(DTEDR2, DTRLMX, 9, 9)
    DEP_FIELD(DTEDR2, DTRLMN, 9, 0)
DEP_REG32(VTDR, 0x23c)
    DEP_FIELD(VTDR, RESERVED_31, 1, 31)
    DEP_FIELD(VTDR, HVREFMX, 7, 24)
    DEP_FIELD(VTDR, RESERVED_23, 1, 23)
    DEP_FIELD(VTDR, HVREFMN, 7, 16)
    DEP_FIELD(VTDR, RESERVED_15_14, 2, 14)
    DEP_FIELD(VTDR, DVREFMX, 6, 8)
    DEP_FIELD(VTDR, RESERVED_7_6, 2, 6)
    DEP_FIELD(VTDR, DVREFMN, 6, 0)
DEP_REG32(CATR0, 0x240)
    DEP_FIELD(CATR0, RESERVED_31_21, 11, 21)
    DEP_FIELD(CATR0, CACD, 5, 16)
    DEP_FIELD(CATR0, RESERVED_15_13, 3, 13)
    DEP_FIELD(CATR0, CAADR, 5, 8)
    DEP_FIELD(CATR0, CA1BYTE1, 4, 4)
    DEP_FIELD(CATR0, CA1BYTE0, 4, 0)
DEP_REG32(CATR1, 0x244)
    DEP_FIELD(CATR1, RESERVED_31_28, 4, 28)
    DEP_FIELD(CATR1, CA0BYTE1, 4, 24)
    DEP_FIELD(CATR1, CA0BYTE0, 4, 20)
    DEP_FIELD(CATR1, CAMRZ, 4, 16)
    DEP_FIELD(CATR1, CACKEH, 4, 12)
    DEP_FIELD(CATR1, CACKEL, 4, 8)
    DEP_FIELD(CATR1, CAEXT, 4, 4)
    DEP_FIELD(CATR1, CAENT, 4, 0)
DEP_REG32(DQSDR0, 0x250)
    DEP_FIELD(DQSDR0, DFTDLY, 4, 28)
    DEP_FIELD(DQSDR0, DFTZQUP, 1, 27)
    DEP_FIELD(DQSDR0, DFTDDLUP, 1, 26)
    DEP_FIELD(DQSDR0, RESERVED_25_22, 4, 22)
    DEP_FIELD(DQSDR0, DFTRDSPC, 2, 20)
    DEP_FIELD(DQSDR0, DFTB2BRD, 4, 16)
    DEP_FIELD(DQSDR0, DFTIDLRD, 4, 12)
    DEP_FIELD(DQSDR0, RESERVED_11_8, 4, 8)
    DEP_FIELD(DQSDR0, DFTGPULSE, 4, 4)
    DEP_FIELD(DQSDR0, DFTUPMODE, 2, 2)
    DEP_FIELD(DQSDR0, DFTDTMODE, 1, 1)
    DEP_FIELD(DQSDR0, DFTDTEN, 1, 0)
DEP_REG32(DQSDR1, 0x254)
    DEP_FIELD(DQSDR1, RESERVED_31_24, 8, 24)
    DEP_FIELD(DQSDR1, DFTRDB2BF, 4, 20)
    DEP_FIELD(DQSDR1, DFTRDIDLF, 4, 16)
    DEP_FIELD(DQSDR1, DFTRDB2BC, 8, 8)
    DEP_FIELD(DQSDR1, DFTRDIDLC, 8, 0)
DEP_REG32(DQSDR2, 0x258)
    DEP_FIELD(DQSDR2, RESERVED_31_24, 8, 24)
    DEP_FIELD(DQSDR2, DFTTHRSH, 8, 16)
    DEP_FIELD(DQSDR2, DFTMNTPRD, 16, 0)
DEP_REG32(DCUAR, 0x300)
    DEP_FIELD(DCUAR, RESERVED_31_20, 12, 20)
    DEP_FIELD(DCUAR, CSADDR_R, 4, 16)
    DEP_FIELD(DCUAR, CWADDR_R, 4, 12)
    DEP_FIELD(DCUAR, ATYPE, 1, 11)
    DEP_FIELD(DCUAR, INCA, 1, 10)
    DEP_FIELD(DCUAR, CSEL, 2, 8)
    DEP_FIELD(DCUAR, CSADDR_W, 4, 4)
    DEP_FIELD(DCUAR, CWADDR_W, 4, 0)
DEP_REG32(DCUDR, 0x304)
DEP_REG32(DCURR, 0x308)
    DEP_FIELD(DCURR, RESERVED_31_24, 8, 24)
    DEP_FIELD(DCURR, XCEN, 1, 23)
    DEP_FIELD(DCURR, RCEN, 1, 22)
    DEP_FIELD(DCURR, SCOF, 1, 21)
    DEP_FIELD(DCURR, SONF, 1, 20)
    DEP_FIELD(DCURR, NFAIL, 8, 12)
    DEP_FIELD(DCURR, EADDR, 4, 8)
    DEP_FIELD(DCURR, SADDR, 4, 4)
    DEP_FIELD(DCURR, DINST, 4, 0)
DEP_REG32(DCULR, 0x30c)
    DEP_FIELD(DCULR, XLEADDR, 4, 28)
    DEP_FIELD(DCULR, RESERVED_27_18, 10, 18)
    DEP_FIELD(DCULR, IDA, 1, 17)
    DEP_FIELD(DCULR, LINF, 1, 16)
    DEP_FIELD(DCULR, LCNT, 8, 8)
    DEP_FIELD(DCULR, LEADDR, 4, 4)
    DEP_FIELD(DCULR, LSADDR, 4, 0)
DEP_REG32(DCUGCR, 0x310)
    DEP_FIELD(DCUGCR, RESERVED_31_16, 16, 16)
    DEP_FIELD(DCUGCR, RCSW, 16, 0)
DEP_REG32(DCUTPR, 0x314)
    DEP_FIELD(DCUTPR, TDCUT2, 16, 16)
    DEP_FIELD(DCUTPR, TDCUT1, 8, 8)
    DEP_FIELD(DCUTPR, TDCUT0, 8, 0)
DEP_REG32(DCUSR0, 0x318)
    DEP_FIELD(DCUSR0, RESERVED_31_3, 29, 3)
    DEP_FIELD(DCUSR0, CFULL, 1, 2)
    DEP_FIELD(DCUSR0, CFAIL, 1, 1)
    DEP_FIELD(DCUSR0, RDONE, 1, 0)
DEP_REG32(DCUSR1, 0x31c)
    DEP_FIELD(DCUSR1, LPCNT, 8, 24)
    DEP_FIELD(DCUSR1, FLCNT, 8, 16)
    DEP_FIELD(DCUSR1, RDCNT, 16, 0)
DEP_REG32(BISTRR, 0x400)
    DEP_FIELD(BISTRR, RESERVED_31_30, 2, 30)
    DEP_FIELD(BISTRR, BPRBST, 1, 29)
    DEP_FIELD(BISTRR, BSOMA, 1, 28)
    DEP_FIELD(BISTRR, BACDPAT, 2, 26)
    DEP_FIELD(BISTRR, BCCSEL, 1, 25)
    DEP_FIELD(BISTRR, BCKSEL, 2, 23)
    DEP_FIELD(BISTRR, BDXSEL, 4, 19)
    DEP_FIELD(BISTRR, BDXDPAT, 2, 17)
    DEP_FIELD(BISTRR, BDMEN, 1, 16)
    DEP_FIELD(BISTRR, BACEN, 1, 15)
    DEP_FIELD(BISTRR, BDXEN, 1, 14)
    DEP_FIELD(BISTRR, BSONF, 1, 13)
    DEP_FIELD(BISTRR, NFAIL, 8, 5)
    DEP_FIELD(BISTRR, BINF, 1, 4)
    DEP_FIELD(BISTRR, BMODE, 1, 3)
    DEP_FIELD(BISTRR, BINST, 3, 0)
DEP_REG32(BISTWCR, 0x404)
    DEP_FIELD(BISTWCR, BACWCNT, 16, 16)
    DEP_FIELD(BISTWCR, BDXWCNT, 16, 0)
DEP_REG32(BISTMSKR0, 0x408)
    DEP_FIELD(BISTMSKR0, CSMSK_RSVD, 10, 22)
    DEP_FIELD(BISTMSKR0, CSMSK, 2, 20)
    DEP_FIELD(BISTMSKR0, ACTMSK, 1, 19)
    DEP_FIELD(BISTMSKR0, RESERVED_18, 1, 18)
    DEP_FIELD(BISTMSKR0, AMSK, 18, 0)
DEP_REG32(BISTMSKR1, 0x40c)
    DEP_FIELD(BISTMSKR1, DMMSK, 4, 28)
    DEP_FIELD(BISTMSKR1, PARINMSK, 1, 27)
    DEP_FIELD(BISTMSKR1, CIDMSK_RSVD, 2, 25)
    DEP_FIELD(BISTMSKR1, CIDMSK, 1, 24)
    DEP_FIELD(BISTMSKR1, ODTMSK_RSVD, 6, 18)
    DEP_FIELD(BISTMSKR1, ODTMSK, 2, 16)
    DEP_FIELD(BISTMSKR1, CKEMSK_RSVD, 6, 10)
    DEP_FIELD(BISTMSKR1, CKEMSK, 2, 8)
    DEP_FIELD(BISTMSKR1, BAMSK, 4, 4)
    DEP_FIELD(BISTMSKR1, RESERVED_3_0, 4, 0)
DEP_REG32(BISTMSKR2, 0x410)
DEP_REG32(BISTLSR, 0x414)
DEP_REG32(BISTAR0, 0x418)
    DEP_FIELD(BISTAR0, BBANK, 4, 28)
    DEP_FIELD(BISTAR0, RESERVED_27_12, 16, 12)
    DEP_FIELD(BISTAR0, BCOL, 12, 0)
DEP_REG32(BISTAR1, 0x41c)
    DEP_FIELD(BISTAR1, RESERVED_31_20, 12, 20)
    DEP_FIELD(BISTAR1, BMRANK, 4, 16)
    DEP_FIELD(BISTAR1, BAINC, 12, 4)
    DEP_FIELD(BISTAR1, BRANK, 4, 0)
DEP_REG32(BISTAR2, 0x420)
    DEP_FIELD(BISTAR2, BMBANK, 4, 28)
    DEP_FIELD(BISTAR2, RESERVED_27_12, 16, 12)
    DEP_FIELD(BISTAR2, BMCOL, 12, 0)
DEP_REG32(BISTAR3, 0x424)
    DEP_FIELD(BISTAR3, RESERVED_31_18, 14, 18)
    DEP_FIELD(BISTAR3, BROW, 18, 0)
DEP_REG32(BISTAR4, 0x428)
    DEP_FIELD(BISTAR4, RESERVED_31_18, 14, 18)
    DEP_FIELD(BISTAR4, BMROW, 18, 0)
DEP_REG32(BISTUDPR, 0x42c)
    DEP_FIELD(BISTUDPR, BUDP1, 16, 16)
    DEP_FIELD(BISTUDPR, BUDP0, 16, 0)
DEP_REG32(BISTGSR, 0x430)
    DEP_FIELD(BISTGSR, RESERVED_31_30, 2, 30)
    DEP_FIELD(BISTGSR, RASBER, 2, 28)
    DEP_FIELD(BISTGSR, DMBER, 8, 20)
    DEP_FIELD(BISTGSR, RESERVED_19_12, 8, 12)
    DEP_FIELD(BISTGSR, RESERVED_11, 1, 11)
    DEP_FIELD(BISTGSR, BDXERR, 9, 2)
    DEP_FIELD(BISTGSR, BACERR, 1, 1)
    DEP_FIELD(BISTGSR, BDONE, 1, 0)
DEP_REG32(BISTWER0, 0x434)
    DEP_FIELD(BISTWER0, RESERVED_31_18, 14, 18)
    DEP_FIELD(BISTWER0, ACWER, 18, 0)
DEP_REG32(BISTWER1, 0x438)
    DEP_FIELD(BISTWER1, RESERVED_31_16, 16, 16)
    DEP_FIELD(BISTWER1, DXWER, 16, 0)
DEP_REG32(BISTBER0, 0x43c)
DEP_REG32(BISTBER1, 0x440)
    DEP_FIELD(BISTBER1, CSBER_RSVD, 20, 12)
    DEP_FIELD(BISTBER1, CSBER, 4, 8)
    DEP_FIELD(BISTBER1, BABER, 8, 0)
DEP_REG32(BISTBER2, 0x444)
DEP_REG32(BISTBER3, 0x448)
DEP_REG32(BISTBER4, 0x44c)
    DEP_FIELD(BISTBER4, RESERVED_31_14, 18, 14)
    DEP_FIELD(BISTBER4, CIDBER_RSVD, 4, 10)
    DEP_FIELD(BISTBER4, CIDBER, 2, 8)
    DEP_FIELD(BISTBER4, RESERVED_7_4, 4, 4)
    DEP_FIELD(BISTBER4, ABER, 4, 0)
DEP_REG32(BISTWCSR, 0x450)
    DEP_FIELD(BISTWCSR, DXWCNT, 16, 16)
    DEP_FIELD(BISTWCSR, ACWCNT, 16, 0)
DEP_REG32(BISTFWR0, 0x454)
    DEP_FIELD(BISTFWR0, CSWEBS_RSVD, 10, 22)
    DEP_FIELD(BISTFWR0, CSWEBS, 2, 20)
    DEP_FIELD(BISTFWR0, RESERVED_19, 1, 19)
    DEP_FIELD(BISTFWR0, ACTWEBS, 1, 18)
    DEP_FIELD(BISTFWR0, AWEBS, 18, 0)
DEP_REG32(BISTFWR1, 0x458)
    DEP_FIELD(BISTFWR1, DMWEBS, 4, 28)
    DEP_FIELD(BISTFWR1, RESERVED_27_24, 4, 24)
    DEP_FIELD(BISTFWR1, RESERVED_23_22, 1, 23)
    DEP_FIELD(BISTFWR1, CIDWEBS_RSVD, 2, 21)
    DEP_FIELD(BISTFWR1, CIDWEBS, 1, 20)
    DEP_FIELD(BISTFWR1, BAWEBS, 4, 16)
    DEP_FIELD(BISTFWR1, ODTWEBS_RSVD, 6, 10)
    DEP_FIELD(BISTFWR1, ODTWEBS, 2, 8)
    DEP_FIELD(BISTFWR1, CKEWEBS_RSVD, 6, 2)
    DEP_FIELD(BISTFWR1, CKEWEBS, 2, 0)
DEP_REG32(BISTFWR2, 0x45c)
DEP_REG32(BISTBER5, 0x460)
    DEP_FIELD(BISTBER5, ODTBER_RSVD, 12, 20)
    DEP_FIELD(BISTBER5, ODTBER, 4, 16)
    DEP_FIELD(BISTBER5, CKEBER_RSVD, 12, 4)
    DEP_FIELD(BISTBER5, CKEBER, 4, 0)
DEP_REG32(RANKIDR, 0x4dc)
    DEP_FIELD(RANKIDR, RESERVED_31_20, 12, 20)
    DEP_FIELD(RANKIDR, RANKRID, 4, 16)
    DEP_FIELD(RANKIDR, RESERVED_15_4, 12, 4)
    DEP_FIELD(RANKIDR, RANKWID, 4, 0)
DEP_REG32(RIOCR0, 0x4e0)
DEP_REG32(RIOCR1, 0x4e4)
DEP_REG32(RIOCR2, 0x4e8)
    DEP_FIELD(RIOCR2, RESERVED_31_30, 2, 30)
    DEP_FIELD(RIOCR2, COEMODE_RSVD, 4, 26)
    DEP_FIELD(RIOCR2, COEMODE, 2, 24)
    DEP_FIELD(RIOCR2, CSOEMODE_RSVD, 20, 4)
    DEP_FIELD(RIOCR2, CSOEMODE, 4, 0)
DEP_REG32(RIOCR3, 0x4ec)
DEP_REG32(RIOCR4, 0x4f0)
    DEP_FIELD(RIOCR4, RESERVED_31_16, 16, 16)
    DEP_FIELD(RIOCR4, CKEOEMODE_RSVD, 12, 4)
    DEP_FIELD(RIOCR4, CKEOEMODE, 4, 0)
DEP_REG32(RIOCR5, 0x4f4)
    DEP_FIELD(RIOCR5, RESERVED_31_16, 16, 16)
    DEP_FIELD(RIOCR5, ODTOEMODE_RSVD, 12, 4)
    DEP_FIELD(RIOCR5, ODTOEMODE, 4, 0)
DEP_REG32(ACIOCR0, 0x500)
    DEP_FIELD(ACIOCR0, ACSR, 2, 30)
    DEP_FIELD(ACIOCR0, RSTIOM, 1, 29)
    DEP_FIELD(ACIOCR0, RSTPDR, 1, 28)
    DEP_FIELD(ACIOCR0, RESERVED_27, 1, 27)
    DEP_FIELD(ACIOCR0, RSTODT, 1, 26)
    DEP_FIELD(ACIOCR0, RESERVED_25_10, 16, 10)
    DEP_FIELD(ACIOCR0, CKDCC, 4, 6)
    DEP_FIELD(ACIOCR0, ACPDRMODE, 2, 4)
    DEP_FIELD(ACIOCR0, ACODTMODE, 2, 2)
    DEP_FIELD(ACIOCR0, RESERVED_1, 1, 1)
    DEP_FIELD(ACIOCR0, ACRANKCLKSEL, 1, 0)
DEP_REG32(ACIOCR1, 0x504)
DEP_REG32(ACIOCR2, 0x508)
    DEP_FIELD(ACIOCR2, CLKGENCLKGATE, 1, 31)
    DEP_FIELD(ACIOCR2, ACOECLKGATE0, 1, 30)
    DEP_FIELD(ACIOCR2, ACPDRCLKGATE0, 1, 29)
    DEP_FIELD(ACIOCR2, ACTECLKGATE0, 1, 28)
    DEP_FIELD(ACIOCR2, CKNCLKGATE0, 2, 26)
    DEP_FIELD(ACIOCR2, CKCLKGATE0, 2, 24)
    DEP_FIELD(ACIOCR2, ACCLKGATE0, 24, 0)
DEP_REG32(ACIOCR3, 0x50c)
    DEP_FIELD(ACIOCR3, PAROEMODE, 2, 30)
    DEP_FIELD(ACIOCR3, BGOEMODE, 4, 26)
    DEP_FIELD(ACIOCR3, BAOEMODE, 4, 22)
    DEP_FIELD(ACIOCR3, A17OEMODE, 2, 20)
    DEP_FIELD(ACIOCR3, A16OEMODE, 2, 18)
    DEP_FIELD(ACIOCR3, ACTOEMODE, 2, 16)
    DEP_FIELD(ACIOCR3, RESERVED_15_8, 8, 8)
    DEP_FIELD(ACIOCR3, CKOEMODE_RSVD, 4, 4)
    DEP_FIELD(ACIOCR3, CKOEMODE, 4, 0)
DEP_REG32(ACIOCR4, 0x510)
    DEP_FIELD(ACIOCR4, LBCLKGATE, 1, 31)
    DEP_FIELD(ACIOCR4, ACOECLKGATE1, 1, 30)
    DEP_FIELD(ACIOCR4, ACPDRCLKGATE1, 1, 29)
    DEP_FIELD(ACIOCR4, ACTECLKGATE1, 1, 28)
    DEP_FIELD(ACIOCR4, CKNCLKGATE1, 2, 26)
    DEP_FIELD(ACIOCR4, CKCLKGATE1, 2, 24)
    DEP_FIELD(ACIOCR4, ACCLKGATE1, 24, 0)
DEP_REG32(ACIOCR5, 0x514)
    DEP_FIELD(ACIOCR5, RESERVED_31_28, 4, 28)
    DEP_FIELD(ACIOCR5, ACVREFIOM, 3, 25)
    DEP_FIELD(ACIOCR5, ACXIOM, 3, 22)
    DEP_FIELD(ACIOCR5, ACTXM, 11, 11)
    DEP_FIELD(ACIOCR5, ACRXM, 11, 0)
DEP_REG32(IOVCR0, 0x520)
    DEP_FIELD(IOVCR0, RESERVED_31_29, 3, 29)
    DEP_FIELD(IOVCR0, ACREFPEN, 1, 28)
    DEP_FIELD(IOVCR0, ACREFEEN, 2, 26)
    DEP_FIELD(IOVCR0, ACREFSEN, 1, 25)
    DEP_FIELD(IOVCR0, ACREFIEN, 1, 24)
    DEP_FIELD(IOVCR0, ACREFESELRANGE, 1, 23)
    DEP_FIELD(IOVCR0, ACREFESEL, 7, 16)
    DEP_FIELD(IOVCR0, ACREFSSELRANGE, 1, 15)
    DEP_FIELD(IOVCR0, ACREFSSEL, 7, 8)
    DEP_FIELD(IOVCR0, ACVREFISELRANGE, 1, 7)
    DEP_FIELD(IOVCR0, ACVREFISEL, 7, 0)
DEP_REG32(IOVCR1, 0x524)
DEP_REG32(VTCR0, 0x528)
    DEP_FIELD(VTCR0, TVREF, 3, 29)
    DEP_FIELD(VTCR0, DVEN, 1, 28)
    DEP_FIELD(VTCR0, PDAEN, 1, 27)
    DEP_FIELD(VTCR0, RESERVED_26, 1, 26)
    DEP_FIELD(VTCR0, VWCR, 4, 22)
    DEP_FIELD(VTCR0, DVSS, 4, 18)
    DEP_FIELD(VTCR0, DVMAX, 6, 12)
    DEP_FIELD(VTCR0, DVMIN, 6, 6)
    DEP_FIELD(VTCR0, DVINIT, 6, 0)
DEP_REG32(VTCR1, 0x52c)
    DEP_FIELD(VTCR1, HVSS, 4, 28)
    DEP_FIELD(VTCR1, RESERVED_27, 1, 27)
    DEP_FIELD(VTCR1, HVMAX, 7, 20)
    DEP_FIELD(VTCR1, RESERVED_19, 1, 19)
    DEP_FIELD(VTCR1, HVMIN, 7, 12)
    DEP_FIELD(VTCR1, RESERVED_11, 1, 11)
    DEP_FIELD(VTCR1, SHRNK, 2, 9)
    DEP_FIELD(VTCR1, SHREN, 1, 8)
    DEP_FIELD(VTCR1, TVREFIO, 3, 5)
    DEP_FIELD(VTCR1, EOFF, 2, 3)
    DEP_FIELD(VTCR1, ENUM, 1, 2)
    DEP_FIELD(VTCR1, HVEN, 1, 1)
    DEP_FIELD(VTCR1, HVIO, 1, 0)
DEP_REG32(ACBDLR0, 0x540)
    DEP_FIELD(ACBDLR0, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR0, CK3BD, 6, 24)
    DEP_FIELD(ACBDLR0, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR0, CK2BD, 6, 16)
    DEP_FIELD(ACBDLR0, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR0, CK1BD, 6, 8)
    DEP_FIELD(ACBDLR0, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR0, CK0BD, 6, 0)
DEP_REG32(ACBDLR1, 0x544)
    DEP_FIELD(ACBDLR1, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR1, PARBD, 6, 24)
    DEP_FIELD(ACBDLR1, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR1, A16BD, 6, 16)
    DEP_FIELD(ACBDLR1, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR1, A17BD, 6, 8)
    DEP_FIELD(ACBDLR1, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR1, ACTBD, 6, 0)
DEP_REG32(ACBDLR2, 0x548)
    DEP_FIELD(ACBDLR2, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR2, BG1BD, 6, 24)
    DEP_FIELD(ACBDLR2, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR2, BG0BD, 6, 16)
    DEP_FIELD(ACBDLR2, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR2, BA1BD, 6, 8)
    DEP_FIELD(ACBDLR2, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR2, BA0BD, 6, 0)
DEP_REG32(ACBDLR3, 0x54c)
    DEP_FIELD(ACBDLR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR3, CS3BD, 6, 24)
    DEP_FIELD(ACBDLR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR3, CS2BD, 6, 16)
    DEP_FIELD(ACBDLR3, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR3, CS1BD, 6, 8)
    DEP_FIELD(ACBDLR3, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR3, CS0BD, 6, 0)
DEP_REG32(ACBDLR4, 0x550)
    DEP_FIELD(ACBDLR4, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR4, ODT3BD, 6, 24)
    DEP_FIELD(ACBDLR4, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR4, ODT2BD, 6, 16)
    DEP_FIELD(ACBDLR4, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR4, ODT1BD, 6, 8)
    DEP_FIELD(ACBDLR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR4, ODT0BD, 6, 0)
DEP_REG32(ACBDLR5, 0x554)
    DEP_FIELD(ACBDLR5, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR5, CKE3BD, 6, 24)
    DEP_FIELD(ACBDLR5, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR5, CKE2BD, 6, 16)
    DEP_FIELD(ACBDLR5, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR5, CKE1BD, 6, 8)
    DEP_FIELD(ACBDLR5, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR5, CKE0BD, 6, 0)
DEP_REG32(ACBDLR6, 0x558)
    DEP_FIELD(ACBDLR6, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR6, A03BD, 6, 24)
    DEP_FIELD(ACBDLR6, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR6, A02BD, 6, 16)
    DEP_FIELD(ACBDLR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR6, A01BD, 6, 8)
    DEP_FIELD(ACBDLR6, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR6, A00BD, 6, 0)
DEP_REG32(ACBDLR7, 0x55c)
    DEP_FIELD(ACBDLR7, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR7, A07BD, 6, 24)
    DEP_FIELD(ACBDLR7, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR7, A06BD, 6, 16)
    DEP_FIELD(ACBDLR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR7, A05BD, 6, 8)
    DEP_FIELD(ACBDLR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR7, A04BD, 6, 0)
DEP_REG32(ACBDLR8, 0x560)
    DEP_FIELD(ACBDLR8, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR8, A11BD, 6, 24)
    DEP_FIELD(ACBDLR8, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR8, A10BD, 6, 16)
    DEP_FIELD(ACBDLR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR8, A09BD, 6, 8)
    DEP_FIELD(ACBDLR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR8, A08BD, 6, 0)
DEP_REG32(ACBDLR9, 0x564)
    DEP_FIELD(ACBDLR9, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR9, A15BD, 6, 24)
    DEP_FIELD(ACBDLR9, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR9, A14BD, 6, 16)
    DEP_FIELD(ACBDLR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR9, A13BD, 6, 8)
    DEP_FIELD(ACBDLR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR9, A12BD, 6, 0)
DEP_REG32(ACBDLR10, 0x568)
    DEP_FIELD(ACBDLR10, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR10, CID2BD, 6, 24)
    DEP_FIELD(ACBDLR10, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR10, CID1BD, 6, 16)
    DEP_FIELD(ACBDLR10, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR10, CID0BD, 6, 8)
    DEP_FIELD(ACBDLR10, RESERVED_7_0, 8, 0)
DEP_REG32(ACBDLR11, 0x56c)
    DEP_FIELD(ACBDLR11, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR11, CS7BD, 6, 24)
    DEP_FIELD(ACBDLR11, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR11, CS6BD, 6, 16)
    DEP_FIELD(ACBDLR11, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR11, CS5BD, 6, 8)
    DEP_FIELD(ACBDLR11, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR11, CS4BD, 6, 0)
DEP_REG32(ACBDLR12, 0x570)
    DEP_FIELD(ACBDLR12, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR12, CS11BD, 6, 24)
    DEP_FIELD(ACBDLR12, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR12, CS10BD, 6, 16)
    DEP_FIELD(ACBDLR12, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR12, CS9BD, 6, 8)
    DEP_FIELD(ACBDLR12, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR12, CS8BD, 6, 0)
DEP_REG32(ACBDLR13, 0x574)
    DEP_FIELD(ACBDLR13, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR13, ODT7BD, 6, 24)
    DEP_FIELD(ACBDLR13, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR13, ODT6BD, 6, 16)
    DEP_FIELD(ACBDLR13, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR13, ODT5BD, 6, 8)
    DEP_FIELD(ACBDLR13, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR13, ODT4BD, 6, 0)
DEP_REG32(ACBDLR14, 0x578)
    DEP_FIELD(ACBDLR14, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR14, CKE7BD, 6, 24)
    DEP_FIELD(ACBDLR14, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR14, CKE6BD, 6, 16)
    DEP_FIELD(ACBDLR14, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR14, CKE5BD, 6, 8)
    DEP_FIELD(ACBDLR14, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR14, CKE4BD, 6, 0)
DEP_REG32(ACBDLR15, 0x57c)
    DEP_FIELD(ACBDLR15, RESERVED_31_22, 10, 22)
    DEP_FIELD(ACBDLR15, OEBD, 6, 16)
    DEP_FIELD(ACBDLR15, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR15, TEBD, 6, 8)
    DEP_FIELD(ACBDLR15, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR15, PDRBD, 6, 0)
DEP_REG32(ACBDLR16, 0x580)
    DEP_FIELD(ACBDLR16, RESERVED_31_30, 2, 30)
    DEP_FIELD(ACBDLR16, CKN3BD, 6, 24)
    DEP_FIELD(ACBDLR16, RESERVED_23_22, 2, 22)
    DEP_FIELD(ACBDLR16, CKN2BD, 6, 16)
    DEP_FIELD(ACBDLR16, RESERVED_15_14, 2, 14)
    DEP_FIELD(ACBDLR16, CKN1BD, 6, 8)
    DEP_FIELD(ACBDLR16, RESERVED_7_6, 2, 6)
    DEP_FIELD(ACBDLR16, CKN0BD, 6, 0)
DEP_REG32(ACLCDLR, 0x584)
    DEP_FIELD(ACLCDLR, RESERVED_31_25, 7, 25)
    DEP_FIELD(ACLCDLR, ACD1, 9, 16)
    DEP_FIELD(ACLCDLR, RESERVED_15_9, 7, 9)
    DEP_FIELD(ACLCDLR, ACD, 9, 0)
DEP_REG32(ACMDLR0, 0x5a0)
    DEP_FIELD(ACMDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(ACMDLR0, TPRD, 9, 16)
    DEP_FIELD(ACMDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(ACMDLR0, IPRD, 9, 0)
DEP_REG32(ACMDLR1, 0x5a4)
    DEP_FIELD(ACMDLR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(ACMDLR1, MDLD1, 9, 16)
    DEP_FIELD(ACMDLR1, RESERVED_15_9, 7, 9)
    DEP_FIELD(ACMDLR1, MDLD, 9, 0)
DEP_REG32(ZQCR, 0x680)
    DEP_FIELD(ZQCR, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQCR, ZQREFISELRANGE, 1, 25)
    DEP_FIELD(ZQCR, PGWAIT_FRQB, 6, 19)
    DEP_FIELD(ZQCR, PGWAIT_FRQA, 6, 13)
    DEP_FIELD(ZQCR, ZQREFPEN, 1, 12)
    DEP_FIELD(ZQCR, ZQREFIEN, 1, 11)
    DEP_FIELD(ZQCR, ODT_MODE, 2, 9)
    DEP_FIELD(ZQCR, FORCE_ZCAL_VT_UPDATE, 1, 8)
    DEP_FIELD(ZQCR, IODLMT, 3, 5)
    DEP_FIELD(ZQCR, AVGEN, 1, 4)
    DEP_FIELD(ZQCR, AVGMAX, 2, 2)
    DEP_FIELD(ZQCR, ZCALT, 1, 1)
    DEP_FIELD(ZQCR, ZQPD, 1, 0)
DEP_REG32(ZQ0PR0, 0x684)
    DEP_FIELD(ZQ0PR0, PD_DRV_ZDEN, 1, 31)
    DEP_FIELD(ZQ0PR0, PU_DRV_ZDEN, 1, 30)
    DEP_FIELD(ZQ0PR0, PD_ODT_ZDEN, 1, 29)
    DEP_FIELD(ZQ0PR0, PU_ODT_ZDEN, 1, 28)
    DEP_FIELD(ZQ0PR0, ZSEGBYP, 1, 27)
    DEP_FIELD(ZQ0PR0, ZLE_MODE, 2, 25)
    DEP_FIELD(ZQ0PR0, ODT_ADJUST, 3, 22)
    DEP_FIELD(ZQ0PR0, PD_DRV_ADJUST, 3, 19)
    DEP_FIELD(ZQ0PR0, PU_DRV_ADJUST, 3, 16)
    DEP_FIELD(ZQ0PR0, ZPROG_DRAM_ODT, 4, 12)
    DEP_FIELD(ZQ0PR0, ZPROG_HOST_ODT, 4, 8)
    DEP_FIELD(ZQ0PR0, ZPROG_ASYM_DRV_PD, 4, 4)
    DEP_FIELD(ZQ0PR0, ZPROG_ASYM_DRV_PU, 4, 0)
DEP_REG32(ZQ0PR1, 0x688)
    DEP_FIELD(ZQ0PR1, RESERVED_31_15, 17, 15)
    DEP_FIELD(ZQ0PR1, PU_REFSEL, 7, 8)
    DEP_FIELD(ZQ0PR1, RESERVED_7, 1, 7)
    DEP_FIELD(ZQ0PR1, PD_REFSEL, 7, 0)
DEP_REG32(ZQ0DR0, 0x68c)
    DEP_FIELD(ZQ0DR0, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ0DR0, ZDATA_PU_DRV_RESULT, 10, 16)
    DEP_FIELD(ZQ0DR0, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ0DR0, ZDATA_PD_DRV_RESULT, 10, 0)
DEP_REG32(ZQ0DR1, 0x690)
    DEP_FIELD(ZQ0DR1, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ0DR1, ZDATA_PU_ODT_RESULT, 10, 16)
    DEP_FIELD(ZQ0DR1, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ0DR1, ZDATA_PD_ODT_RESULT, 10, 0)
DEP_REG32(ZQ0OR0, 0x694)
    DEP_FIELD(ZQ0OR0, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ0OR0, ZDATA_PU_DRV_OVRD, 10, 16)
    DEP_FIELD(ZQ0OR0, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ0OR0, ZDATA_PD_DRV_OVRD, 10, 0)
DEP_REG32(ZQ0OR1, 0x698)
    DEP_FIELD(ZQ0OR1, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ0OR1, ZDATA_PU_ODT_OVRD, 10, 16)
    DEP_FIELD(ZQ0OR1, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ0OR1, ZDATA_PD_ODT_OVRD, 10, 0)
DEP_REG32(ZQ0SR, 0x69c)
    DEP_FIELD(ZQ0SR, RESERVED_31_14, 18, 14)
    DEP_FIELD(ZQ0SR, PD_ODT_SAT, 1, 13)
    DEP_FIELD(ZQ0SR, PU_ODT_SAT, 1, 12)
    DEP_FIELD(ZQ0SR, PD_DRV_SAT, 1, 11)
    DEP_FIELD(ZQ0SR, PU_DRV_SAT, 1, 10)
    DEP_FIELD(ZQ0SR, ZDONE, 1, 9)
    DEP_FIELD(ZQ0SR, ZERR, 1, 8)
    DEP_FIELD(ZQ0SR, OPU, 2, 6)
    DEP_FIELD(ZQ0SR, OPD, 2, 4)
    DEP_FIELD(ZQ0SR, ZPU, 2, 2)
    DEP_FIELD(ZQ0SR, ZPD, 2, 0)
DEP_REG32(ZQ1PR0, 0x6a4)
    DEP_FIELD(ZQ1PR0, PD_DRV_ZDEN, 1, 31)
    DEP_FIELD(ZQ1PR0, PU_DRV_ZDEN, 1, 30)
    DEP_FIELD(ZQ1PR0, PD_ODT_ZDEN, 1, 29)
    DEP_FIELD(ZQ1PR0, PU_ODT_ZDEN, 1, 28)
    DEP_FIELD(ZQ1PR0, ZSEGBYP, 1, 27)
    DEP_FIELD(ZQ1PR0, ZLE_MODE, 2, 25)
    DEP_FIELD(ZQ1PR0, ODT_ADJUST, 3, 22)
    DEP_FIELD(ZQ1PR0, PD_DRV_ADJUST, 3, 19)
    DEP_FIELD(ZQ1PR0, PU_DRV_ADJUST, 3, 16)
    DEP_FIELD(ZQ1PR0, ZPROG_DRAM_ODT, 4, 12)
    DEP_FIELD(ZQ1PR0, ZPROG_HOST_ODT, 4, 8)
    DEP_FIELD(ZQ1PR0, ZPROG_ASYM_DRV_PD, 4, 4)
    DEP_FIELD(ZQ1PR0, ZPROG_ASYM_DRV_PU, 4, 0)
DEP_REG32(ZQ1PR1, 0x6a8)
    DEP_FIELD(ZQ1PR1, RESERVED_31_15, 17, 15)
    DEP_FIELD(ZQ1PR1, PU_REFSEL, 7, 8)
    DEP_FIELD(ZQ1PR1, RESERVED_7, 1, 7)
    DEP_FIELD(ZQ1PR1, PD_REFSEL, 7, 0)
DEP_REG32(ZQ1DR0, 0x6ac)
    DEP_FIELD(ZQ1DR0, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ1DR0, ZDATA_PU_DRV_RESULT, 10, 16)
    DEP_FIELD(ZQ1DR0, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ1DR0, ZDATA_PD_DRV_RESULT, 10, 0)
DEP_REG32(ZQ1DR1, 0x6b0)
    DEP_FIELD(ZQ1DR1, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ1DR1, ZDATA_PU_ODT_RESULT, 10, 16)
    DEP_FIELD(ZQ1DR1, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ1DR1, ZDATA_PD_ODT_RESULT, 10, 0)
DEP_REG32(ZQ1OR0, 0x6b4)
    DEP_FIELD(ZQ1OR0, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ1OR0, ZDATA_PU_DRV_OVRD, 10, 16)
    DEP_FIELD(ZQ1OR0, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ1OR0, ZDATA_PD_DRV_OVRD, 10, 0)
DEP_REG32(ZQ1OR1, 0x6b8)
    DEP_FIELD(ZQ1OR1, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ1OR1, ZDATA_PU_ODT_OVRD, 10, 16)
    DEP_FIELD(ZQ1OR1, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ1OR1, ZDATA_PD_ODT_OVRD, 10, 0)
DEP_REG32(ZQ1SR, 0x6bc)
    DEP_FIELD(ZQ1SR, RESERVED_31_14, 18, 14)
    DEP_FIELD(ZQ1SR, PD_ODT_SAT, 1, 13)
    DEP_FIELD(ZQ1SR, PU_ODT_SAT, 1, 12)
    DEP_FIELD(ZQ1SR, PD_DRV_SAT, 1, 11)
    DEP_FIELD(ZQ1SR, PU_DRV_SAT, 1, 10)
    DEP_FIELD(ZQ1SR, ZDONE, 1, 9)
    DEP_FIELD(ZQ1SR, ZERR, 1, 8)
    DEP_FIELD(ZQ1SR, OPU, 2, 6)
    DEP_FIELD(ZQ1SR, OPD, 2, 4)
    DEP_FIELD(ZQ1SR, ZPU, 2, 2)
    DEP_FIELD(ZQ1SR, ZPD, 2, 0)
DEP_REG32(ZQ2PR0, 0x6c4)
    DEP_FIELD(ZQ2PR0, PD_DRV_ZDEN, 1, 31)
    DEP_FIELD(ZQ2PR0, PU_DRV_ZDEN, 1, 30)
    DEP_FIELD(ZQ2PR0, PD_ODT_ZDEN, 1, 29)
    DEP_FIELD(ZQ2PR0, PU_ODT_ZDEN, 1, 28)
    DEP_FIELD(ZQ2PR0, ZSEGBYP, 1, 27)
    DEP_FIELD(ZQ2PR0, ZLE_MODE, 2, 25)
    DEP_FIELD(ZQ2PR0, ODT_ADJUST, 3, 22)
    DEP_FIELD(ZQ2PR0, PD_DRV_ADJUST, 3, 19)
    DEP_FIELD(ZQ2PR0, PU_DRV_ADJUST, 3, 16)
    DEP_FIELD(ZQ2PR0, ZPROG_DRAM_ODT, 4, 12)
    DEP_FIELD(ZQ2PR0, ZPROG_HOST_ODT, 4, 8)
    DEP_FIELD(ZQ2PR0, ZPROG_ASYM_DRV_PD, 4, 4)
    DEP_FIELD(ZQ2PR0, ZPROG_ASYM_DRV_PU, 4, 0)
DEP_REG32(ZQ2PR1, 0x6c8)
    DEP_FIELD(ZQ2PR1, RESERVED_31_15, 17, 15)
    DEP_FIELD(ZQ2PR1, PU_REFSEL, 7, 8)
    DEP_FIELD(ZQ2PR1, RESERVED_7, 1, 7)
    DEP_FIELD(ZQ2PR1, PD_REFSEL, 7, 0)
DEP_REG32(ZQ2DR0, 0x6cc)
    DEP_FIELD(ZQ2DR0, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ2DR0, ZDATA_PU_DRV_RESULT, 10, 16)
    DEP_FIELD(ZQ2DR0, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ2DR0, ZDATA_PD_DRV_RESULT, 10, 0)
DEP_REG32(ZQ2DR1, 0x6d0)
    DEP_FIELD(ZQ2DR1, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ2DR1, ZDATA_PU_ODT_RESULT, 10, 16)
    DEP_FIELD(ZQ2DR1, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ2DR1, ZDATA_PD_ODT_RESULT, 10, 0)
DEP_REG32(ZQ2OR0, 0x6d4)
    DEP_FIELD(ZQ2OR0, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ2OR0, ZDATA_PU_DRV_OVRD, 10, 16)
    DEP_FIELD(ZQ2OR0, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ2OR0, ZDATA_PD_DRV_OVRD, 10, 0)
DEP_REG32(ZQ2OR1, 0x6d8)
    DEP_FIELD(ZQ2OR1, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ2OR1, ZDATA_PU_ODT_OVRD, 10, 16)
    DEP_FIELD(ZQ2OR1, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ2OR1, ZDATA_PD_ODT_OVRD, 10, 0)
DEP_REG32(ZQ2SR, 0x6dc)
    DEP_FIELD(ZQ2SR, RESERVED_31_14, 18, 14)
    DEP_FIELD(ZQ2SR, PD_ODT_SAT, 1, 13)
    DEP_FIELD(ZQ2SR, PU_ODT_SAT, 1, 12)
    DEP_FIELD(ZQ2SR, PD_DRV_SAT, 1, 11)
    DEP_FIELD(ZQ2SR, PU_DRV_SAT, 1, 10)
    DEP_FIELD(ZQ2SR, ZDONE, 1, 9)
    DEP_FIELD(ZQ2SR, ZERR, 1, 8)
    DEP_FIELD(ZQ2SR, OPU, 2, 6)
    DEP_FIELD(ZQ2SR, OPD, 2, 4)
    DEP_FIELD(ZQ2SR, ZPU, 2, 2)
    DEP_FIELD(ZQ2SR, ZPD, 2, 0)
DEP_REG32(ZQ3PR0, 0x6e4)
    DEP_FIELD(ZQ3PR0, PD_DRV_ZDEN, 1, 31)
    DEP_FIELD(ZQ3PR0, PU_DRV_ZDEN, 1, 30)
    DEP_FIELD(ZQ3PR0, PD_ODT_ZDEN, 1, 29)
    DEP_FIELD(ZQ3PR0, PU_ODT_ZDEN, 1, 28)
    DEP_FIELD(ZQ3PR0, ZSEGBYP, 1, 27)
    DEP_FIELD(ZQ3PR0, ZLE_MODE, 2, 25)
    DEP_FIELD(ZQ3PR0, ODT_ADJUST, 3, 22)
    DEP_FIELD(ZQ3PR0, PD_DRV_ADJUST, 3, 19)
    DEP_FIELD(ZQ3PR0, PU_DRV_ADJUST, 3, 16)
    DEP_FIELD(ZQ3PR0, ZPROG_DRAM_ODT, 4, 12)
    DEP_FIELD(ZQ3PR0, ZPROG_HOST_ODT, 4, 8)
    DEP_FIELD(ZQ3PR0, ZPROG_ASYM_DRV_PD, 4, 4)
    DEP_FIELD(ZQ3PR0, ZPROG_ASYM_DRV_PU, 4, 0)
DEP_REG32(ZQ3PR1, 0x6e8)
    DEP_FIELD(ZQ3PR1, RESERVED_31_15, 17, 15)
    DEP_FIELD(ZQ3PR1, PU_REFSEL, 7, 8)
    DEP_FIELD(ZQ3PR1, RESERVED_7, 1, 7)
    DEP_FIELD(ZQ3PR1, PD_REFSEL, 7, 0)
DEP_REG32(ZQ3DR0, 0x6ec)
    DEP_FIELD(ZQ3DR0, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ3DR0, ZDATA_PU_DRV_RESULT, 10, 16)
    DEP_FIELD(ZQ3DR0, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ3DR0, ZDATA_PD_DRV_RESULT, 10, 0)
DEP_REG32(ZQ3DR1, 0x6f0)
    DEP_FIELD(ZQ3DR1, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ3DR1, ZDATA_PU_ODT_RESULT, 10, 16)
    DEP_FIELD(ZQ3DR1, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ3DR1, ZDATA_PD_ODT_RESULT, 10, 0)
DEP_REG32(ZQ3OR0, 0x6f4)
    DEP_FIELD(ZQ3OR0, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ3OR0, ZDATA_PU_DRV_OVRD, 10, 16)
    DEP_FIELD(ZQ3OR0, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ3OR0, ZDATA_PD_DRV_OVRD, 10, 0)
DEP_REG32(ZQ3OR1, 0x6f8)
    DEP_FIELD(ZQ3OR1, RESERVED_31_26, 6, 26)
    DEP_FIELD(ZQ3OR1, ZDATA_PU_ODT_OVRD, 10, 16)
    DEP_FIELD(ZQ3OR1, RESERVED_15_10, 6, 10)
    DEP_FIELD(ZQ3OR1, ZDATA_PD_ODT_OVRD, 10, 0)
DEP_REG32(ZQ3SR, 0x6fc)
    DEP_FIELD(ZQ3SR, RESERVED_31_14, 18, 14)
    DEP_FIELD(ZQ3SR, PD_ODT_SAT, 1, 13)
    DEP_FIELD(ZQ3SR, PU_ODT_SAT, 1, 12)
    DEP_FIELD(ZQ3SR, PD_DRV_SAT, 1, 11)
    DEP_FIELD(ZQ3SR, PU_DRV_SAT, 1, 10)
    DEP_FIELD(ZQ3SR, ZDONE, 1, 9)
    DEP_FIELD(ZQ3SR, ZERR, 1, 8)
    DEP_FIELD(ZQ3SR, OPU, 2, 6)
    DEP_FIELD(ZQ3SR, OPD, 2, 4)
    DEP_FIELD(ZQ3SR, ZPU, 2, 2)
    DEP_FIELD(ZQ3SR, ZPD, 2, 0)
DEP_REG32(DX0GCR0, 0x700)
    DEP_FIELD(DX0GCR0, CALBYP, 1, 31)
    DEP_FIELD(DX0GCR0, MDLEN, 1, 30)
    DEP_FIELD(DX0GCR0, CODTSHFT, 2, 28)
    DEP_FIELD(DX0GCR0, DQSDCC, 4, 24)
    DEP_FIELD(DX0GCR0, RDDLY, 4, 20)
    DEP_FIELD(DX0GCR0, RESERVED_19_14, 6, 14)
    DEP_FIELD(DX0GCR0, DQSNSEPDR, 1, 13)
    DEP_FIELD(DX0GCR0, DQSSEPDR, 1, 12)
    DEP_FIELD(DX0GCR0, RTTOAL, 1, 11)
    DEP_FIELD(DX0GCR0, RTTOH, 2, 9)
    DEP_FIELD(DX0GCR0, CPDRSHFT, 2, 7)
    DEP_FIELD(DX0GCR0, DQSRPD, 1, 6)
    DEP_FIELD(DX0GCR0, DQSGPDR, 1, 5)
    DEP_FIELD(DX0GCR0, RESERVED_4, 1, 4)
    DEP_FIELD(DX0GCR0, DQSGODT, 1, 3)
    DEP_FIELD(DX0GCR0, DQSGOE, 1, 2)
    DEP_FIELD(DX0GCR0, RESERVED_1_0, 2, 0)
DEP_REG32(DX0GCR1, 0x704)
    DEP_FIELD(DX0GCR1, DXPDRMODE, 16, 16)
    DEP_FIELD(DX0GCR1, RESERVED_15, 1, 15)
    DEP_FIELD(DX0GCR1, QSNSEL, 1, 14)
    DEP_FIELD(DX0GCR1, QSSEL, 1, 13)
    DEP_FIELD(DX0GCR1, OEEN, 1, 12)
    DEP_FIELD(DX0GCR1, PDREN, 1, 11)
    DEP_FIELD(DX0GCR1, TEEN, 1, 10)
    DEP_FIELD(DX0GCR1, DSEN, 1, 9)
    DEP_FIELD(DX0GCR1, DMEN, 1, 8)
    DEP_FIELD(DX0GCR1, DQEN, 8, 0)
DEP_REG32(DX0GCR2, 0x708)
    DEP_FIELD(DX0GCR2, DXOEMODE, 16, 16)
    DEP_FIELD(DX0GCR2, DXTEMODE, 16, 0)
DEP_REG32(DX0GCR3, 0x70c)
    DEP_FIELD(DX0GCR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX0GCR3, RDBVT, 1, 29)
    DEP_FIELD(DX0GCR3, WDBVT, 1, 28)
    DEP_FIELD(DX0GCR3, RGLVT, 1, 27)
    DEP_FIELD(DX0GCR3, RDLVT, 1, 26)
    DEP_FIELD(DX0GCR3, WDLVT, 1, 25)
    DEP_FIELD(DX0GCR3, WLLVT, 1, 24)
    DEP_FIELD(DX0GCR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX0GCR3, DSNOEMODE, 2, 20)
    DEP_FIELD(DX0GCR3, DSNTEMODE, 2, 18)
    DEP_FIELD(DX0GCR3, DSNPDRMODE, 2, 16)
    DEP_FIELD(DX0GCR3, DMOEMODE, 2, 14)
    DEP_FIELD(DX0GCR3, DMTEMODE, 2, 12)
    DEP_FIELD(DX0GCR3, DMPDRMODE, 2, 10)
    DEP_FIELD(DX0GCR3, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX0GCR3, DSOEMODE, 2, 6)
    DEP_FIELD(DX0GCR3, DSTEMODE, 2, 4)
    DEP_FIELD(DX0GCR3, DSPDRMODE, 2, 2)
    DEP_FIELD(DX0GCR3, RESERVED_1_0, 2, 0)
DEP_REG32(DX0GCR4, 0x710)
    DEP_FIELD(DX0GCR4, RESERVED_31_29, 3, 29)
    DEP_FIELD(DX0GCR4, DXREFPEN, 1, 28)
    DEP_FIELD(DX0GCR4, DXREFEEN, 2, 26)
    DEP_FIELD(DX0GCR4, DXREFSEN, 1, 25)
    DEP_FIELD(DX0GCR4, RESERVED_24, 1, 24)
    DEP_FIELD(DX0GCR4, DXREFESELRANGE, 1, 23)
    DEP_FIELD(DX0GCR4, DXREFESEL, 7, 16)
    DEP_FIELD(DX0GCR4, DXREFSSELRANGE, 1, 15)
    DEP_FIELD(DX0GCR4, DXREFSSEL, 7, 8)
    DEP_FIELD(DX0GCR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX0GCR4, DXREFIEN, 4, 2)
    DEP_FIELD(DX0GCR4, DXREFIMON, 2, 0)
DEP_REG32(DX0GCR5, 0x714)
    DEP_FIELD(DX0GCR5, RESERVED_31, 1, 31)
    DEP_FIELD(DX0GCR5, DXREFISELR3, 7, 24)
    DEP_FIELD(DX0GCR5, RESERVED_23, 1, 23)
    DEP_FIELD(DX0GCR5, DXREFISELR2, 7, 16)
    DEP_FIELD(DX0GCR5, RESERVED_15, 1, 15)
    DEP_FIELD(DX0GCR5, DXREFISELR1, 7, 8)
    DEP_FIELD(DX0GCR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX0GCR5, DXREFISELR0, 7, 0)
DEP_REG32(DX0GCR6, 0x718)
    DEP_FIELD(DX0GCR6, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX0GCR6, DXDQVREFR3, 6, 24)
    DEP_FIELD(DX0GCR6, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX0GCR6, DXDQVREFR2, 6, 16)
    DEP_FIELD(DX0GCR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX0GCR6, DXDQVREFR1, 6, 8)
    DEP_FIELD(DX0GCR6, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX0GCR6, DXDQVREFR0, 6, 0)
DEP_REG32(DX0GCR7, 0x71c)
    DEP_FIELD(DX0GCR7, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX0GCR7, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX0GCR7, RESERVED_25, 1, 25)
    DEP_FIELD(DX0GCR7, RESERVED_24_23, 2, 23)
    DEP_FIELD(DX0GCR7, RESERVED_22, 1, 22)
    DEP_FIELD(DX0GCR7, RESERVED_21, 1, 21)
    DEP_FIELD(DX0GCR7, RESERVED_20, 1, 20)
    DEP_FIELD(DX0GCR7, RESERVED_19, 1, 19)
    DEP_FIELD(DX0GCR7, RESERVED_18, 1, 18)
    DEP_FIELD(DX0GCR7, RESERVED_17, 1, 17)
    DEP_FIELD(DX0GCR7, RESERVED_16, 1, 16)
    DEP_FIELD(DX0GCR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX0GCR7, RESERVED_13_12, 2, 12)
    DEP_FIELD(DX0GCR7, RESERVED_11_10, 2, 10)
    DEP_FIELD(DX0GCR7, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX0GCR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX0GCR7, RESERVED_5_4, 2, 4)
    DEP_FIELD(DX0GCR7, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX0GCR7, RESERVED_1_0, 2, 0)
DEP_REG32(DX0GCR8, 0x720)
    DEP_FIELD(DX0GCR8, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX0GCR8, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX0GCR8, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX0GCR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX0GCR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX0GCR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX0GCR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX0GCR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX0GCR9, 0x724)
    DEP_FIELD(DX0GCR9, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX0GCR9, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX0GCR9, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX0GCR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX0GCR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX0GCR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX0GCR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX0GCR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX0BDLR0, 0x740)
    DEP_FIELD(DX0BDLR0, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX0BDLR0, DQ3WBD, 6, 24)
    DEP_FIELD(DX0BDLR0, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX0BDLR0, DQ2WBD, 6, 16)
    DEP_FIELD(DX0BDLR0, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX0BDLR0, DQ1WBD, 6, 8)
    DEP_FIELD(DX0BDLR0, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX0BDLR0, DQ0WBD, 6, 0)
DEP_REG32(DX0BDLR1, 0x744)
    DEP_FIELD(DX0BDLR1, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX0BDLR1, DQ7WBD, 6, 24)
    DEP_FIELD(DX0BDLR1, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX0BDLR1, DQ6WBD, 6, 16)
    DEP_FIELD(DX0BDLR1, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX0BDLR1, DQ5WBD, 6, 8)
    DEP_FIELD(DX0BDLR1, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX0BDLR1, DQ4WBD, 6, 0)
DEP_REG32(DX0BDLR2, 0x748)
    DEP_FIELD(DX0BDLR2, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX0BDLR2, DSNWBD, 6, 24)
    DEP_FIELD(DX0BDLR2, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX0BDLR2, DSOEBD, 6, 16)
    DEP_FIELD(DX0BDLR2, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX0BDLR2, DSWBD, 6, 8)
    DEP_FIELD(DX0BDLR2, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX0BDLR2, DMWBD, 6, 0)
DEP_REG32(DX0BDLR3, 0x750)
    DEP_FIELD(DX0BDLR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX0BDLR3, DQ3RBD, 6, 24)
    DEP_FIELD(DX0BDLR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX0BDLR3, DQ2RBD, 6, 16)
    DEP_FIELD(DX0BDLR3, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX0BDLR3, DQ1RBD, 6, 8)
    DEP_FIELD(DX0BDLR3, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX0BDLR3, DQ0RBD, 6, 0)
DEP_REG32(DX0BDLR4, 0x754)
    DEP_FIELD(DX0BDLR4, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX0BDLR4, DQ7RBD, 6, 24)
    DEP_FIELD(DX0BDLR4, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX0BDLR4, DQ6RBD, 6, 16)
    DEP_FIELD(DX0BDLR4, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX0BDLR4, DQ5RBD, 6, 8)
    DEP_FIELD(DX0BDLR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX0BDLR4, DQ4RBD, 6, 0)
DEP_REG32(DX0BDLR5, 0x758)
    DEP_FIELD(DX0BDLR5, RESERVED_31_6, 26, 6)
    DEP_FIELD(DX0BDLR5, DMRBD, 6, 0)
DEP_REG32(DX0BDLR6, 0x760)
    DEP_FIELD(DX0BDLR6, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX0BDLR6, TERBD, 6, 16)
    DEP_FIELD(DX0BDLR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX0BDLR6, PDRBD, 6, 8)
    DEP_FIELD(DX0BDLR6, RESERVED_7_0, 8, 0)
DEP_REG32(DX0BDLR7, 0x764)
    DEP_FIELD(DX0BDLR7, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX0BDLR7, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX0BDLR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX0BDLR7, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX0BDLR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX0BDLR7, RESERVED_5_0, 6, 0)
DEP_REG32(DX0BDLR8, 0x768)
    DEP_FIELD(DX0BDLR8, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX0BDLR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX0BDLR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX0BDLR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX0BDLR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX0BDLR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX0BDLR9, 0x76c)
    DEP_FIELD(DX0BDLR9, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX0BDLR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX0BDLR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX0BDLR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX0BDLR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX0BDLR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX0LCDLR0, 0x780)
    DEP_FIELD(DX0LCDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX0LCDLR0, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX0LCDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX0LCDLR0, WLD, 9, 0)
DEP_REG32(DX0LCDLR1, 0x784)
    DEP_FIELD(DX0LCDLR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX0LCDLR1, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX0LCDLR1, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX0LCDLR1, WDQD, 9, 0)
DEP_REG32(DX0LCDLR2, 0x788)
    DEP_FIELD(DX0LCDLR2, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX0LCDLR2, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX0LCDLR2, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX0LCDLR2, DQSGD, 9, 0)
DEP_REG32(DX0LCDLR3, 0x78c)
    DEP_FIELD(DX0LCDLR3, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX0LCDLR3, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX0LCDLR3, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX0LCDLR3, RDQSD, 9, 0)
DEP_REG32(DX0LCDLR4, 0x790)
    DEP_FIELD(DX0LCDLR4, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX0LCDLR4, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX0LCDLR4, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX0LCDLR4, RDQSND, 9, 0)
DEP_REG32(DX0LCDLR5, 0x794)
    DEP_FIELD(DX0LCDLR5, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX0LCDLR5, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX0LCDLR5, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX0LCDLR5, DQSGSD, 9, 0)
DEP_REG32(DX0MDLR0, 0x7a0)
    DEP_FIELD(DX0MDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX0MDLR0, TPRD, 9, 16)
    DEP_FIELD(DX0MDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX0MDLR0, IPRD, 9, 0)
DEP_REG32(DX0MDLR1, 0x7a4)
    DEP_FIELD(DX0MDLR1, RESERVED_31_9, 23, 9)
    DEP_FIELD(DX0MDLR1, MDLD, 9, 0)
DEP_REG32(DX0GTR0, 0x7c0)
    DEP_FIELD(DX0GTR0, RESERVED_31_24, 5, 27)
    DEP_FIELD(DX0GTR0, WDQSL, 3, 24)
    DEP_FIELD(DX0GTR0, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX0GTR0, WLSL, 4, 16)
    DEP_FIELD(DX0GTR0, RESERVED_15_13, 3, 13)
    DEP_FIELD(DX0GTR0, RESERVED_12_8, 5, 8)
    DEP_FIELD(DX0GTR0, RESERVED_7_5, 3, 5)
    DEP_FIELD(DX0GTR0, DGSL, 5, 0)
DEP_REG32(DX0RSR0, 0x7d0)
    DEP_FIELD(DX0RSR0, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX0RSR0, QSGERR, 16, 0)
DEP_REG32(DX0RSR1, 0x7d4)
    DEP_FIELD(DX0RSR1, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX0RSR1, RDLVLERR, 16, 0)
DEP_REG32(DX0RSR2, 0x7d8)
    DEP_FIELD(DX0RSR2, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX0RSR2, WLAWN, 16, 0)
DEP_REG32(DX0RSR3, 0x7dc)
    DEP_FIELD(DX0RSR3, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX0RSR3, WLAERR, 16, 0)
DEP_REG32(DX0GSR0, 0x7e0)
    DEP_FIELD(DX0GSR0, RESERVED_31, 1, 31)
    DEP_FIELD(DX0GSR0, WLDQ, 1, 30)
    DEP_FIELD(DX0GSR0, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX0GSR0, GDQSPRD, 9, 17)
    DEP_FIELD(DX0GSR0, DPLOCK, 1, 16)
    DEP_FIELD(DX0GSR0, WLPRD, 9, 7)
    DEP_FIELD(DX0GSR0, WLERR, 1, 6)
    DEP_FIELD(DX0GSR0, WLDONE, 1, 5)
    DEP_FIELD(DX0GSR0, WLCAL, 1, 4)
    DEP_FIELD(DX0GSR0, GDQSCAL, 1, 3)
    DEP_FIELD(DX0GSR0, RDQSNCAL, 1, 2)
    DEP_FIELD(DX0GSR0, RDQSCAL, 1, 1)
    DEP_FIELD(DX0GSR0, WDQCAL, 1, 0)
DEP_REG32(DX0GSR1, 0x7e4)
    DEP_FIELD(DX0GSR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX0GSR1, DLTCODE, 24, 1)
    DEP_FIELD(DX0GSR1, DLTDONE, 1, 0)
DEP_REG32(DX0GSR2, 0x7e8)
    DEP_FIELD(DX0GSR2, GSDQSPRD, 9, 23)
    DEP_FIELD(DX0GSR2, GSDQSCAL, 1, 22)
    DEP_FIELD(DX0GSR2, RESERVED_21, 1, 21)
    DEP_FIELD(DX0GSR2, SRDERR, 1, 20)
    DEP_FIELD(DX0GSR2, DQS2DQERR, 8, 12)
    DEP_FIELD(DX0GSR2, ESTAT, 4, 8)
    DEP_FIELD(DX0GSR2, WEWN, 1, 7)
    DEP_FIELD(DX0GSR2, WEERR, 1, 6)
    DEP_FIELD(DX0GSR2, REWN, 1, 5)
    DEP_FIELD(DX0GSR2, REERR, 1, 4)
    DEP_FIELD(DX0GSR2, WDWN, 1, 3)
    DEP_FIELD(DX0GSR2, WDERR, 1, 2)
    DEP_FIELD(DX0GSR2, RDWN, 1, 1)
    DEP_FIELD(DX0GSR2, RDERR, 1, 0)
DEP_REG32(DX0GSR3, 0x7ec)
    DEP_FIELD(DX0GSR3, RESERVED_31_27, 5, 27)
    DEP_FIELD(DX0GSR3, ESTAT, 3, 24)
    DEP_FIELD(DX0GSR3, DVWRN, 4, 20)
    DEP_FIELD(DX0GSR3, DVERR, 4, 16)
    DEP_FIELD(DX0GSR3, HVWRN, 4, 12)
    DEP_FIELD(DX0GSR3, HVERR, 4, 8)
    DEP_FIELD(DX0GSR3, RESERVED_7_2, 6, 2)
    DEP_FIELD(DX0GSR3, SRDPC, 2, 0)
DEP_REG32(DX0GSR4, 0x7f0)
    DEP_FIELD(DX0GSR4, RESERVED_31_26, 6, 26)
    DEP_FIELD(DX0GSR4, RESERVED_25_17, 9, 17)
    DEP_FIELD(DX0GSR4, RESERVED_16, 1, 16)
    DEP_FIELD(DX0GSR4, RESERVED_15_7, 9, 7)
    DEP_FIELD(DX0GSR4, RESERVED_6, 1, 6)
    DEP_FIELD(DX0GSR4, RESERVED_5, 1, 5)
    DEP_FIELD(DX0GSR4, RESERVED_4, 1, 4)
    DEP_FIELD(DX0GSR4, RESERVED_3, 1, 3)
    DEP_FIELD(DX0GSR4, RESERVED_2, 1, 2)
    DEP_FIELD(DX0GSR4, RESERVED_1, 1, 1)
    DEP_FIELD(DX0GSR4, RESERVED_0, 1, 0)
DEP_REG32(DX0GSR5, 0x7f4)
    DEP_FIELD(DX0GSR5, RESERVED_31_23, 9, 23)
    DEP_FIELD(DX0GSR5, RESERVED_22, 1, 22)
    DEP_FIELD(DX0GSR5, RESERVED_21, 1, 21)
    DEP_FIELD(DX0GSR5, RESERVED_20, 1, 20)
    DEP_FIELD(DX0GSR5, RESERVED_19_12, 8, 12)
    DEP_FIELD(DX0GSR5, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX0GSR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX0GSR5, RESERVED_6, 1, 6)
    DEP_FIELD(DX0GSR5, RESERVED_5, 1, 5)
    DEP_FIELD(DX0GSR5, RESERVED_4, 1, 4)
    DEP_FIELD(DX0GSR5, RESERVED_3, 1, 3)
    DEP_FIELD(DX0GSR5, RESERVED_2, 1, 2)
    DEP_FIELD(DX0GSR5, RESERVED_1, 1, 1)
    DEP_FIELD(DX0GSR5, RESERVED_0, 1, 0)
DEP_REG32(DX0GSR6, 0x7f8)
    DEP_FIELD(DX0GSR6, RESERVED_31_24, 8, 24)
    DEP_FIELD(DX0GSR6, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX0GSR6, RESERVED_19_15, 4, 16)
    DEP_FIELD(DX0GSR6, RESERVED_15_12, 4, 12)
    DEP_FIELD(DX0GSR6, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX0GSR6, RESERVED_7_4, 4, 4)
    DEP_FIELD(DX0GSR6, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX0GSR6, RESERVED_1_0, 2, 0)
DEP_REG32(DX1GCR0, 0x800)
    DEP_FIELD(DX1GCR0, CALBYP, 1, 31)
    DEP_FIELD(DX1GCR0, MDLEN, 1, 30)
    DEP_FIELD(DX1GCR0, CODTSHFT, 2, 28)
    DEP_FIELD(DX1GCR0, DQSDCC, 4, 24)
    DEP_FIELD(DX1GCR0, RDDLY, 4, 20)
    DEP_FIELD(DX1GCR0, RESERVED_19_14, 6, 14)
    DEP_FIELD(DX1GCR0, DQSNSEPDR, 1, 13)
    DEP_FIELD(DX1GCR0, DQSSEPDR, 1, 12)
    DEP_FIELD(DX1GCR0, RTTOAL, 1, 11)
    DEP_FIELD(DX1GCR0, RTTOH, 2, 9)
    DEP_FIELD(DX1GCR0, CPDRSHFT, 2, 7)
    DEP_FIELD(DX1GCR0, DQSRPD, 1, 6)
    DEP_FIELD(DX1GCR0, DQSGPDR, 1, 5)
    DEP_FIELD(DX1GCR0, RESERVED_4, 1, 4)
    DEP_FIELD(DX1GCR0, DQSGODT, 1, 3)
    DEP_FIELD(DX1GCR0, DQSGOE, 1, 2)
    DEP_FIELD(DX1GCR0, RESERVED_1_0, 2, 0)
DEP_REG32(DX1GCR1, 0x804)
    DEP_FIELD(DX1GCR1, DXPDRMODE, 16, 16)
    DEP_FIELD(DX1GCR1, RESERVED_15, 1, 15)
    DEP_FIELD(DX1GCR1, QSNSEL, 1, 14)
    DEP_FIELD(DX1GCR1, QSSEL, 1, 13)
    DEP_FIELD(DX1GCR1, OEEN, 1, 12)
    DEP_FIELD(DX1GCR1, PDREN, 1, 11)
    DEP_FIELD(DX1GCR1, TEEN, 1, 10)
    DEP_FIELD(DX1GCR1, DSEN, 1, 9)
    DEP_FIELD(DX1GCR1, DMEN, 1, 8)
    DEP_FIELD(DX1GCR1, DQEN, 8, 0)
DEP_REG32(DX1GCR2, 0x808)
    DEP_FIELD(DX1GCR2, DXOEMODE, 16, 16)
    DEP_FIELD(DX1GCR2, DXTEMODE, 16, 0)
DEP_REG32(DX1GCR3, 0x80c)
    DEP_FIELD(DX1GCR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX1GCR3, RDBVT, 1, 29)
    DEP_FIELD(DX1GCR3, WDBVT, 1, 28)
    DEP_FIELD(DX1GCR3, RGLVT, 1, 27)
    DEP_FIELD(DX1GCR3, RDLVT, 1, 26)
    DEP_FIELD(DX1GCR3, WDLVT, 1, 25)
    DEP_FIELD(DX1GCR3, WLLVT, 1, 24)
    DEP_FIELD(DX1GCR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX1GCR3, DSNOEMODE, 2, 20)
    DEP_FIELD(DX1GCR3, DSNTEMODE, 2, 18)
    DEP_FIELD(DX1GCR3, DSNPDRMODE, 2, 16)
    DEP_FIELD(DX1GCR3, DMOEMODE, 2, 14)
    DEP_FIELD(DX1GCR3, DMTEMODE, 2, 12)
    DEP_FIELD(DX1GCR3, DMPDRMODE, 2, 10)
    DEP_FIELD(DX1GCR3, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX1GCR3, DSOEMODE, 2, 6)
    DEP_FIELD(DX1GCR3, DSTEMODE, 2, 4)
    DEP_FIELD(DX1GCR3, DSPDRMODE, 2, 2)
    DEP_FIELD(DX1GCR3, RESERVED_1_0, 2, 0)
DEP_REG32(DX1GCR4, 0x810)
    DEP_FIELD(DX1GCR4, RESERVED_31_29, 3, 29)
    DEP_FIELD(DX1GCR4, DXREFPEN, 1, 28)
    DEP_FIELD(DX1GCR4, DXREFEEN, 2, 26)
    DEP_FIELD(DX1GCR4, DXREFSEN, 1, 25)
    DEP_FIELD(DX1GCR4, RESERVED_24, 1, 24)
    DEP_FIELD(DX1GCR4, DXREFESELRANGE, 1, 23)
    DEP_FIELD(DX1GCR4, DXREFESEL, 7, 16)
    DEP_FIELD(DX1GCR4, DXREFSSELRANGE, 1, 15)
    DEP_FIELD(DX1GCR4, DXREFSSEL, 7, 8)
    DEP_FIELD(DX1GCR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX1GCR4, DXREFIEN, 4, 2)
    DEP_FIELD(DX1GCR4, DXREFIMON, 2, 0)
DEP_REG32(DX1GCR5, 0x814)
    DEP_FIELD(DX1GCR5, RESERVED_31, 1, 31)
    DEP_FIELD(DX1GCR5, DXREFISELR3, 7, 24)
    DEP_FIELD(DX1GCR5, RESERVED_23, 1, 23)
    DEP_FIELD(DX1GCR5, DXREFISELR2, 7, 16)
    DEP_FIELD(DX1GCR5, RESERVED_15, 1, 15)
    DEP_FIELD(DX1GCR5, DXREFISELR1, 7, 8)
    DEP_FIELD(DX1GCR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX1GCR5, DXREFISELR0, 7, 0)
DEP_REG32(DX1GCR6, 0x818)
    DEP_FIELD(DX1GCR6, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX1GCR6, DXDQVREFR3, 6, 24)
    DEP_FIELD(DX1GCR6, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX1GCR6, DXDQVREFR2, 6, 16)
    DEP_FIELD(DX1GCR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX1GCR6, DXDQVREFR1, 6, 8)
    DEP_FIELD(DX1GCR6, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX1GCR6, DXDQVREFR0, 6, 0)
DEP_REG32(DX1GCR7, 0x81c)
    DEP_FIELD(DX1GCR7, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX1GCR7, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX1GCR7, RESERVED_25, 1, 25)
    DEP_FIELD(DX1GCR7, RESERVED_24_23, 2, 23)
    DEP_FIELD(DX1GCR7, RESERVED_22, 1, 22)
    DEP_FIELD(DX1GCR7, RESERVED_21, 1, 21)
    DEP_FIELD(DX1GCR7, RESERVED_20, 1, 20)
    DEP_FIELD(DX1GCR7, RESERVED_19, 1, 19)
    DEP_FIELD(DX1GCR7, RESERVED_18, 1, 18)
    DEP_FIELD(DX1GCR7, RESERVED_17, 1, 17)
    DEP_FIELD(DX1GCR7, RESERVED_16, 1, 16)
    DEP_FIELD(DX1GCR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX1GCR7, RESERVED_13_12, 2, 12)
    DEP_FIELD(DX1GCR7, RESERVED_11_10, 2, 10)
    DEP_FIELD(DX1GCR7, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX1GCR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX1GCR7, RESERVED_5_4, 2, 4)
    DEP_FIELD(DX1GCR7, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX1GCR7, RESERVED_1_0, 2, 0)
DEP_REG32(DX1GCR8, 0x820)
    DEP_FIELD(DX1GCR8, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX1GCR8, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX1GCR8, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX1GCR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX1GCR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX1GCR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX1GCR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX1GCR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX1GCR9, 0x824)
    DEP_FIELD(DX1GCR9, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX1GCR9, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX1GCR9, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX1GCR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX1GCR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX1GCR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX1GCR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX1GCR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX1BDLR0, 0x840)
    DEP_FIELD(DX1BDLR0, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX1BDLR0, DQ3WBD, 6, 24)
    DEP_FIELD(DX1BDLR0, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX1BDLR0, DQ2WBD, 6, 16)
    DEP_FIELD(DX1BDLR0, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX1BDLR0, DQ1WBD, 6, 8)
    DEP_FIELD(DX1BDLR0, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX1BDLR0, DQ0WBD, 6, 0)
DEP_REG32(DX1BDLR1, 0x844)
    DEP_FIELD(DX1BDLR1, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX1BDLR1, DQ7WBD, 6, 24)
    DEP_FIELD(DX1BDLR1, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX1BDLR1, DQ6WBD, 6, 16)
    DEP_FIELD(DX1BDLR1, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX1BDLR1, DQ5WBD, 6, 8)
    DEP_FIELD(DX1BDLR1, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX1BDLR1, DQ4WBD, 6, 0)
DEP_REG32(DX1BDLR2, 0x848)
    DEP_FIELD(DX1BDLR2, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX1BDLR2, DSNWBD, 6, 24)
    DEP_FIELD(DX1BDLR2, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX1BDLR2, DSOEBD, 6, 16)
    DEP_FIELD(DX1BDLR2, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX1BDLR2, DSWBD, 6, 8)
    DEP_FIELD(DX1BDLR2, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX1BDLR2, DMWBD, 6, 0)
DEP_REG32(DX1BDLR3, 0x850)
    DEP_FIELD(DX1BDLR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX1BDLR3, DQ3RBD, 6, 24)
    DEP_FIELD(DX1BDLR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX1BDLR3, DQ2RBD, 6, 16)
    DEP_FIELD(DX1BDLR3, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX1BDLR3, DQ1RBD, 6, 8)
    DEP_FIELD(DX1BDLR3, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX1BDLR3, DQ0RBD, 6, 0)
DEP_REG32(DX1BDLR4, 0x854)
    DEP_FIELD(DX1BDLR4, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX1BDLR4, DQ7RBD, 6, 24)
    DEP_FIELD(DX1BDLR4, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX1BDLR4, DQ6RBD, 6, 16)
    DEP_FIELD(DX1BDLR4, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX1BDLR4, DQ5RBD, 6, 8)
    DEP_FIELD(DX1BDLR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX1BDLR4, DQ4RBD, 6, 0)
DEP_REG32(DX1BDLR5, 0x858)
    DEP_FIELD(DX1BDLR5, RESERVED_31_6, 26, 6)
    DEP_FIELD(DX1BDLR5, DMRBD, 6, 0)
DEP_REG32(DX1BDLR6, 0x860)
    DEP_FIELD(DX1BDLR6, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX1BDLR6, TERBD, 6, 16)
    DEP_FIELD(DX1BDLR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX1BDLR6, PDRBD, 6, 8)
    DEP_FIELD(DX1BDLR6, RESERVED_7_0, 8, 0)
DEP_REG32(DX1BDLR7, 0x864)
    DEP_FIELD(DX1BDLR7, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX1BDLR7, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX1BDLR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX1BDLR7, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX1BDLR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX1BDLR7, RESERVED_5_0, 6, 0)
DEP_REG32(DX1BDLR8, 0x868)
    DEP_FIELD(DX1BDLR8, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX1BDLR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX1BDLR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX1BDLR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX1BDLR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX1BDLR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX1BDLR9, 0x86c)
    DEP_FIELD(DX1BDLR9, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX1BDLR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX1BDLR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX1BDLR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX1BDLR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX1BDLR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX1LCDLR0, 0x880)
    DEP_FIELD(DX1LCDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX1LCDLR0, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX1LCDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX1LCDLR0, WLD, 9, 0)
DEP_REG32(DX1LCDLR1, 0x884)
    DEP_FIELD(DX1LCDLR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX1LCDLR1, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX1LCDLR1, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX1LCDLR1, WDQD, 9, 0)
DEP_REG32(DX1LCDLR2, 0x888)
    DEP_FIELD(DX1LCDLR2, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX1LCDLR2, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX1LCDLR2, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX1LCDLR2, DQSGD, 9, 0)
DEP_REG32(DX1LCDLR3, 0x88c)
    DEP_FIELD(DX1LCDLR3, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX1LCDLR3, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX1LCDLR3, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX1LCDLR3, RDQSD, 9, 0)
DEP_REG32(DX1LCDLR4, 0x890)
    DEP_FIELD(DX1LCDLR4, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX1LCDLR4, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX1LCDLR4, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX1LCDLR4, RDQSND, 9, 0)
DEP_REG32(DX1LCDLR5, 0x894)
    DEP_FIELD(DX1LCDLR5, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX1LCDLR5, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX1LCDLR5, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX1LCDLR5, DQSGSD, 9, 0)
DEP_REG32(DX1MDLR0, 0x8a0)
    DEP_FIELD(DX1MDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX1MDLR0, TPRD, 9, 16)
    DEP_FIELD(DX1MDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX1MDLR0, IPRD, 9, 0)
DEP_REG32(DX1MDLR1, 0x8a4)
    DEP_FIELD(DX1MDLR1, RESERVED_31_9, 23, 9)
    DEP_FIELD(DX1MDLR1, MDLD, 9, 0)
DEP_REG32(DX1GTR0, 0x8c0)
    DEP_FIELD(DX1GTR0, RESERVED_31_24, 5, 27)
    DEP_FIELD(DX1GTR0, WDQSL, 3, 24)
    DEP_FIELD(DX1GTR0, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX1GTR0, WLSL, 4, 16)
    DEP_FIELD(DX1GTR0, RESERVED_15_13, 3, 13)
    DEP_FIELD(DX1GTR0, RESERVED_12_8, 5, 8)
    DEP_FIELD(DX1GTR0, RESERVED_7_5, 3, 5)
    DEP_FIELD(DX1GTR0, DGSL, 5, 0)
DEP_REG32(DX1RSR0, 0x8d0)
    DEP_FIELD(DX1RSR0, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX1RSR0, QSGERR, 16, 0)
DEP_REG32(DX1RSR1, 0x8d4)
    DEP_FIELD(DX1RSR1, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX1RSR1, RDLVLERR, 16, 0)
DEP_REG32(DX1RSR2, 0x8d8)
    DEP_FIELD(DX1RSR2, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX1RSR2, WLAWN, 16, 0)
DEP_REG32(DX1RSR3, 0x8dc)
    DEP_FIELD(DX1RSR3, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX1RSR3, WLAERR, 16, 0)
DEP_REG32(DX1GSR0, 0x8e0)
    DEP_FIELD(DX1GSR0, RESERVED_31, 1, 31)
    DEP_FIELD(DX1GSR0, WLDQ, 1, 30)
    DEP_FIELD(DX1GSR0, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX1GSR0, GDQSPRD, 9, 17)
    DEP_FIELD(DX1GSR0, DPLOCK, 1, 16)
    DEP_FIELD(DX1GSR0, WLPRD, 9, 7)
    DEP_FIELD(DX1GSR0, WLERR, 1, 6)
    DEP_FIELD(DX1GSR0, WLDONE, 1, 5)
    DEP_FIELD(DX1GSR0, WLCAL, 1, 4)
    DEP_FIELD(DX1GSR0, GDQSCAL, 1, 3)
    DEP_FIELD(DX1GSR0, RDQSNCAL, 1, 2)
    DEP_FIELD(DX1GSR0, RDQSCAL, 1, 1)
    DEP_FIELD(DX1GSR0, WDQCAL, 1, 0)
DEP_REG32(DX1GSR1, 0x8e4)
    DEP_FIELD(DX1GSR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX1GSR1, DLTCODE, 24, 1)
    DEP_FIELD(DX1GSR1, DLTDONE, 1, 0)
DEP_REG32(DX1GSR2, 0x8e8)
    DEP_FIELD(DX1GSR2, GSDQSPRD, 9, 23)
    DEP_FIELD(DX1GSR2, GSDQSCAL, 1, 22)
    DEP_FIELD(DX1GSR2, RESERVED_21, 1, 21)
    DEP_FIELD(DX1GSR2, SRDERR, 1, 20)
    DEP_FIELD(DX1GSR2, DQS2DQERR, 8, 12)
    DEP_FIELD(DX1GSR2, ESTAT, 4, 8)
    DEP_FIELD(DX1GSR2, WEWN, 1, 7)
    DEP_FIELD(DX1GSR2, WEERR, 1, 6)
    DEP_FIELD(DX1GSR2, REWN, 1, 5)
    DEP_FIELD(DX1GSR2, REERR, 1, 4)
    DEP_FIELD(DX1GSR2, WDWN, 1, 3)
    DEP_FIELD(DX1GSR2, WDERR, 1, 2)
    DEP_FIELD(DX1GSR2, RDWN, 1, 1)
    DEP_FIELD(DX1GSR2, RDERR, 1, 0)
DEP_REG32(DX1GSR3, 0x8ec)
    DEP_FIELD(DX1GSR3, RESERVED_31_27, 5, 27)
    DEP_FIELD(DX1GSR3, ESTAT, 3, 24)
    DEP_FIELD(DX1GSR3, DVWRN, 4, 20)
    DEP_FIELD(DX1GSR3, DVERR, 4, 16)
    DEP_FIELD(DX1GSR3, HVWRN, 4, 12)
    DEP_FIELD(DX1GSR3, HVERR, 4, 8)
    DEP_FIELD(DX1GSR3, RESERVED_7_2, 6, 2)
    DEP_FIELD(DX1GSR3, SRDPC, 2, 0)
DEP_REG32(DX1GSR4, 0x8f0)
    DEP_FIELD(DX1GSR4, RESERVED_31_26, 6, 26)
    DEP_FIELD(DX1GSR4, RESERVED_25_17, 9, 17)
    DEP_FIELD(DX1GSR4, RESERVED_16, 1, 16)
    DEP_FIELD(DX1GSR4, RESERVED_15_7, 9, 7)
    DEP_FIELD(DX1GSR4, RESERVED_6, 1, 6)
    DEP_FIELD(DX1GSR4, RESERVED_5, 1, 5)
    DEP_FIELD(DX1GSR4, RESERVED_4, 1, 4)
    DEP_FIELD(DX1GSR4, RESERVED_3, 1, 3)
    DEP_FIELD(DX1GSR4, RESERVED_2, 1, 2)
    DEP_FIELD(DX1GSR4, RESERVED_1, 1, 1)
    DEP_FIELD(DX1GSR4, RESERVED_0, 1, 0)
DEP_REG32(DX1GSR5, 0x8f4)
    DEP_FIELD(DX1GSR5, RESERVED_31_23, 9, 23)
    DEP_FIELD(DX1GSR5, RESERVED_22, 1, 22)
    DEP_FIELD(DX1GSR5, RESERVED_21, 1, 21)
    DEP_FIELD(DX1GSR5, RESERVED_20, 1, 20)
    DEP_FIELD(DX1GSR5, RESERVED_19_12, 8, 12)
    DEP_FIELD(DX1GSR5, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX1GSR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX1GSR5, RESERVED_6, 1, 6)
    DEP_FIELD(DX1GSR5, RESERVED_5, 1, 5)
    DEP_FIELD(DX1GSR5, RESERVED_4, 1, 4)
    DEP_FIELD(DX1GSR5, RESERVED_3, 1, 3)
    DEP_FIELD(DX1GSR5, RESERVED_2, 1, 2)
    DEP_FIELD(DX1GSR5, RESERVED_1, 1, 1)
    DEP_FIELD(DX1GSR5, RESERVED_0, 1, 0)
DEP_REG32(DX1GSR6, 0x8f8)
    DEP_FIELD(DX1GSR6, RESERVED_31_24, 8, 24)
    DEP_FIELD(DX1GSR6, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX1GSR6, RESERVED_19_15, 4, 16)
    DEP_FIELD(DX1GSR6, RESERVED_15_12, 4, 12)
    DEP_FIELD(DX1GSR6, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX1GSR6, RESERVED_7_4, 4, 4)
    DEP_FIELD(DX1GSR6, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX1GSR6, RESERVED_1_0, 2, 0)
DEP_REG32(DX2GCR0, 0x900)
    DEP_FIELD(DX2GCR0, CALBYP, 1, 31)
    DEP_FIELD(DX2GCR0, MDLEN, 1, 30)
    DEP_FIELD(DX2GCR0, CODTSHFT, 2, 28)
    DEP_FIELD(DX2GCR0, DQSDCC, 4, 24)
    DEP_FIELD(DX2GCR0, RDDLY, 4, 20)
    DEP_FIELD(DX2GCR0, RESERVED_19_14, 6, 14)
    DEP_FIELD(DX2GCR0, DQSNSEPDR, 1, 13)
    DEP_FIELD(DX2GCR0, DQSSEPDR, 1, 12)
    DEP_FIELD(DX2GCR0, RTTOAL, 1, 11)
    DEP_FIELD(DX2GCR0, RTTOH, 2, 9)
    DEP_FIELD(DX2GCR0, CPDRSHFT, 2, 7)
    DEP_FIELD(DX2GCR0, DQSRPD, 1, 6)
    DEP_FIELD(DX2GCR0, DQSGPDR, 1, 5)
    DEP_FIELD(DX2GCR0, RESERVED_4, 1, 4)
    DEP_FIELD(DX2GCR0, DQSGODT, 1, 3)
    DEP_FIELD(DX2GCR0, DQSGOE, 1, 2)
    DEP_FIELD(DX2GCR0, RESERVED_1_0, 2, 0)
DEP_REG32(DX2GCR1, 0x904)
    DEP_FIELD(DX2GCR1, DXPDRMODE, 16, 16)
    DEP_FIELD(DX2GCR1, RESERVED_15, 1, 15)
    DEP_FIELD(DX2GCR1, QSNSEL, 1, 14)
    DEP_FIELD(DX2GCR1, QSSEL, 1, 13)
    DEP_FIELD(DX2GCR1, OEEN, 1, 12)
    DEP_FIELD(DX2GCR1, PDREN, 1, 11)
    DEP_FIELD(DX2GCR1, TEEN, 1, 10)
    DEP_FIELD(DX2GCR1, DSEN, 1, 9)
    DEP_FIELD(DX2GCR1, DMEN, 1, 8)
    DEP_FIELD(DX2GCR1, DQEN, 8, 0)
DEP_REG32(DX2GCR2, 0x908)
    DEP_FIELD(DX2GCR2, DXOEMODE, 16, 16)
    DEP_FIELD(DX2GCR2, DXTEMODE, 16, 0)
DEP_REG32(DX2GCR3, 0x90c)
    DEP_FIELD(DX2GCR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX2GCR3, RDBVT, 1, 29)
    DEP_FIELD(DX2GCR3, WDBVT, 1, 28)
    DEP_FIELD(DX2GCR3, RGLVT, 1, 27)
    DEP_FIELD(DX2GCR3, RDLVT, 1, 26)
    DEP_FIELD(DX2GCR3, WDLVT, 1, 25)
    DEP_FIELD(DX2GCR3, WLLVT, 1, 24)
    DEP_FIELD(DX2GCR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX2GCR3, DSNOEMODE, 2, 20)
    DEP_FIELD(DX2GCR3, DSNTEMODE, 2, 18)
    DEP_FIELD(DX2GCR3, DSNPDRMODE, 2, 16)
    DEP_FIELD(DX2GCR3, DMOEMODE, 2, 14)
    DEP_FIELD(DX2GCR3, DMTEMODE, 2, 12)
    DEP_FIELD(DX2GCR3, DMPDRMODE, 2, 10)
    DEP_FIELD(DX2GCR3, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX2GCR3, DSOEMODE, 2, 6)
    DEP_FIELD(DX2GCR3, DSTEMODE, 2, 4)
    DEP_FIELD(DX2GCR3, DSPDRMODE, 2, 2)
    DEP_FIELD(DX2GCR3, RESERVED_1_0, 2, 0)
DEP_REG32(DX2GCR4, 0x910)
    DEP_FIELD(DX2GCR4, RESERVED_31_29, 3, 29)
    DEP_FIELD(DX2GCR4, DXREFPEN, 1, 28)
    DEP_FIELD(DX2GCR4, DXREFEEN, 2, 26)
    DEP_FIELD(DX2GCR4, DXREFSEN, 1, 25)
    DEP_FIELD(DX2GCR4, RESERVED_24, 1, 24)
    DEP_FIELD(DX2GCR4, DXREFESELRANGE, 1, 23)
    DEP_FIELD(DX2GCR4, DXREFESEL, 7, 16)
    DEP_FIELD(DX2GCR4, DXREFSSELRANGE, 1, 15)
    DEP_FIELD(DX2GCR4, DXREFSSEL, 7, 8)
    DEP_FIELD(DX2GCR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX2GCR4, DXREFIEN, 4, 2)
    DEP_FIELD(DX2GCR4, DXREFIMON, 2, 0)
DEP_REG32(DX2GCR5, 0x914)
    DEP_FIELD(DX2GCR5, RESERVED_31, 1, 31)
    DEP_FIELD(DX2GCR5, DXREFISELR3, 7, 24)
    DEP_FIELD(DX2GCR5, RESERVED_23, 1, 23)
    DEP_FIELD(DX2GCR5, DXREFISELR2, 7, 16)
    DEP_FIELD(DX2GCR5, RESERVED_15, 1, 15)
    DEP_FIELD(DX2GCR5, DXREFISELR1, 7, 8)
    DEP_FIELD(DX2GCR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX2GCR5, DXREFISELR0, 7, 0)
DEP_REG32(DX2GCR6, 0x918)
    DEP_FIELD(DX2GCR6, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX2GCR6, DXDQVREFR3, 6, 24)
    DEP_FIELD(DX2GCR6, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX2GCR6, DXDQVREFR2, 6, 16)
    DEP_FIELD(DX2GCR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX2GCR6, DXDQVREFR1, 6, 8)
    DEP_FIELD(DX2GCR6, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX2GCR6, DXDQVREFR0, 6, 0)
DEP_REG32(DX2GCR7, 0x91c)
    DEP_FIELD(DX2GCR7, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX2GCR7, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX2GCR7, RESERVED_25, 1, 25)
    DEP_FIELD(DX2GCR7, RESERVED_24_23, 2, 23)
    DEP_FIELD(DX2GCR7, RESERVED_22, 1, 22)
    DEP_FIELD(DX2GCR7, RESERVED_21, 1, 21)
    DEP_FIELD(DX2GCR7, RESERVED_20, 1, 20)
    DEP_FIELD(DX2GCR7, RESERVED_19, 1, 19)
    DEP_FIELD(DX2GCR7, RESERVED_18, 1, 18)
    DEP_FIELD(DX2GCR7, RESERVED_17, 1, 17)
    DEP_FIELD(DX2GCR7, RESERVED_16, 1, 16)
    DEP_FIELD(DX2GCR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX2GCR7, RESERVED_13_12, 2, 12)
    DEP_FIELD(DX2GCR7, RESERVED_11_10, 2, 10)
    DEP_FIELD(DX2GCR7, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX2GCR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX2GCR7, RESERVED_5_4, 2, 4)
    DEP_FIELD(DX2GCR7, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX2GCR7, RESERVED_1_0, 2, 0)
DEP_REG32(DX2GCR8, 0x920)
    DEP_FIELD(DX2GCR8, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX2GCR8, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX2GCR8, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX2GCR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX2GCR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX2GCR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX2GCR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX2GCR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX2GCR9, 0x924)
    DEP_FIELD(DX2GCR9, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX2GCR9, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX2GCR9, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX2GCR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX2GCR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX2GCR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX2GCR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX2GCR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX2BDLR0, 0x940)
    DEP_FIELD(DX2BDLR0, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX2BDLR0, DQ3WBD, 6, 24)
    DEP_FIELD(DX2BDLR0, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX2BDLR0, DQ2WBD, 6, 16)
    DEP_FIELD(DX2BDLR0, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX2BDLR0, DQ1WBD, 6, 8)
    DEP_FIELD(DX2BDLR0, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX2BDLR0, DQ0WBD, 6, 0)
DEP_REG32(DX2BDLR1, 0x944)
    DEP_FIELD(DX2BDLR1, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX2BDLR1, DQ7WBD, 6, 24)
    DEP_FIELD(DX2BDLR1, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX2BDLR1, DQ6WBD, 6, 16)
    DEP_FIELD(DX2BDLR1, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX2BDLR1, DQ5WBD, 6, 8)
    DEP_FIELD(DX2BDLR1, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX2BDLR1, DQ4WBD, 6, 0)
DEP_REG32(DX2BDLR2, 0x948)
    DEP_FIELD(DX2BDLR2, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX2BDLR2, DSNWBD, 6, 24)
    DEP_FIELD(DX2BDLR2, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX2BDLR2, DSOEBD, 6, 16)
    DEP_FIELD(DX2BDLR2, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX2BDLR2, DSWBD, 6, 8)
    DEP_FIELD(DX2BDLR2, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX2BDLR2, DMWBD, 6, 0)
DEP_REG32(DX2BDLR3, 0x950)
    DEP_FIELD(DX2BDLR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX2BDLR3, DQ3RBD, 6, 24)
    DEP_FIELD(DX2BDLR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX2BDLR3, DQ2RBD, 6, 16)
    DEP_FIELD(DX2BDLR3, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX2BDLR3, DQ1RBD, 6, 8)
    DEP_FIELD(DX2BDLR3, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX2BDLR3, DQ0RBD, 6, 0)
DEP_REG32(DX2BDLR4, 0x954)
    DEP_FIELD(DX2BDLR4, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX2BDLR4, DQ7RBD, 6, 24)
    DEP_FIELD(DX2BDLR4, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX2BDLR4, DQ6RBD, 6, 16)
    DEP_FIELD(DX2BDLR4, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX2BDLR4, DQ5RBD, 6, 8)
    DEP_FIELD(DX2BDLR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX2BDLR4, DQ4RBD, 6, 0)
DEP_REG32(DX2BDLR5, 0x958)
    DEP_FIELD(DX2BDLR5, RESERVED_31_6, 26, 6)
    DEP_FIELD(DX2BDLR5, DMRBD, 6, 0)
DEP_REG32(DX2BDLR6, 0x960)
    DEP_FIELD(DX2BDLR6, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX2BDLR6, TERBD, 6, 16)
    DEP_FIELD(DX2BDLR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX2BDLR6, PDRBD, 6, 8)
    DEP_FIELD(DX2BDLR6, RESERVED_7_0, 8, 0)
DEP_REG32(DX2BDLR7, 0x964)
    DEP_FIELD(DX2BDLR7, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX2BDLR7, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX2BDLR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX2BDLR7, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX2BDLR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX2BDLR7, RESERVED_5_0, 6, 0)
DEP_REG32(DX2BDLR8, 0x968)
    DEP_FIELD(DX2BDLR8, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX2BDLR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX2BDLR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX2BDLR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX2BDLR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX2BDLR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX2BDLR9, 0x96c)
    DEP_FIELD(DX2BDLR9, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX2BDLR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX2BDLR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX2BDLR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX2BDLR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX2BDLR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX2LCDLR0, 0x980)
    DEP_FIELD(DX2LCDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX2LCDLR0, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX2LCDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX2LCDLR0, WLD, 9, 0)
DEP_REG32(DX2LCDLR1, 0x984)
    DEP_FIELD(DX2LCDLR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX2LCDLR1, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX2LCDLR1, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX2LCDLR1, WDQD, 9, 0)
DEP_REG32(DX2LCDLR2, 0x988)
    DEP_FIELD(DX2LCDLR2, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX2LCDLR2, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX2LCDLR2, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX2LCDLR2, DQSGD, 9, 0)
DEP_REG32(DX2LCDLR3, 0x98c)
    DEP_FIELD(DX2LCDLR3, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX2LCDLR3, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX2LCDLR3, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX2LCDLR3, RDQSD, 9, 0)
DEP_REG32(DX2LCDLR4, 0x990)
    DEP_FIELD(DX2LCDLR4, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX2LCDLR4, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX2LCDLR4, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX2LCDLR4, RDQSND, 9, 0)
DEP_REG32(DX2LCDLR5, 0x994)
    DEP_FIELD(DX2LCDLR5, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX2LCDLR5, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX2LCDLR5, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX2LCDLR5, DQSGSD, 9, 0)
DEP_REG32(DX2MDLR0, 0x9a0)
    DEP_FIELD(DX2MDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX2MDLR0, TPRD, 9, 16)
    DEP_FIELD(DX2MDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX2MDLR0, IPRD, 9, 0)
DEP_REG32(DX2MDLR1, 0x9a4)
    DEP_FIELD(DX2MDLR1, RESERVED_31_9, 23, 9)
    DEP_FIELD(DX2MDLR1, MDLD, 9, 0)
DEP_REG32(DX2GTR0, 0x9c0)
    DEP_FIELD(DX2GTR0, RESERVED_31_24, 5, 27)
    DEP_FIELD(DX2GTR0, WDQSL, 3, 24)
    DEP_FIELD(DX2GTR0, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX2GTR0, WLSL, 4, 16)
    DEP_FIELD(DX2GTR0, RESERVED_15_13, 3, 13)
    DEP_FIELD(DX2GTR0, RESERVED_12_8, 5, 8)
    DEP_FIELD(DX2GTR0, RESERVED_7_5, 3, 5)
    DEP_FIELD(DX2GTR0, DGSL, 5, 0)
DEP_REG32(DX2RSR0, 0x9d0)
    DEP_FIELD(DX2RSR0, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX2RSR0, QSGERR, 16, 0)
DEP_REG32(DX2RSR1, 0x9d4)
    DEP_FIELD(DX2RSR1, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX2RSR1, RDLVLERR, 16, 0)
DEP_REG32(DX2RSR2, 0x9d8)
    DEP_FIELD(DX2RSR2, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX2RSR2, WLAWN, 16, 0)
DEP_REG32(DX2RSR3, 0x9dc)
    DEP_FIELD(DX2RSR3, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX2RSR3, WLAERR, 16, 0)
DEP_REG32(DX2GSR0, 0x9e0)
    DEP_FIELD(DX2GSR0, RESERVED_31, 1, 31)
    DEP_FIELD(DX2GSR0, WLDQ, 1, 30)
    DEP_FIELD(DX2GSR0, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX2GSR0, GDQSPRD, 9, 17)
    DEP_FIELD(DX2GSR0, DPLOCK, 1, 16)
    DEP_FIELD(DX2GSR0, WLPRD, 9, 7)
    DEP_FIELD(DX2GSR0, WLERR, 1, 6)
    DEP_FIELD(DX2GSR0, WLDONE, 1, 5)
    DEP_FIELD(DX2GSR0, WLCAL, 1, 4)
    DEP_FIELD(DX2GSR0, GDQSCAL, 1, 3)
    DEP_FIELD(DX2GSR0, RDQSNCAL, 1, 2)
    DEP_FIELD(DX2GSR0, RDQSCAL, 1, 1)
    DEP_FIELD(DX2GSR0, WDQCAL, 1, 0)
DEP_REG32(DX2GSR1, 0x9e4)
    DEP_FIELD(DX2GSR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX2GSR1, DLTCODE, 24, 1)
    DEP_FIELD(DX2GSR1, DLTDONE, 1, 0)
DEP_REG32(DX2GSR2, 0x9e8)
    DEP_FIELD(DX2GSR2, GSDQSPRD, 9, 23)
    DEP_FIELD(DX2GSR2, GSDQSCAL, 1, 22)
    DEP_FIELD(DX2GSR2, RESERVED_21, 1, 21)
    DEP_FIELD(DX2GSR2, SRDERR, 1, 20)
    DEP_FIELD(DX2GSR2, DQS2DQERR, 8, 12)
    DEP_FIELD(DX2GSR2, ESTAT, 4, 8)
    DEP_FIELD(DX2GSR2, WEWN, 1, 7)
    DEP_FIELD(DX2GSR2, WEERR, 1, 6)
    DEP_FIELD(DX2GSR2, REWN, 1, 5)
    DEP_FIELD(DX2GSR2, REERR, 1, 4)
    DEP_FIELD(DX2GSR2, WDWN, 1, 3)
    DEP_FIELD(DX2GSR2, WDERR, 1, 2)
    DEP_FIELD(DX2GSR2, RDWN, 1, 1)
    DEP_FIELD(DX2GSR2, RDERR, 1, 0)
DEP_REG32(DX2GSR3, 0x9ec)
    DEP_FIELD(DX2GSR3, RESERVED_31_27, 5, 27)
    DEP_FIELD(DX2GSR3, ESTAT, 3, 24)
    DEP_FIELD(DX2GSR3, DVWRN, 4, 20)
    DEP_FIELD(DX2GSR3, DVERR, 4, 16)
    DEP_FIELD(DX2GSR3, HVWRN, 4, 12)
    DEP_FIELD(DX2GSR3, HVERR, 4, 8)
    DEP_FIELD(DX2GSR3, RESERVED_7_2, 6, 2)
    DEP_FIELD(DX2GSR3, SRDPC, 2, 0)
DEP_REG32(DX2GSR4, 0x9f0)
    DEP_FIELD(DX2GSR4, RESERVED_31_26, 6, 26)
    DEP_FIELD(DX2GSR4, RESERVED_25_17, 9, 17)
    DEP_FIELD(DX2GSR4, RESERVED_16, 1, 16)
    DEP_FIELD(DX2GSR4, RESERVED_15_7, 9, 7)
    DEP_FIELD(DX2GSR4, RESERVED_6, 1, 6)
    DEP_FIELD(DX2GSR4, RESERVED_5, 1, 5)
    DEP_FIELD(DX2GSR4, RESERVED_4, 1, 4)
    DEP_FIELD(DX2GSR4, RESERVED_3, 1, 3)
    DEP_FIELD(DX2GSR4, RESERVED_2, 1, 2)
    DEP_FIELD(DX2GSR4, RESERVED_1, 1, 1)
    DEP_FIELD(DX2GSR4, RESERVED_0, 1, 0)
DEP_REG32(DX2GSR5, 0x9f4)
    DEP_FIELD(DX2GSR5, RESERVED_31_23, 9, 23)
    DEP_FIELD(DX2GSR5, RESERVED_22, 1, 22)
    DEP_FIELD(DX2GSR5, RESERVED_21, 1, 21)
    DEP_FIELD(DX2GSR5, RESERVED_20, 1, 20)
    DEP_FIELD(DX2GSR5, RESERVED_19_12, 8, 12)
    DEP_FIELD(DX2GSR5, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX2GSR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX2GSR5, RESERVED_6, 1, 6)
    DEP_FIELD(DX2GSR5, RESERVED_5, 1, 5)
    DEP_FIELD(DX2GSR5, RESERVED_4, 1, 4)
    DEP_FIELD(DX2GSR5, RESERVED_3, 1, 3)
    DEP_FIELD(DX2GSR5, RESERVED_2, 1, 2)
    DEP_FIELD(DX2GSR5, RESERVED_1, 1, 1)
    DEP_FIELD(DX2GSR5, RESERVED_0, 1, 0)
DEP_REG32(DX2GSR6, 0x9f8)
    DEP_FIELD(DX2GSR6, RESERVED_31_24, 8, 24)
    DEP_FIELD(DX2GSR6, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX2GSR6, RESERVED_19_15, 4, 16)
    DEP_FIELD(DX2GSR6, RESERVED_15_12, 4, 12)
    DEP_FIELD(DX2GSR6, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX2GSR6, RESERVED_7_4, 4, 4)
    DEP_FIELD(DX2GSR6, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX2GSR6, RESERVED_1_0, 2, 0)
DEP_REG32(DX3GCR0, 0xa00)
    DEP_FIELD(DX3GCR0, CALBYP, 1, 31)
    DEP_FIELD(DX3GCR0, MDLEN, 1, 30)
    DEP_FIELD(DX3GCR0, CODTSHFT, 2, 28)
    DEP_FIELD(DX3GCR0, DQSDCC, 4, 24)
    DEP_FIELD(DX3GCR0, RDDLY, 4, 20)
    DEP_FIELD(DX3GCR0, RESERVED_19_14, 6, 14)
    DEP_FIELD(DX3GCR0, DQSNSEPDR, 1, 13)
    DEP_FIELD(DX3GCR0, DQSSEPDR, 1, 12)
    DEP_FIELD(DX3GCR0, RTTOAL, 1, 11)
    DEP_FIELD(DX3GCR0, RTTOH, 2, 9)
    DEP_FIELD(DX3GCR0, CPDRSHFT, 2, 7)
    DEP_FIELD(DX3GCR0, DQSRPD, 1, 6)
    DEP_FIELD(DX3GCR0, DQSGPDR, 1, 5)
    DEP_FIELD(DX3GCR0, RESERVED_4, 1, 4)
    DEP_FIELD(DX3GCR0, DQSGODT, 1, 3)
    DEP_FIELD(DX3GCR0, DQSGOE, 1, 2)
    DEP_FIELD(DX3GCR0, RESERVED_1_0, 2, 0)
DEP_REG32(DX3GCR1, 0xa04)
    DEP_FIELD(DX3GCR1, DXPDRMODE, 16, 16)
    DEP_FIELD(DX3GCR1, RESERVED_15, 1, 15)
    DEP_FIELD(DX3GCR1, QSNSEL, 1, 14)
    DEP_FIELD(DX3GCR1, QSSEL, 1, 13)
    DEP_FIELD(DX3GCR1, OEEN, 1, 12)
    DEP_FIELD(DX3GCR1, PDREN, 1, 11)
    DEP_FIELD(DX3GCR1, TEEN, 1, 10)
    DEP_FIELD(DX3GCR1, DSEN, 1, 9)
    DEP_FIELD(DX3GCR1, DMEN, 1, 8)
    DEP_FIELD(DX3GCR1, DQEN, 8, 0)
DEP_REG32(DX3GCR2, 0xa08)
    DEP_FIELD(DX3GCR2, DXOEMODE, 16, 16)
    DEP_FIELD(DX3GCR2, DXTEMODE, 16, 0)
DEP_REG32(DX3GCR3, 0xa0c)
    DEP_FIELD(DX3GCR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX3GCR3, RDBVT, 1, 29)
    DEP_FIELD(DX3GCR3, WDBVT, 1, 28)
    DEP_FIELD(DX3GCR3, RGLVT, 1, 27)
    DEP_FIELD(DX3GCR3, RDLVT, 1, 26)
    DEP_FIELD(DX3GCR3, WDLVT, 1, 25)
    DEP_FIELD(DX3GCR3, WLLVT, 1, 24)
    DEP_FIELD(DX3GCR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX3GCR3, DSNOEMODE, 2, 20)
    DEP_FIELD(DX3GCR3, DSNTEMODE, 2, 18)
    DEP_FIELD(DX3GCR3, DSNPDRMODE, 2, 16)
    DEP_FIELD(DX3GCR3, DMOEMODE, 2, 14)
    DEP_FIELD(DX3GCR3, DMTEMODE, 2, 12)
    DEP_FIELD(DX3GCR3, DMPDRMODE, 2, 10)
    DEP_FIELD(DX3GCR3, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX3GCR3, DSOEMODE, 2, 6)
    DEP_FIELD(DX3GCR3, DSTEMODE, 2, 4)
    DEP_FIELD(DX3GCR3, DSPDRMODE, 2, 2)
    DEP_FIELD(DX3GCR3, RESERVED_1_0, 2, 0)
DEP_REG32(DX3GCR4, 0xa10)
    DEP_FIELD(DX3GCR4, RESERVED_31_29, 3, 29)
    DEP_FIELD(DX3GCR4, DXREFPEN, 1, 28)
    DEP_FIELD(DX3GCR4, DXREFEEN, 2, 26)
    DEP_FIELD(DX3GCR4, DXREFSEN, 1, 25)
    DEP_FIELD(DX3GCR4, RESERVED_24, 1, 24)
    DEP_FIELD(DX3GCR4, DXREFESELRANGE, 1, 23)
    DEP_FIELD(DX3GCR4, DXREFESEL, 7, 16)
    DEP_FIELD(DX3GCR4, DXREFSSELRANGE, 1, 15)
    DEP_FIELD(DX3GCR4, DXREFSSEL, 7, 8)
    DEP_FIELD(DX3GCR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX3GCR4, DXREFIEN, 4, 2)
    DEP_FIELD(DX3GCR4, DXREFIMON, 2, 0)
DEP_REG32(DX3GCR5, 0xa14)
    DEP_FIELD(DX3GCR5, RESERVED_31, 1, 31)
    DEP_FIELD(DX3GCR5, DXREFISELR3, 7, 24)
    DEP_FIELD(DX3GCR5, RESERVED_23, 1, 23)
    DEP_FIELD(DX3GCR5, DXREFISELR2, 7, 16)
    DEP_FIELD(DX3GCR5, RESERVED_15, 1, 15)
    DEP_FIELD(DX3GCR5, DXREFISELR1, 7, 8)
    DEP_FIELD(DX3GCR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX3GCR5, DXREFISELR0, 7, 0)
DEP_REG32(DX3GCR6, 0xa18)
    DEP_FIELD(DX3GCR6, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX3GCR6, DXDQVREFR3, 6, 24)
    DEP_FIELD(DX3GCR6, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX3GCR6, DXDQVREFR2, 6, 16)
    DEP_FIELD(DX3GCR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX3GCR6, DXDQVREFR1, 6, 8)
    DEP_FIELD(DX3GCR6, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX3GCR6, DXDQVREFR0, 6, 0)
DEP_REG32(DX3GCR7, 0xa1c)
    DEP_FIELD(DX3GCR7, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX3GCR7, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX3GCR7, RESERVED_25, 1, 25)
    DEP_FIELD(DX3GCR7, RESERVED_24_23, 2, 23)
    DEP_FIELD(DX3GCR7, RESERVED_22, 1, 22)
    DEP_FIELD(DX3GCR7, RESERVED_21, 1, 21)
    DEP_FIELD(DX3GCR7, RESERVED_20, 1, 20)
    DEP_FIELD(DX3GCR7, RESERVED_19, 1, 19)
    DEP_FIELD(DX3GCR7, RESERVED_18, 1, 18)
    DEP_FIELD(DX3GCR7, RESERVED_17, 1, 17)
    DEP_FIELD(DX3GCR7, RESERVED_16, 1, 16)
    DEP_FIELD(DX3GCR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX3GCR7, RESERVED_13_12, 2, 12)
    DEP_FIELD(DX3GCR7, RESERVED_11_10, 2, 10)
    DEP_FIELD(DX3GCR7, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX3GCR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX3GCR7, RESERVED_5_4, 2, 4)
    DEP_FIELD(DX3GCR7, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX3GCR7, RESERVED_1_0, 2, 0)
DEP_REG32(DX3GCR8, 0xa20)
    DEP_FIELD(DX3GCR8, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX3GCR8, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX3GCR8, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX3GCR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX3GCR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX3GCR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX3GCR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX3GCR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX3GCR9, 0xa24)
    DEP_FIELD(DX3GCR9, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX3GCR9, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX3GCR9, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX3GCR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX3GCR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX3GCR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX3GCR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX3GCR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX3BDLR0, 0xa40)
    DEP_FIELD(DX3BDLR0, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX3BDLR0, DQ3WBD, 6, 24)
    DEP_FIELD(DX3BDLR0, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX3BDLR0, DQ2WBD, 6, 16)
    DEP_FIELD(DX3BDLR0, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX3BDLR0, DQ1WBD, 6, 8)
    DEP_FIELD(DX3BDLR0, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX3BDLR0, DQ0WBD, 6, 0)
DEP_REG32(DX3BDLR1, 0xa44)
    DEP_FIELD(DX3BDLR1, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX3BDLR1, DQ7WBD, 6, 24)
    DEP_FIELD(DX3BDLR1, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX3BDLR1, DQ6WBD, 6, 16)
    DEP_FIELD(DX3BDLR1, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX3BDLR1, DQ5WBD, 6, 8)
    DEP_FIELD(DX3BDLR1, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX3BDLR1, DQ4WBD, 6, 0)
DEP_REG32(DX3BDLR2, 0xa48)
    DEP_FIELD(DX3BDLR2, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX3BDLR2, DSNWBD, 6, 24)
    DEP_FIELD(DX3BDLR2, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX3BDLR2, DSOEBD, 6, 16)
    DEP_FIELD(DX3BDLR2, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX3BDLR2, DSWBD, 6, 8)
    DEP_FIELD(DX3BDLR2, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX3BDLR2, DMWBD, 6, 0)
DEP_REG32(DX3BDLR3, 0xa50)
    DEP_FIELD(DX3BDLR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX3BDLR3, DQ3RBD, 6, 24)
    DEP_FIELD(DX3BDLR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX3BDLR3, DQ2RBD, 6, 16)
    DEP_FIELD(DX3BDLR3, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX3BDLR3, DQ1RBD, 6, 8)
    DEP_FIELD(DX3BDLR3, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX3BDLR3, DQ0RBD, 6, 0)
DEP_REG32(DX3BDLR4, 0xa54)
    DEP_FIELD(DX3BDLR4, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX3BDLR4, DQ7RBD, 6, 24)
    DEP_FIELD(DX3BDLR4, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX3BDLR4, DQ6RBD, 6, 16)
    DEP_FIELD(DX3BDLR4, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX3BDLR4, DQ5RBD, 6, 8)
    DEP_FIELD(DX3BDLR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX3BDLR4, DQ4RBD, 6, 0)
DEP_REG32(DX3BDLR5, 0xa58)
    DEP_FIELD(DX3BDLR5, RESERVED_31_6, 26, 6)
    DEP_FIELD(DX3BDLR5, DMRBD, 6, 0)
DEP_REG32(DX3BDLR6, 0xa60)
    DEP_FIELD(DX3BDLR6, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX3BDLR6, TERBD, 6, 16)
    DEP_FIELD(DX3BDLR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX3BDLR6, PDRBD, 6, 8)
    DEP_FIELD(DX3BDLR6, RESERVED_7_0, 8, 0)
DEP_REG32(DX3BDLR7, 0xa64)
    DEP_FIELD(DX3BDLR7, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX3BDLR7, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX3BDLR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX3BDLR7, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX3BDLR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX3BDLR7, RESERVED_5_0, 6, 0)
DEP_REG32(DX3BDLR8, 0xa68)
    DEP_FIELD(DX3BDLR8, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX3BDLR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX3BDLR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX3BDLR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX3BDLR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX3BDLR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX3BDLR9, 0xa6c)
    DEP_FIELD(DX3BDLR9, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX3BDLR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX3BDLR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX3BDLR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX3BDLR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX3BDLR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX3LCDLR0, 0xa80)
    DEP_FIELD(DX3LCDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX3LCDLR0, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX3LCDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX3LCDLR0, WLD, 9, 0)
DEP_REG32(DX3LCDLR1, 0xa84)
    DEP_FIELD(DX3LCDLR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX3LCDLR1, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX3LCDLR1, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX3LCDLR1, WDQD, 9, 0)
DEP_REG32(DX3LCDLR2, 0xa88)
    DEP_FIELD(DX3LCDLR2, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX3LCDLR2, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX3LCDLR2, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX3LCDLR2, DQSGD, 9, 0)
DEP_REG32(DX3LCDLR3, 0xa8c)
    DEP_FIELD(DX3LCDLR3, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX3LCDLR3, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX3LCDLR3, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX3LCDLR3, RDQSD, 9, 0)
DEP_REG32(DX3LCDLR4, 0xa90)
    DEP_FIELD(DX3LCDLR4, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX3LCDLR4, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX3LCDLR4, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX3LCDLR4, RDQSND, 9, 0)
DEP_REG32(DX3LCDLR5, 0xa94)
    DEP_FIELD(DX3LCDLR5, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX3LCDLR5, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX3LCDLR5, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX3LCDLR5, DQSGSD, 9, 0)
DEP_REG32(DX3MDLR0, 0xaa0)
    DEP_FIELD(DX3MDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX3MDLR0, TPRD, 9, 16)
    DEP_FIELD(DX3MDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX3MDLR0, IPRD, 9, 0)
DEP_REG32(DX3MDLR1, 0xaa4)
    DEP_FIELD(DX3MDLR1, RESERVED_31_9, 23, 9)
    DEP_FIELD(DX3MDLR1, MDLD, 9, 0)
DEP_REG32(DX3GTR0, 0xac0)
    DEP_FIELD(DX3GTR0, RESERVED_31_24, 5, 27)
    DEP_FIELD(DX3GTR0, WDQSL, 3, 24)
    DEP_FIELD(DX3GTR0, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX3GTR0, WLSL, 4, 16)
    DEP_FIELD(DX3GTR0, RESERVED_15_13, 3, 13)
    DEP_FIELD(DX3GTR0, RESERVED_12_8, 5, 8)
    DEP_FIELD(DX3GTR0, RESERVED_7_5, 3, 5)
    DEP_FIELD(DX3GTR0, DGSL, 5, 0)
DEP_REG32(DX3RSR0, 0xad0)
    DEP_FIELD(DX3RSR0, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX3RSR0, QSGERR, 16, 0)
DEP_REG32(DX3RSR1, 0xad4)
    DEP_FIELD(DX3RSR1, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX3RSR1, RDLVLERR, 16, 0)
DEP_REG32(DX3RSR2, 0xad8)
    DEP_FIELD(DX3RSR2, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX3RSR2, WLAWN, 16, 0)
DEP_REG32(DX3RSR3, 0xadc)
    DEP_FIELD(DX3RSR3, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX3RSR3, WLAERR, 16, 0)
DEP_REG32(DX3GSR0, 0xae0)
    DEP_FIELD(DX3GSR0, RESERVED_31, 1, 31)
    DEP_FIELD(DX3GSR0, WLDQ, 1, 30)
    DEP_FIELD(DX3GSR0, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX3GSR0, GDQSPRD, 9, 17)
    DEP_FIELD(DX3GSR0, DPLOCK, 1, 16)
    DEP_FIELD(DX3GSR0, WLPRD, 9, 7)
    DEP_FIELD(DX3GSR0, WLERR, 1, 6)
    DEP_FIELD(DX3GSR0, WLDONE, 1, 5)
    DEP_FIELD(DX3GSR0, WLCAL, 1, 4)
    DEP_FIELD(DX3GSR0, GDQSCAL, 1, 3)
    DEP_FIELD(DX3GSR0, RDQSNCAL, 1, 2)
    DEP_FIELD(DX3GSR0, RDQSCAL, 1, 1)
    DEP_FIELD(DX3GSR0, WDQCAL, 1, 0)
DEP_REG32(DX3GSR1, 0xae4)
    DEP_FIELD(DX3GSR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX3GSR1, DLTCODE, 24, 1)
    DEP_FIELD(DX3GSR1, DLTDONE, 1, 0)
DEP_REG32(DX3GSR2, 0xae8)
    DEP_FIELD(DX3GSR2, GSDQSPRD, 9, 23)
    DEP_FIELD(DX3GSR2, GSDQSCAL, 1, 22)
    DEP_FIELD(DX3GSR2, RESERVED_21, 1, 21)
    DEP_FIELD(DX3GSR2, SRDERR, 1, 20)
    DEP_FIELD(DX3GSR2, DQS2DQERR, 8, 12)
    DEP_FIELD(DX3GSR2, ESTAT, 4, 8)
    DEP_FIELD(DX3GSR2, WEWN, 1, 7)
    DEP_FIELD(DX3GSR2, WEERR, 1, 6)
    DEP_FIELD(DX3GSR2, REWN, 1, 5)
    DEP_FIELD(DX3GSR2, REERR, 1, 4)
    DEP_FIELD(DX3GSR2, WDWN, 1, 3)
    DEP_FIELD(DX3GSR2, WDERR, 1, 2)
    DEP_FIELD(DX3GSR2, RDWN, 1, 1)
    DEP_FIELD(DX3GSR2, RDERR, 1, 0)
DEP_REG32(DX3GSR3, 0xaec)
    DEP_FIELD(DX3GSR3, RESERVED_31_27, 5, 27)
    DEP_FIELD(DX3GSR3, ESTAT, 3, 24)
    DEP_FIELD(DX3GSR3, DVWRN, 4, 20)
    DEP_FIELD(DX3GSR3, DVERR, 4, 16)
    DEP_FIELD(DX3GSR3, HVWRN, 4, 12)
    DEP_FIELD(DX3GSR3, HVERR, 4, 8)
    DEP_FIELD(DX3GSR3, RESERVED_7_2, 6, 2)
    DEP_FIELD(DX3GSR3, SRDPC, 2, 0)
DEP_REG32(DX3GSR4, 0xaf0)
    DEP_FIELD(DX3GSR4, RESERVED_31_26, 6, 26)
    DEP_FIELD(DX3GSR4, RESERVED_25_17, 9, 17)
    DEP_FIELD(DX3GSR4, RESERVED_16, 1, 16)
    DEP_FIELD(DX3GSR4, RESERVED_15_7, 9, 7)
    DEP_FIELD(DX3GSR4, RESERVED_6, 1, 6)
    DEP_FIELD(DX3GSR4, RESERVED_5, 1, 5)
    DEP_FIELD(DX3GSR4, RESERVED_4, 1, 4)
    DEP_FIELD(DX3GSR4, RESERVED_3, 1, 3)
    DEP_FIELD(DX3GSR4, RESERVED_2, 1, 2)
    DEP_FIELD(DX3GSR4, RESERVED_1, 1, 1)
    DEP_FIELD(DX3GSR4, RESERVED_0, 1, 0)
DEP_REG32(DX3GSR5, 0xaf4)
    DEP_FIELD(DX3GSR5, RESERVED_31_23, 9, 23)
    DEP_FIELD(DX3GSR5, RESERVED_22, 1, 22)
    DEP_FIELD(DX3GSR5, RESERVED_21, 1, 21)
    DEP_FIELD(DX3GSR5, RESERVED_20, 1, 20)
    DEP_FIELD(DX3GSR5, RESERVED_19_12, 8, 12)
    DEP_FIELD(DX3GSR5, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX3GSR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX3GSR5, RESERVED_6, 1, 6)
    DEP_FIELD(DX3GSR5, RESERVED_5, 1, 5)
    DEP_FIELD(DX3GSR5, RESERVED_4, 1, 4)
    DEP_FIELD(DX3GSR5, RESERVED_3, 1, 3)
    DEP_FIELD(DX3GSR5, RESERVED_2, 1, 2)
    DEP_FIELD(DX3GSR5, RESERVED_1, 1, 1)
    DEP_FIELD(DX3GSR5, RESERVED_0, 1, 0)
DEP_REG32(DX3GSR6, 0xaf8)
    DEP_FIELD(DX3GSR6, RESERVED_31_24, 8, 24)
    DEP_FIELD(DX3GSR6, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX3GSR6, RESERVED_19_15, 4, 16)
    DEP_FIELD(DX3GSR6, RESERVED_15_12, 4, 12)
    DEP_FIELD(DX3GSR6, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX3GSR6, RESERVED_7_4, 4, 4)
    DEP_FIELD(DX3GSR6, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX3GSR6, RESERVED_1_0, 2, 0)
DEP_REG32(DX4GCR0, 0xb00)
    DEP_FIELD(DX4GCR0, CALBYP, 1, 31)
    DEP_FIELD(DX4GCR0, MDLEN, 1, 30)
    DEP_FIELD(DX4GCR0, CODTSHFT, 2, 28)
    DEP_FIELD(DX4GCR0, DQSDCC, 4, 24)
    DEP_FIELD(DX4GCR0, RDDLY, 4, 20)
    DEP_FIELD(DX4GCR0, RESERVED_19_14, 6, 14)
    DEP_FIELD(DX4GCR0, DQSNSEPDR, 1, 13)
    DEP_FIELD(DX4GCR0, DQSSEPDR, 1, 12)
    DEP_FIELD(DX4GCR0, RTTOAL, 1, 11)
    DEP_FIELD(DX4GCR0, RTTOH, 2, 9)
    DEP_FIELD(DX4GCR0, CPDRSHFT, 2, 7)
    DEP_FIELD(DX4GCR0, DQSRPD, 1, 6)
    DEP_FIELD(DX4GCR0, DQSGPDR, 1, 5)
    DEP_FIELD(DX4GCR0, RESERVED_4, 1, 4)
    DEP_FIELD(DX4GCR0, DQSGODT, 1, 3)
    DEP_FIELD(DX4GCR0, DQSGOE, 1, 2)
    DEP_FIELD(DX4GCR0, RESERVED_1_0, 2, 0)
DEP_REG32(DX4GCR1, 0xb04)
    DEP_FIELD(DX4GCR1, DXPDRMODE, 16, 16)
    DEP_FIELD(DX4GCR1, RESERVED_15, 1, 15)
    DEP_FIELD(DX4GCR1, QSNSEL, 1, 14)
    DEP_FIELD(DX4GCR1, QSSEL, 1, 13)
    DEP_FIELD(DX4GCR1, OEEN, 1, 12)
    DEP_FIELD(DX4GCR1, PDREN, 1, 11)
    DEP_FIELD(DX4GCR1, TEEN, 1, 10)
    DEP_FIELD(DX4GCR1, DSEN, 1, 9)
    DEP_FIELD(DX4GCR1, DMEN, 1, 8)
    DEP_FIELD(DX4GCR1, DQEN, 8, 0)
DEP_REG32(DX4GCR2, 0xb08)
    DEP_FIELD(DX4GCR2, DXOEMODE, 16, 16)
    DEP_FIELD(DX4GCR2, DXTEMODE, 16, 0)
DEP_REG32(DX4GCR3, 0xb0c)
    DEP_FIELD(DX4GCR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX4GCR3, RDBVT, 1, 29)
    DEP_FIELD(DX4GCR3, WDBVT, 1, 28)
    DEP_FIELD(DX4GCR3, RGLVT, 1, 27)
    DEP_FIELD(DX4GCR3, RDLVT, 1, 26)
    DEP_FIELD(DX4GCR3, WDLVT, 1, 25)
    DEP_FIELD(DX4GCR3, WLLVT, 1, 24)
    DEP_FIELD(DX4GCR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX4GCR3, DSNOEMODE, 2, 20)
    DEP_FIELD(DX4GCR3, DSNTEMODE, 2, 18)
    DEP_FIELD(DX4GCR3, DSNPDRMODE, 2, 16)
    DEP_FIELD(DX4GCR3, DMOEMODE, 2, 14)
    DEP_FIELD(DX4GCR3, DMTEMODE, 2, 12)
    DEP_FIELD(DX4GCR3, DMPDRMODE, 2, 10)
    DEP_FIELD(DX4GCR3, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX4GCR3, DSOEMODE, 2, 6)
    DEP_FIELD(DX4GCR3, DSTEMODE, 2, 4)
    DEP_FIELD(DX4GCR3, DSPDRMODE, 2, 2)
    DEP_FIELD(DX4GCR3, RESERVED_1_0, 2, 0)
DEP_REG32(DX4GCR4, 0xb10)
    DEP_FIELD(DX4GCR4, RESERVED_31_29, 3, 29)
    DEP_FIELD(DX4GCR4, DXREFPEN, 1, 28)
    DEP_FIELD(DX4GCR4, DXREFEEN, 2, 26)
    DEP_FIELD(DX4GCR4, DXREFSEN, 1, 25)
    DEP_FIELD(DX4GCR4, RESERVED_24, 1, 24)
    DEP_FIELD(DX4GCR4, DXREFESELRANGE, 1, 23)
    DEP_FIELD(DX4GCR4, DXREFESEL, 7, 16)
    DEP_FIELD(DX4GCR4, DXREFSSELRANGE, 1, 15)
    DEP_FIELD(DX4GCR4, DXREFSSEL, 7, 8)
    DEP_FIELD(DX4GCR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX4GCR4, DXREFIEN, 4, 2)
    DEP_FIELD(DX4GCR4, DXREFIMON, 2, 0)
DEP_REG32(DX4GCR5, 0xb14)
    DEP_FIELD(DX4GCR5, RESERVED_31, 1, 31)
    DEP_FIELD(DX4GCR5, DXREFISELR3, 7, 24)
    DEP_FIELD(DX4GCR5, RESERVED_23, 1, 23)
    DEP_FIELD(DX4GCR5, DXREFISELR2, 7, 16)
    DEP_FIELD(DX4GCR5, RESERVED_15, 1, 15)
    DEP_FIELD(DX4GCR5, DXREFISELR1, 7, 8)
    DEP_FIELD(DX4GCR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX4GCR5, DXREFISELR0, 7, 0)
DEP_REG32(DX4GCR6, 0xb18)
    DEP_FIELD(DX4GCR6, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX4GCR6, DXDQVREFR3, 6, 24)
    DEP_FIELD(DX4GCR6, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX4GCR6, DXDQVREFR2, 6, 16)
    DEP_FIELD(DX4GCR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX4GCR6, DXDQVREFR1, 6, 8)
    DEP_FIELD(DX4GCR6, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX4GCR6, DXDQVREFR0, 6, 0)
DEP_REG32(DX4GCR7, 0xb1c)
    DEP_FIELD(DX4GCR7, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX4GCR7, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX4GCR7, RESERVED_25, 1, 25)
    DEP_FIELD(DX4GCR7, RESERVED_24_23, 2, 23)
    DEP_FIELD(DX4GCR7, RESERVED_22, 1, 22)
    DEP_FIELD(DX4GCR7, RESERVED_21, 1, 21)
    DEP_FIELD(DX4GCR7, RESERVED_20, 1, 20)
    DEP_FIELD(DX4GCR7, RESERVED_19, 1, 19)
    DEP_FIELD(DX4GCR7, RESERVED_18, 1, 18)
    DEP_FIELD(DX4GCR7, RESERVED_17, 1, 17)
    DEP_FIELD(DX4GCR7, RESERVED_16, 1, 16)
    DEP_FIELD(DX4GCR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX4GCR7, RESERVED_13_12, 2, 12)
    DEP_FIELD(DX4GCR7, RESERVED_11_10, 2, 10)
    DEP_FIELD(DX4GCR7, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX4GCR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX4GCR7, RESERVED_5_4, 2, 4)
    DEP_FIELD(DX4GCR7, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX4GCR7, RESERVED_1_0, 2, 0)
DEP_REG32(DX4GCR8, 0xb20)
    DEP_FIELD(DX4GCR8, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX4GCR8, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX4GCR8, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX4GCR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX4GCR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX4GCR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX4GCR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX4GCR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX4GCR9, 0xb24)
    DEP_FIELD(DX4GCR9, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX4GCR9, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX4GCR9, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX4GCR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX4GCR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX4GCR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX4GCR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX4GCR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX4BDLR0, 0xb40)
    DEP_FIELD(DX4BDLR0, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX4BDLR0, DQ3WBD, 6, 24)
    DEP_FIELD(DX4BDLR0, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX4BDLR0, DQ2WBD, 6, 16)
    DEP_FIELD(DX4BDLR0, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX4BDLR0, DQ1WBD, 6, 8)
    DEP_FIELD(DX4BDLR0, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX4BDLR0, DQ0WBD, 6, 0)
DEP_REG32(DX4BDLR1, 0xb44)
    DEP_FIELD(DX4BDLR1, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX4BDLR1, DQ7WBD, 6, 24)
    DEP_FIELD(DX4BDLR1, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX4BDLR1, DQ6WBD, 6, 16)
    DEP_FIELD(DX4BDLR1, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX4BDLR1, DQ5WBD, 6, 8)
    DEP_FIELD(DX4BDLR1, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX4BDLR1, DQ4WBD, 6, 0)
DEP_REG32(DX4BDLR2, 0xb48)
    DEP_FIELD(DX4BDLR2, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX4BDLR2, DSNWBD, 6, 24)
    DEP_FIELD(DX4BDLR2, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX4BDLR2, DSOEBD, 6, 16)
    DEP_FIELD(DX4BDLR2, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX4BDLR2, DSWBD, 6, 8)
    DEP_FIELD(DX4BDLR2, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX4BDLR2, DMWBD, 6, 0)
DEP_REG32(DX4BDLR3, 0xb50)
    DEP_FIELD(DX4BDLR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX4BDLR3, DQ3RBD, 6, 24)
    DEP_FIELD(DX4BDLR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX4BDLR3, DQ2RBD, 6, 16)
    DEP_FIELD(DX4BDLR3, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX4BDLR3, DQ1RBD, 6, 8)
    DEP_FIELD(DX4BDLR3, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX4BDLR3, DQ0RBD, 6, 0)
DEP_REG32(DX4BDLR4, 0xb54)
    DEP_FIELD(DX4BDLR4, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX4BDLR4, DQ7RBD, 6, 24)
    DEP_FIELD(DX4BDLR4, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX4BDLR4, DQ6RBD, 6, 16)
    DEP_FIELD(DX4BDLR4, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX4BDLR4, DQ5RBD, 6, 8)
    DEP_FIELD(DX4BDLR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX4BDLR4, DQ4RBD, 6, 0)
DEP_REG32(DX4BDLR5, 0xb58)
    DEP_FIELD(DX4BDLR5, RESERVED_31_6, 26, 6)
    DEP_FIELD(DX4BDLR5, DMRBD, 6, 0)
DEP_REG32(DX4BDLR6, 0xb60)
    DEP_FIELD(DX4BDLR6, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX4BDLR6, TERBD, 6, 16)
    DEP_FIELD(DX4BDLR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX4BDLR6, PDRBD, 6, 8)
    DEP_FIELD(DX4BDLR6, RESERVED_7_0, 8, 0)
DEP_REG32(DX4BDLR7, 0xb64)
    DEP_FIELD(DX4BDLR7, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX4BDLR7, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX4BDLR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX4BDLR7, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX4BDLR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX4BDLR7, RESERVED_5_0, 6, 0)
DEP_REG32(DX4BDLR8, 0xb68)
    DEP_FIELD(DX4BDLR8, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX4BDLR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX4BDLR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX4BDLR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX4BDLR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX4BDLR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX4BDLR9, 0xb6c)
    DEP_FIELD(DX4BDLR9, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX4BDLR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX4BDLR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX4BDLR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX4BDLR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX4BDLR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX4LCDLR0, 0xb80)
    DEP_FIELD(DX4LCDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX4LCDLR0, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX4LCDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX4LCDLR0, WLD, 9, 0)
DEP_REG32(DX4LCDLR1, 0xb84)
    DEP_FIELD(DX4LCDLR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX4LCDLR1, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX4LCDLR1, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX4LCDLR1, WDQD, 9, 0)
DEP_REG32(DX4LCDLR2, 0xb88)
    DEP_FIELD(DX4LCDLR2, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX4LCDLR2, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX4LCDLR2, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX4LCDLR2, DQSGD, 9, 0)
DEP_REG32(DX4LCDLR3, 0xb8c)
    DEP_FIELD(DX4LCDLR3, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX4LCDLR3, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX4LCDLR3, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX4LCDLR3, RDQSD, 9, 0)
DEP_REG32(DX4LCDLR4, 0xb90)
    DEP_FIELD(DX4LCDLR4, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX4LCDLR4, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX4LCDLR4, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX4LCDLR4, RDQSND, 9, 0)
DEP_REG32(DX4LCDLR5, 0xb94)
    DEP_FIELD(DX4LCDLR5, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX4LCDLR5, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX4LCDLR5, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX4LCDLR5, DQSGSD, 9, 0)
DEP_REG32(DX4MDLR0, 0xba0)
    DEP_FIELD(DX4MDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX4MDLR0, TPRD, 9, 16)
    DEP_FIELD(DX4MDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX4MDLR0, IPRD, 9, 0)
DEP_REG32(DX4MDLR1, 0xba4)
    DEP_FIELD(DX4MDLR1, RESERVED_31_9, 23, 9)
    DEP_FIELD(DX4MDLR1, MDLD, 9, 0)
DEP_REG32(DX4GTR0, 0xbc0)
    DEP_FIELD(DX4GTR0, RESERVED_31_24, 5, 27)
    DEP_FIELD(DX4GTR0, WDQSL, 3, 24)
    DEP_FIELD(DX4GTR0, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX4GTR0, WLSL, 4, 16)
    DEP_FIELD(DX4GTR0, RESERVED_15_13, 3, 13)
    DEP_FIELD(DX4GTR0, RESERVED_12_8, 5, 8)
    DEP_FIELD(DX4GTR0, RESERVED_7_5, 3, 5)
    DEP_FIELD(DX4GTR0, DGSL, 5, 0)
DEP_REG32(DX4RSR0, 0xbd0)
    DEP_FIELD(DX4RSR0, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX4RSR0, QSGERR, 16, 0)
DEP_REG32(DX4RSR1, 0xbd4)
    DEP_FIELD(DX4RSR1, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX4RSR1, RDLVLERR, 16, 0)
DEP_REG32(DX4RSR2, 0xbd8)
    DEP_FIELD(DX4RSR2, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX4RSR2, WLAWN, 16, 0)
DEP_REG32(DX4RSR3, 0xbdc)
    DEP_FIELD(DX4RSR3, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX4RSR3, WLAERR, 16, 0)
DEP_REG32(DX4GSR0, 0xbe0)
    DEP_FIELD(DX4GSR0, RESERVED_31, 1, 31)
    DEP_FIELD(DX4GSR0, WLDQ, 1, 30)
    DEP_FIELD(DX4GSR0, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX4GSR0, GDQSPRD, 9, 17)
    DEP_FIELD(DX4GSR0, DPLOCK, 1, 16)
    DEP_FIELD(DX4GSR0, WLPRD, 9, 7)
    DEP_FIELD(DX4GSR0, WLERR, 1, 6)
    DEP_FIELD(DX4GSR0, WLDONE, 1, 5)
    DEP_FIELD(DX4GSR0, WLCAL, 1, 4)
    DEP_FIELD(DX4GSR0, GDQSCAL, 1, 3)
    DEP_FIELD(DX4GSR0, RDQSNCAL, 1, 2)
    DEP_FIELD(DX4GSR0, RDQSCAL, 1, 1)
    DEP_FIELD(DX4GSR0, WDQCAL, 1, 0)
DEP_REG32(DX4GSR1, 0xbe4)
    DEP_FIELD(DX4GSR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX4GSR1, DLTCODE, 24, 1)
    DEP_FIELD(DX4GSR1, DLTDONE, 1, 0)
DEP_REG32(DX4GSR2, 0xbe8)
    DEP_FIELD(DX4GSR2, GSDQSPRD, 9, 23)
    DEP_FIELD(DX4GSR2, GSDQSCAL, 1, 22)
    DEP_FIELD(DX4GSR2, RESERVED_21, 1, 21)
    DEP_FIELD(DX4GSR2, SRDERR, 1, 20)
    DEP_FIELD(DX4GSR2, DQS2DQERR, 8, 12)
    DEP_FIELD(DX4GSR2, ESTAT, 4, 8)
    DEP_FIELD(DX4GSR2, WEWN, 1, 7)
    DEP_FIELD(DX4GSR2, WEERR, 1, 6)
    DEP_FIELD(DX4GSR2, REWN, 1, 5)
    DEP_FIELD(DX4GSR2, REERR, 1, 4)
    DEP_FIELD(DX4GSR2, WDWN, 1, 3)
    DEP_FIELD(DX4GSR2, WDERR, 1, 2)
    DEP_FIELD(DX4GSR2, RDWN, 1, 1)
    DEP_FIELD(DX4GSR2, RDERR, 1, 0)
DEP_REG32(DX4GSR3, 0xbec)
    DEP_FIELD(DX4GSR3, RESERVED_31_27, 5, 27)
    DEP_FIELD(DX4GSR3, ESTAT, 3, 24)
    DEP_FIELD(DX4GSR3, DVWRN, 4, 20)
    DEP_FIELD(DX4GSR3, DVERR, 4, 16)
    DEP_FIELD(DX4GSR3, HVWRN, 4, 12)
    DEP_FIELD(DX4GSR3, HVERR, 4, 8)
    DEP_FIELD(DX4GSR3, RESERVED_7_2, 6, 2)
    DEP_FIELD(DX4GSR3, SRDPC, 2, 0)
DEP_REG32(DX4GSR4, 0xbf0)
    DEP_FIELD(DX4GSR4, RESERVED_31_26, 6, 26)
    DEP_FIELD(DX4GSR4, RESERVED_25_17, 9, 17)
    DEP_FIELD(DX4GSR4, RESERVED_16, 1, 16)
    DEP_FIELD(DX4GSR4, RESERVED_15_7, 9, 7)
    DEP_FIELD(DX4GSR4, RESERVED_6, 1, 6)
    DEP_FIELD(DX4GSR4, RESERVED_5, 1, 5)
    DEP_FIELD(DX4GSR4, RESERVED_4, 1, 4)
    DEP_FIELD(DX4GSR4, RESERVED_3, 1, 3)
    DEP_FIELD(DX4GSR4, RESERVED_2, 1, 2)
    DEP_FIELD(DX4GSR4, RESERVED_1, 1, 1)
    DEP_FIELD(DX4GSR4, RESERVED_0, 1, 0)
DEP_REG32(DX4GSR5, 0xbf4)
    DEP_FIELD(DX4GSR5, RESERVED_31_23, 9, 23)
    DEP_FIELD(DX4GSR5, RESERVED_22, 1, 22)
    DEP_FIELD(DX4GSR5, RESERVED_21, 1, 21)
    DEP_FIELD(DX4GSR5, RESERVED_20, 1, 20)
    DEP_FIELD(DX4GSR5, RESERVED_19_12, 8, 12)
    DEP_FIELD(DX4GSR5, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX4GSR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX4GSR5, RESERVED_6, 1, 6)
    DEP_FIELD(DX4GSR5, RESERVED_5, 1, 5)
    DEP_FIELD(DX4GSR5, RESERVED_4, 1, 4)
    DEP_FIELD(DX4GSR5, RESERVED_3, 1, 3)
    DEP_FIELD(DX4GSR5, RESERVED_2, 1, 2)
    DEP_FIELD(DX4GSR5, RESERVED_1, 1, 1)
    DEP_FIELD(DX4GSR5, RESERVED_0, 1, 0)
DEP_REG32(DX4GSR6, 0xbf8)
    DEP_FIELD(DX4GSR6, RESERVED_31_24, 8, 24)
    DEP_FIELD(DX4GSR6, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX4GSR6, RESERVED_19_15, 4, 16)
    DEP_FIELD(DX4GSR6, RESERVED_15_12, 4, 12)
    DEP_FIELD(DX4GSR6, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX4GSR6, RESERVED_7_4, 4, 4)
    DEP_FIELD(DX4GSR6, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX4GSR6, RESERVED_1_0, 2, 0)
DEP_REG32(DX5GCR0, 0xc00)
    DEP_FIELD(DX5GCR0, CALBYP, 1, 31)
    DEP_FIELD(DX5GCR0, MDLEN, 1, 30)
    DEP_FIELD(DX5GCR0, CODTSHFT, 2, 28)
    DEP_FIELD(DX5GCR0, DQSDCC, 4, 24)
    DEP_FIELD(DX5GCR0, RDDLY, 4, 20)
    DEP_FIELD(DX5GCR0, RESERVED_19_14, 6, 14)
    DEP_FIELD(DX5GCR0, DQSNSEPDR, 1, 13)
    DEP_FIELD(DX5GCR0, DQSSEPDR, 1, 12)
    DEP_FIELD(DX5GCR0, RTTOAL, 1, 11)
    DEP_FIELD(DX5GCR0, RTTOH, 2, 9)
    DEP_FIELD(DX5GCR0, CPDRSHFT, 2, 7)
    DEP_FIELD(DX5GCR0, DQSRPD, 1, 6)
    DEP_FIELD(DX5GCR0, DQSGPDR, 1, 5)
    DEP_FIELD(DX5GCR0, RESERVED_4, 1, 4)
    DEP_FIELD(DX5GCR0, DQSGODT, 1, 3)
    DEP_FIELD(DX5GCR0, DQSGOE, 1, 2)
    DEP_FIELD(DX5GCR0, RESERVED_1_0, 2, 0)
DEP_REG32(DX5GCR1, 0xc04)
    DEP_FIELD(DX5GCR1, DXPDRMODE, 16, 16)
    DEP_FIELD(DX5GCR1, RESERVED_15, 1, 15)
    DEP_FIELD(DX5GCR1, QSNSEL, 1, 14)
    DEP_FIELD(DX5GCR1, QSSEL, 1, 13)
    DEP_FIELD(DX5GCR1, OEEN, 1, 12)
    DEP_FIELD(DX5GCR1, PDREN, 1, 11)
    DEP_FIELD(DX5GCR1, TEEN, 1, 10)
    DEP_FIELD(DX5GCR1, DSEN, 1, 9)
    DEP_FIELD(DX5GCR1, DMEN, 1, 8)
    DEP_FIELD(DX5GCR1, DQEN, 8, 0)
DEP_REG32(DX5GCR2, 0xc08)
    DEP_FIELD(DX5GCR2, DXOEMODE, 16, 16)
    DEP_FIELD(DX5GCR2, DXTEMODE, 16, 0)
DEP_REG32(DX5GCR3, 0xc0c)
    DEP_FIELD(DX5GCR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX5GCR3, RDBVT, 1, 29)
    DEP_FIELD(DX5GCR3, WDBVT, 1, 28)
    DEP_FIELD(DX5GCR3, RGLVT, 1, 27)
    DEP_FIELD(DX5GCR3, RDLVT, 1, 26)
    DEP_FIELD(DX5GCR3, WDLVT, 1, 25)
    DEP_FIELD(DX5GCR3, WLLVT, 1, 24)
    DEP_FIELD(DX5GCR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX5GCR3, DSNOEMODE, 2, 20)
    DEP_FIELD(DX5GCR3, DSNTEMODE, 2, 18)
    DEP_FIELD(DX5GCR3, DSNPDRMODE, 2, 16)
    DEP_FIELD(DX5GCR3, DMOEMODE, 2, 14)
    DEP_FIELD(DX5GCR3, DMTEMODE, 2, 12)
    DEP_FIELD(DX5GCR3, DMPDRMODE, 2, 10)
    DEP_FIELD(DX5GCR3, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX5GCR3, DSOEMODE, 2, 6)
    DEP_FIELD(DX5GCR3, DSTEMODE, 2, 4)
    DEP_FIELD(DX5GCR3, DSPDRMODE, 2, 2)
    DEP_FIELD(DX5GCR3, RESERVED_1_0, 2, 0)
DEP_REG32(DX5GCR4, 0xc10)
    DEP_FIELD(DX5GCR4, RESERVED_31_29, 3, 29)
    DEP_FIELD(DX5GCR4, DXREFPEN, 1, 28)
    DEP_FIELD(DX5GCR4, DXREFEEN, 2, 26)
    DEP_FIELD(DX5GCR4, DXREFSEN, 1, 25)
    DEP_FIELD(DX5GCR4, RESERVED_24, 1, 24)
    DEP_FIELD(DX5GCR4, DXREFESELRANGE, 1, 23)
    DEP_FIELD(DX5GCR4, DXREFESEL, 7, 16)
    DEP_FIELD(DX5GCR4, DXREFSSELRANGE, 1, 15)
    DEP_FIELD(DX5GCR4, DXREFSSEL, 7, 8)
    DEP_FIELD(DX5GCR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX5GCR4, DXREFIEN, 4, 2)
    DEP_FIELD(DX5GCR4, DXREFIMON, 2, 0)
DEP_REG32(DX5GCR5, 0xc14)
    DEP_FIELD(DX5GCR5, RESERVED_31, 1, 31)
    DEP_FIELD(DX5GCR5, DXREFISELR3, 7, 24)
    DEP_FIELD(DX5GCR5, RESERVED_23, 1, 23)
    DEP_FIELD(DX5GCR5, DXREFISELR2, 7, 16)
    DEP_FIELD(DX5GCR5, RESERVED_15, 1, 15)
    DEP_FIELD(DX5GCR5, DXREFISELR1, 7, 8)
    DEP_FIELD(DX5GCR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX5GCR5, DXREFISELR0, 7, 0)
DEP_REG32(DX5GCR6, 0xc18)
    DEP_FIELD(DX5GCR6, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX5GCR6, DXDQVREFR3, 6, 24)
    DEP_FIELD(DX5GCR6, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX5GCR6, DXDQVREFR2, 6, 16)
    DEP_FIELD(DX5GCR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX5GCR6, DXDQVREFR1, 6, 8)
    DEP_FIELD(DX5GCR6, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX5GCR6, DXDQVREFR0, 6, 0)
DEP_REG32(DX5GCR7, 0xc1c)
    DEP_FIELD(DX5GCR7, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX5GCR7, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX5GCR7, RESERVED_25, 1, 25)
    DEP_FIELD(DX5GCR7, RESERVED_24_23, 2, 23)
    DEP_FIELD(DX5GCR7, RESERVED_22, 1, 22)
    DEP_FIELD(DX5GCR7, RESERVED_21, 1, 21)
    DEP_FIELD(DX5GCR7, RESERVED_20, 1, 20)
    DEP_FIELD(DX5GCR7, RESERVED_19, 1, 19)
    DEP_FIELD(DX5GCR7, RESERVED_18, 1, 18)
    DEP_FIELD(DX5GCR7, RESERVED_17, 1, 17)
    DEP_FIELD(DX5GCR7, RESERVED_16, 1, 16)
    DEP_FIELD(DX5GCR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX5GCR7, RESERVED_13_12, 2, 12)
    DEP_FIELD(DX5GCR7, RESERVED_11_10, 2, 10)
    DEP_FIELD(DX5GCR7, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX5GCR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX5GCR7, RESERVED_5_4, 2, 4)
    DEP_FIELD(DX5GCR7, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX5GCR7, RESERVED_1_0, 2, 0)
DEP_REG32(DX5GCR8, 0xc20)
    DEP_FIELD(DX5GCR8, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX5GCR8, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX5GCR8, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX5GCR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX5GCR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX5GCR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX5GCR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX5GCR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX5GCR9, 0xc24)
    DEP_FIELD(DX5GCR9, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX5GCR9, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX5GCR9, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX5GCR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX5GCR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX5GCR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX5GCR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX5GCR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX5BDLR0, 0xc40)
    DEP_FIELD(DX5BDLR0, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX5BDLR0, DQ3WBD, 6, 24)
    DEP_FIELD(DX5BDLR0, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX5BDLR0, DQ2WBD, 6, 16)
    DEP_FIELD(DX5BDLR0, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX5BDLR0, DQ1WBD, 6, 8)
    DEP_FIELD(DX5BDLR0, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX5BDLR0, DQ0WBD, 6, 0)
DEP_REG32(DX5BDLR1, 0xc44)
    DEP_FIELD(DX5BDLR1, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX5BDLR1, DQ7WBD, 6, 24)
    DEP_FIELD(DX5BDLR1, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX5BDLR1, DQ6WBD, 6, 16)
    DEP_FIELD(DX5BDLR1, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX5BDLR1, DQ5WBD, 6, 8)
    DEP_FIELD(DX5BDLR1, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX5BDLR1, DQ4WBD, 6, 0)
DEP_REG32(DX5BDLR2, 0xc48)
    DEP_FIELD(DX5BDLR2, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX5BDLR2, DSNWBD, 6, 24)
    DEP_FIELD(DX5BDLR2, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX5BDLR2, DSOEBD, 6, 16)
    DEP_FIELD(DX5BDLR2, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX5BDLR2, DSWBD, 6, 8)
    DEP_FIELD(DX5BDLR2, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX5BDLR2, DMWBD, 6, 0)
DEP_REG32(DX5BDLR3, 0xc50)
    DEP_FIELD(DX5BDLR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX5BDLR3, DQ3RBD, 6, 24)
    DEP_FIELD(DX5BDLR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX5BDLR3, DQ2RBD, 6, 16)
    DEP_FIELD(DX5BDLR3, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX5BDLR3, DQ1RBD, 6, 8)
    DEP_FIELD(DX5BDLR3, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX5BDLR3, DQ0RBD, 6, 0)
DEP_REG32(DX5BDLR4, 0xc54)
    DEP_FIELD(DX5BDLR4, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX5BDLR4, DQ7RBD, 6, 24)
    DEP_FIELD(DX5BDLR4, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX5BDLR4, DQ6RBD, 6, 16)
    DEP_FIELD(DX5BDLR4, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX5BDLR4, DQ5RBD, 6, 8)
    DEP_FIELD(DX5BDLR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX5BDLR4, DQ4RBD, 6, 0)
DEP_REG32(DX5BDLR5, 0xc58)
    DEP_FIELD(DX5BDLR5, RESERVED_31_6, 26, 6)
    DEP_FIELD(DX5BDLR5, DMRBD, 6, 0)
DEP_REG32(DX5BDLR6, 0xc60)
    DEP_FIELD(DX5BDLR6, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX5BDLR6, TERBD, 6, 16)
    DEP_FIELD(DX5BDLR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX5BDLR6, PDRBD, 6, 8)
    DEP_FIELD(DX5BDLR6, RESERVED_7_0, 8, 0)
DEP_REG32(DX5BDLR7, 0xc64)
    DEP_FIELD(DX5BDLR7, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX5BDLR7, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX5BDLR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX5BDLR7, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX5BDLR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX5BDLR7, RESERVED_5_0, 6, 0)
DEP_REG32(DX5BDLR8, 0xc68)
    DEP_FIELD(DX5BDLR8, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX5BDLR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX5BDLR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX5BDLR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX5BDLR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX5BDLR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX5BDLR9, 0xc6c)
    DEP_FIELD(DX5BDLR9, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX5BDLR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX5BDLR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX5BDLR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX5BDLR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX5BDLR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX5LCDLR0, 0xc80)
    DEP_FIELD(DX5LCDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX5LCDLR0, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX5LCDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX5LCDLR0, WLD, 9, 0)
DEP_REG32(DX5LCDLR1, 0xc84)
    DEP_FIELD(DX5LCDLR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX5LCDLR1, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX5LCDLR1, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX5LCDLR1, WDQD, 9, 0)
DEP_REG32(DX5LCDLR2, 0xc88)
    DEP_FIELD(DX5LCDLR2, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX5LCDLR2, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX5LCDLR2, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX5LCDLR2, DQSGD, 9, 0)
DEP_REG32(DX5LCDLR3, 0xc8c)
    DEP_FIELD(DX5LCDLR3, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX5LCDLR3, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX5LCDLR3, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX5LCDLR3, RDQSD, 9, 0)
DEP_REG32(DX5LCDLR4, 0xc90)
    DEP_FIELD(DX5LCDLR4, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX5LCDLR4, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX5LCDLR4, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX5LCDLR4, RDQSND, 9, 0)
DEP_REG32(DX5LCDLR5, 0xc94)
    DEP_FIELD(DX5LCDLR5, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX5LCDLR5, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX5LCDLR5, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX5LCDLR5, DQSGSD, 9, 0)
DEP_REG32(DX5MDLR0, 0xca0)
    DEP_FIELD(DX5MDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX5MDLR0, TPRD, 9, 16)
    DEP_FIELD(DX5MDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX5MDLR0, IPRD, 9, 0)
DEP_REG32(DX5MDLR1, 0xca4)
    DEP_FIELD(DX5MDLR1, RESERVED_31_9, 23, 9)
    DEP_FIELD(DX5MDLR1, MDLD, 9, 0)
DEP_REG32(DX5GTR0, 0xcc0)
    DEP_FIELD(DX5GTR0, RESERVED_31_24, 5, 27)
    DEP_FIELD(DX5GTR0, WDQSL, 3, 24)
    DEP_FIELD(DX5GTR0, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX5GTR0, WLSL, 4, 16)
    DEP_FIELD(DX5GTR0, RESERVED_15_13, 3, 13)
    DEP_FIELD(DX5GTR0, RESERVED_12_8, 5, 8)
    DEP_FIELD(DX5GTR0, RESERVED_7_5, 3, 5)
    DEP_FIELD(DX5GTR0, DGSL, 5, 0)
DEP_REG32(DX5RSR0, 0xcd0)
    DEP_FIELD(DX5RSR0, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX5RSR0, QSGERR, 16, 0)
DEP_REG32(DX5RSR1, 0xcd4)
    DEP_FIELD(DX5RSR1, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX5RSR1, RDLVLERR, 16, 0)
DEP_REG32(DX5RSR2, 0xcd8)
    DEP_FIELD(DX5RSR2, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX5RSR2, WLAWN, 16, 0)
DEP_REG32(DX5RSR3, 0xcdc)
    DEP_FIELD(DX5RSR3, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX5RSR3, WLAERR, 16, 0)
DEP_REG32(DX5GSR0, 0xce0)
    DEP_FIELD(DX5GSR0, RESERVED_31, 1, 31)
    DEP_FIELD(DX5GSR0, WLDQ, 1, 30)
    DEP_FIELD(DX5GSR0, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX5GSR0, GDQSPRD, 9, 17)
    DEP_FIELD(DX5GSR0, DPLOCK, 1, 16)
    DEP_FIELD(DX5GSR0, WLPRD, 9, 7)
    DEP_FIELD(DX5GSR0, WLERR, 1, 6)
    DEP_FIELD(DX5GSR0, WLDONE, 1, 5)
    DEP_FIELD(DX5GSR0, WLCAL, 1, 4)
    DEP_FIELD(DX5GSR0, GDQSCAL, 1, 3)
    DEP_FIELD(DX5GSR0, RDQSNCAL, 1, 2)
    DEP_FIELD(DX5GSR0, RDQSCAL, 1, 1)
    DEP_FIELD(DX5GSR0, WDQCAL, 1, 0)
DEP_REG32(DX5GSR1, 0xce4)
    DEP_FIELD(DX5GSR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX5GSR1, DLTCODE, 24, 1)
    DEP_FIELD(DX5GSR1, DLTDONE, 1, 0)
DEP_REG32(DX5GSR2, 0xce8)
    DEP_FIELD(DX5GSR2, GSDQSPRD, 9, 23)
    DEP_FIELD(DX5GSR2, GSDQSCAL, 1, 22)
    DEP_FIELD(DX5GSR2, RESERVED_21, 1, 21)
    DEP_FIELD(DX5GSR2, SRDERR, 1, 20)
    DEP_FIELD(DX5GSR2, DQS2DQERR, 8, 12)
    DEP_FIELD(DX5GSR2, ESTAT, 4, 8)
    DEP_FIELD(DX5GSR2, WEWN, 1, 7)
    DEP_FIELD(DX5GSR2, WEERR, 1, 6)
    DEP_FIELD(DX5GSR2, REWN, 1, 5)
    DEP_FIELD(DX5GSR2, REERR, 1, 4)
    DEP_FIELD(DX5GSR2, WDWN, 1, 3)
    DEP_FIELD(DX5GSR2, WDERR, 1, 2)
    DEP_FIELD(DX5GSR2, RDWN, 1, 1)
    DEP_FIELD(DX5GSR2, RDERR, 1, 0)
DEP_REG32(DX5GSR3, 0xcec)
    DEP_FIELD(DX5GSR3, RESERVED_31_27, 5, 27)
    DEP_FIELD(DX5GSR3, ESTAT, 3, 24)
    DEP_FIELD(DX5GSR3, DVWRN, 4, 20)
    DEP_FIELD(DX5GSR3, DVERR, 4, 16)
    DEP_FIELD(DX5GSR3, HVWRN, 4, 12)
    DEP_FIELD(DX5GSR3, HVERR, 4, 8)
    DEP_FIELD(DX5GSR3, RESERVED_7_2, 6, 2)
    DEP_FIELD(DX5GSR3, SRDPC, 2, 0)
DEP_REG32(DX5GSR4, 0xcf0)
    DEP_FIELD(DX5GSR4, RESERVED_31_26, 6, 26)
    DEP_FIELD(DX5GSR4, RESERVED_25_17, 9, 17)
    DEP_FIELD(DX5GSR4, RESERVED_16, 1, 16)
    DEP_FIELD(DX5GSR4, RESERVED_15_7, 9, 7)
    DEP_FIELD(DX5GSR4, RESERVED_6, 1, 6)
    DEP_FIELD(DX5GSR4, RESERVED_5, 1, 5)
    DEP_FIELD(DX5GSR4, RESERVED_4, 1, 4)
    DEP_FIELD(DX5GSR4, RESERVED_3, 1, 3)
    DEP_FIELD(DX5GSR4, RESERVED_2, 1, 2)
    DEP_FIELD(DX5GSR4, RESERVED_1, 1, 1)
    DEP_FIELD(DX5GSR4, RESERVED_0, 1, 0)
DEP_REG32(DX5GSR5, 0xcf4)
    DEP_FIELD(DX5GSR5, RESERVED_31_23, 9, 23)
    DEP_FIELD(DX5GSR5, RESERVED_22, 1, 22)
    DEP_FIELD(DX5GSR5, RESERVED_21, 1, 21)
    DEP_FIELD(DX5GSR5, RESERVED_20, 1, 20)
    DEP_FIELD(DX5GSR5, RESERVED_19_12, 8, 12)
    DEP_FIELD(DX5GSR5, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX5GSR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX5GSR5, RESERVED_6, 1, 6)
    DEP_FIELD(DX5GSR5, RESERVED_5, 1, 5)
    DEP_FIELD(DX5GSR5, RESERVED_4, 1, 4)
    DEP_FIELD(DX5GSR5, RESERVED_3, 1, 3)
    DEP_FIELD(DX5GSR5, RESERVED_2, 1, 2)
    DEP_FIELD(DX5GSR5, RESERVED_1, 1, 1)
    DEP_FIELD(DX5GSR5, RESERVED_0, 1, 0)
DEP_REG32(DX5GSR6, 0xcf8)
    DEP_FIELD(DX5GSR6, RESERVED_31_24, 8, 24)
    DEP_FIELD(DX5GSR6, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX5GSR6, RESERVED_19_15, 4, 16)
    DEP_FIELD(DX5GSR6, RESERVED_15_12, 4, 12)
    DEP_FIELD(DX5GSR6, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX5GSR6, RESERVED_7_4, 4, 4)
    DEP_FIELD(DX5GSR6, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX5GSR6, RESERVED_1_0, 2, 0)
DEP_REG32(DX6GCR0, 0xd00)
    DEP_FIELD(DX6GCR0, CALBYP, 1, 31)
    DEP_FIELD(DX6GCR0, MDLEN, 1, 30)
    DEP_FIELD(DX6GCR0, CODTSHFT, 2, 28)
    DEP_FIELD(DX6GCR0, DQSDCC, 4, 24)
    DEP_FIELD(DX6GCR0, RDDLY, 4, 20)
    DEP_FIELD(DX6GCR0, RESERVED_19_14, 6, 14)
    DEP_FIELD(DX6GCR0, DQSNSEPDR, 1, 13)
    DEP_FIELD(DX6GCR0, DQSSEPDR, 1, 12)
    DEP_FIELD(DX6GCR0, RTTOAL, 1, 11)
    DEP_FIELD(DX6GCR0, RTTOH, 2, 9)
    DEP_FIELD(DX6GCR0, CPDRSHFT, 2, 7)
    DEP_FIELD(DX6GCR0, DQSRPD, 1, 6)
    DEP_FIELD(DX6GCR0, DQSGPDR, 1, 5)
    DEP_FIELD(DX6GCR0, RESERVED_4, 1, 4)
    DEP_FIELD(DX6GCR0, DQSGODT, 1, 3)
    DEP_FIELD(DX6GCR0, DQSGOE, 1, 2)
    DEP_FIELD(DX6GCR0, RESERVED_1_0, 2, 0)
DEP_REG32(DX6GCR1, 0xd04)
    DEP_FIELD(DX6GCR1, DXPDRMODE, 16, 16)
    DEP_FIELD(DX6GCR1, RESERVED_15, 1, 15)
    DEP_FIELD(DX6GCR1, QSNSEL, 1, 14)
    DEP_FIELD(DX6GCR1, QSSEL, 1, 13)
    DEP_FIELD(DX6GCR1, OEEN, 1, 12)
    DEP_FIELD(DX6GCR1, PDREN, 1, 11)
    DEP_FIELD(DX6GCR1, TEEN, 1, 10)
    DEP_FIELD(DX6GCR1, DSEN, 1, 9)
    DEP_FIELD(DX6GCR1, DMEN, 1, 8)
    DEP_FIELD(DX6GCR1, DQEN, 8, 0)
DEP_REG32(DX6GCR2, 0xd08)
    DEP_FIELD(DX6GCR2, DXOEMODE, 16, 16)
    DEP_FIELD(DX6GCR2, DXTEMODE, 16, 0)
DEP_REG32(DX6GCR3, 0xd0c)
    DEP_FIELD(DX6GCR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX6GCR3, RDBVT, 1, 29)
    DEP_FIELD(DX6GCR3, WDBVT, 1, 28)
    DEP_FIELD(DX6GCR3, RGLVT, 1, 27)
    DEP_FIELD(DX6GCR3, RDLVT, 1, 26)
    DEP_FIELD(DX6GCR3, WDLVT, 1, 25)
    DEP_FIELD(DX6GCR3, WLLVT, 1, 24)
    DEP_FIELD(DX6GCR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX6GCR3, DSNOEMODE, 2, 20)
    DEP_FIELD(DX6GCR3, DSNTEMODE, 2, 18)
    DEP_FIELD(DX6GCR3, DSNPDRMODE, 2, 16)
    DEP_FIELD(DX6GCR3, DMOEMODE, 2, 14)
    DEP_FIELD(DX6GCR3, DMTEMODE, 2, 12)
    DEP_FIELD(DX6GCR3, DMPDRMODE, 2, 10)
    DEP_FIELD(DX6GCR3, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX6GCR3, DSOEMODE, 2, 6)
    DEP_FIELD(DX6GCR3, DSTEMODE, 2, 4)
    DEP_FIELD(DX6GCR3, DSPDRMODE, 2, 2)
    DEP_FIELD(DX6GCR3, RESERVED_1_0, 2, 0)
DEP_REG32(DX6GCR4, 0xd10)
    DEP_FIELD(DX6GCR4, RESERVED_31_29, 3, 29)
    DEP_FIELD(DX6GCR4, DXREFPEN, 1, 28)
    DEP_FIELD(DX6GCR4, DXREFEEN, 2, 26)
    DEP_FIELD(DX6GCR4, DXREFSEN, 1, 25)
    DEP_FIELD(DX6GCR4, RESERVED_24, 1, 24)
    DEP_FIELD(DX6GCR4, DXREFESELRANGE, 1, 23)
    DEP_FIELD(DX6GCR4, DXREFESEL, 7, 16)
    DEP_FIELD(DX6GCR4, DXREFSSELRANGE, 1, 15)
    DEP_FIELD(DX6GCR4, DXREFSSEL, 7, 8)
    DEP_FIELD(DX6GCR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX6GCR4, DXREFIEN, 4, 2)
    DEP_FIELD(DX6GCR4, DXREFIMON, 2, 0)
DEP_REG32(DX6GCR5, 0xd14)
    DEP_FIELD(DX6GCR5, RESERVED_31, 1, 31)
    DEP_FIELD(DX6GCR5, DXREFISELR3, 7, 24)
    DEP_FIELD(DX6GCR5, RESERVED_23, 1, 23)
    DEP_FIELD(DX6GCR5, DXREFISELR2, 7, 16)
    DEP_FIELD(DX6GCR5, RESERVED_15, 1, 15)
    DEP_FIELD(DX6GCR5, DXREFISELR1, 7, 8)
    DEP_FIELD(DX6GCR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX6GCR5, DXREFISELR0, 7, 0)
DEP_REG32(DX6GCR6, 0xd18)
    DEP_FIELD(DX6GCR6, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX6GCR6, DXDQVREFR3, 6, 24)
    DEP_FIELD(DX6GCR6, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX6GCR6, DXDQVREFR2, 6, 16)
    DEP_FIELD(DX6GCR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX6GCR6, DXDQVREFR1, 6, 8)
    DEP_FIELD(DX6GCR6, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX6GCR6, DXDQVREFR0, 6, 0)
DEP_REG32(DX6GCR7, 0xd1c)
    DEP_FIELD(DX6GCR7, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX6GCR7, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX6GCR7, RESERVED_25, 1, 25)
    DEP_FIELD(DX6GCR7, RESERVED_24_23, 2, 23)
    DEP_FIELD(DX6GCR7, RESERVED_22, 1, 22)
    DEP_FIELD(DX6GCR7, RESERVED_21, 1, 21)
    DEP_FIELD(DX6GCR7, RESERVED_20, 1, 20)
    DEP_FIELD(DX6GCR7, RESERVED_19, 1, 19)
    DEP_FIELD(DX6GCR7, RESERVED_18, 1, 18)
    DEP_FIELD(DX6GCR7, RESERVED_17, 1, 17)
    DEP_FIELD(DX6GCR7, RESERVED_16, 1, 16)
    DEP_FIELD(DX6GCR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX6GCR7, RESERVED_13_12, 2, 12)
    DEP_FIELD(DX6GCR7, RESERVED_11_10, 2, 10)
    DEP_FIELD(DX6GCR7, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX6GCR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX6GCR7, RESERVED_5_4, 2, 4)
    DEP_FIELD(DX6GCR7, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX6GCR7, RESERVED_1_0, 2, 0)
DEP_REG32(DX6GCR8, 0xd20)
    DEP_FIELD(DX6GCR8, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX6GCR8, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX6GCR8, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX6GCR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX6GCR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX6GCR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX6GCR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX6GCR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX6GCR9, 0xd24)
    DEP_FIELD(DX6GCR9, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX6GCR9, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX6GCR9, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX6GCR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX6GCR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX6GCR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX6GCR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX6GCR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX6BDLR0, 0xd40)
    DEP_FIELD(DX6BDLR0, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX6BDLR0, DQ3WBD, 6, 24)
    DEP_FIELD(DX6BDLR0, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX6BDLR0, DQ2WBD, 6, 16)
    DEP_FIELD(DX6BDLR0, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX6BDLR0, DQ1WBD, 6, 8)
    DEP_FIELD(DX6BDLR0, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX6BDLR0, DQ0WBD, 6, 0)
DEP_REG32(DX6BDLR1, 0xd44)
    DEP_FIELD(DX6BDLR1, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX6BDLR1, DQ7WBD, 6, 24)
    DEP_FIELD(DX6BDLR1, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX6BDLR1, DQ6WBD, 6, 16)
    DEP_FIELD(DX6BDLR1, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX6BDLR1, DQ5WBD, 6, 8)
    DEP_FIELD(DX6BDLR1, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX6BDLR1, DQ4WBD, 6, 0)
DEP_REG32(DX6BDLR2, 0xd48)
    DEP_FIELD(DX6BDLR2, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX6BDLR2, DSNWBD, 6, 24)
    DEP_FIELD(DX6BDLR2, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX6BDLR2, DSOEBD, 6, 16)
    DEP_FIELD(DX6BDLR2, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX6BDLR2, DSWBD, 6, 8)
    DEP_FIELD(DX6BDLR2, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX6BDLR2, DMWBD, 6, 0)
DEP_REG32(DX6BDLR3, 0xd50)
    DEP_FIELD(DX6BDLR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX6BDLR3, DQ3RBD, 6, 24)
    DEP_FIELD(DX6BDLR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX6BDLR3, DQ2RBD, 6, 16)
    DEP_FIELD(DX6BDLR3, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX6BDLR3, DQ1RBD, 6, 8)
    DEP_FIELD(DX6BDLR3, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX6BDLR3, DQ0RBD, 6, 0)
DEP_REG32(DX6BDLR4, 0xd54)
    DEP_FIELD(DX6BDLR4, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX6BDLR4, DQ7RBD, 6, 24)
    DEP_FIELD(DX6BDLR4, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX6BDLR4, DQ6RBD, 6, 16)
    DEP_FIELD(DX6BDLR4, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX6BDLR4, DQ5RBD, 6, 8)
    DEP_FIELD(DX6BDLR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX6BDLR4, DQ4RBD, 6, 0)
DEP_REG32(DX6BDLR5, 0xd58)
    DEP_FIELD(DX6BDLR5, RESERVED_31_6, 26, 6)
    DEP_FIELD(DX6BDLR5, DMRBD, 6, 0)
DEP_REG32(DX6BDLR6, 0xd60)
    DEP_FIELD(DX6BDLR6, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX6BDLR6, TERBD, 6, 16)
    DEP_FIELD(DX6BDLR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX6BDLR6, PDRBD, 6, 8)
    DEP_FIELD(DX6BDLR6, RESERVED_7_0, 8, 0)
DEP_REG32(DX6BDLR7, 0xd64)
    DEP_FIELD(DX6BDLR7, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX6BDLR7, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX6BDLR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX6BDLR7, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX6BDLR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX6BDLR7, RESERVED_5_0, 6, 0)
DEP_REG32(DX6BDLR8, 0xd68)
    DEP_FIELD(DX6BDLR8, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX6BDLR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX6BDLR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX6BDLR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX6BDLR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX6BDLR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX6BDLR9, 0xd6c)
    DEP_FIELD(DX6BDLR9, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX6BDLR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX6BDLR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX6BDLR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX6BDLR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX6BDLR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX6LCDLR0, 0xd80)
    DEP_FIELD(DX6LCDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX6LCDLR0, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX6LCDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX6LCDLR0, WLD, 9, 0)
DEP_REG32(DX6LCDLR1, 0xd84)
    DEP_FIELD(DX6LCDLR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX6LCDLR1, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX6LCDLR1, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX6LCDLR1, WDQD, 9, 0)
DEP_REG32(DX6LCDLR2, 0xd88)
    DEP_FIELD(DX6LCDLR2, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX6LCDLR2, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX6LCDLR2, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX6LCDLR2, DQSGD, 9, 0)
DEP_REG32(DX6LCDLR3, 0xd8c)
    DEP_FIELD(DX6LCDLR3, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX6LCDLR3, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX6LCDLR3, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX6LCDLR3, RDQSD, 9, 0)
DEP_REG32(DX6LCDLR4, 0xd90)
    DEP_FIELD(DX6LCDLR4, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX6LCDLR4, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX6LCDLR4, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX6LCDLR4, RDQSND, 9, 0)
DEP_REG32(DX6LCDLR5, 0xd94)
    DEP_FIELD(DX6LCDLR5, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX6LCDLR5, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX6LCDLR5, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX6LCDLR5, DQSGSD, 9, 0)
DEP_REG32(DX6MDLR0, 0xda0)
    DEP_FIELD(DX6MDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX6MDLR0, TPRD, 9, 16)
    DEP_FIELD(DX6MDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX6MDLR0, IPRD, 9, 0)
DEP_REG32(DX6MDLR1, 0xda4)
    DEP_FIELD(DX6MDLR1, RESERVED_31_9, 23, 9)
    DEP_FIELD(DX6MDLR1, MDLD, 9, 0)
DEP_REG32(DX6GTR0, 0xdc0)
    DEP_FIELD(DX6GTR0, RESERVED_31_24, 5, 27)
    DEP_FIELD(DX6GTR0, WDQSL, 3, 24)
    DEP_FIELD(DX6GTR0, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX6GTR0, WLSL, 4, 16)
    DEP_FIELD(DX6GTR0, RESERVED_15_13, 3, 13)
    DEP_FIELD(DX6GTR0, RESERVED_12_8, 5, 8)
    DEP_FIELD(DX6GTR0, RESERVED_7_5, 3, 5)
    DEP_FIELD(DX6GTR0, DGSL, 5, 0)
DEP_REG32(DX6RSR0, 0xdd0)
    DEP_FIELD(DX6RSR0, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX6RSR0, QSGERR, 16, 0)
DEP_REG32(DX6RSR1, 0xdd4)
    DEP_FIELD(DX6RSR1, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX6RSR1, RDLVLERR, 16, 0)
DEP_REG32(DX6RSR2, 0xdd8)
    DEP_FIELD(DX6RSR2, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX6RSR2, WLAWN, 16, 0)
DEP_REG32(DX6RSR3, 0xddc)
    DEP_FIELD(DX6RSR3, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX6RSR3, WLAERR, 16, 0)
DEP_REG32(DX6GSR0, 0xde0)
    DEP_FIELD(DX6GSR0, RESERVED_31, 1, 31)
    DEP_FIELD(DX6GSR0, WLDQ, 1, 30)
    DEP_FIELD(DX6GSR0, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX6GSR0, GDQSPRD, 9, 17)
    DEP_FIELD(DX6GSR0, DPLOCK, 1, 16)
    DEP_FIELD(DX6GSR0, WLPRD, 9, 7)
    DEP_FIELD(DX6GSR0, WLERR, 1, 6)
    DEP_FIELD(DX6GSR0, WLDONE, 1, 5)
    DEP_FIELD(DX6GSR0, WLCAL, 1, 4)
    DEP_FIELD(DX6GSR0, GDQSCAL, 1, 3)
    DEP_FIELD(DX6GSR0, RDQSNCAL, 1, 2)
    DEP_FIELD(DX6GSR0, RDQSCAL, 1, 1)
    DEP_FIELD(DX6GSR0, WDQCAL, 1, 0)
DEP_REG32(DX6GSR1, 0xde4)
    DEP_FIELD(DX6GSR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX6GSR1, DLTCODE, 24, 1)
    DEP_FIELD(DX6GSR1, DLTDONE, 1, 0)
DEP_REG32(DX6GSR2, 0xde8)
    DEP_FIELD(DX6GSR2, GSDQSPRD, 9, 23)
    DEP_FIELD(DX6GSR2, GSDQSCAL, 1, 22)
    DEP_FIELD(DX6GSR2, RESERVED_21, 1, 21)
    DEP_FIELD(DX6GSR2, SRDERR, 1, 20)
    DEP_FIELD(DX6GSR2, DQS2DQERR, 8, 12)
    DEP_FIELD(DX6GSR2, ESTAT, 4, 8)
    DEP_FIELD(DX6GSR2, WEWN, 1, 7)
    DEP_FIELD(DX6GSR2, WEERR, 1, 6)
    DEP_FIELD(DX6GSR2, REWN, 1, 5)
    DEP_FIELD(DX6GSR2, REERR, 1, 4)
    DEP_FIELD(DX6GSR2, WDWN, 1, 3)
    DEP_FIELD(DX6GSR2, WDERR, 1, 2)
    DEP_FIELD(DX6GSR2, RDWN, 1, 1)
    DEP_FIELD(DX6GSR2, RDERR, 1, 0)
DEP_REG32(DX6GSR3, 0xdec)
    DEP_FIELD(DX6GSR3, RESERVED_31_27, 5, 27)
    DEP_FIELD(DX6GSR3, ESTAT, 3, 24)
    DEP_FIELD(DX6GSR3, DVWRN, 4, 20)
    DEP_FIELD(DX6GSR3, DVERR, 4, 16)
    DEP_FIELD(DX6GSR3, HVWRN, 4, 12)
    DEP_FIELD(DX6GSR3, HVERR, 4, 8)
    DEP_FIELD(DX6GSR3, RESERVED_7_2, 6, 2)
    DEP_FIELD(DX6GSR3, SRDPC, 2, 0)
DEP_REG32(DX6GSR4, 0xdf0)
    DEP_FIELD(DX6GSR4, RESERVED_31_26, 6, 26)
    DEP_FIELD(DX6GSR4, RESERVED_25_17, 9, 17)
    DEP_FIELD(DX6GSR4, RESERVED_16, 1, 16)
    DEP_FIELD(DX6GSR4, RESERVED_15_7, 9, 7)
    DEP_FIELD(DX6GSR4, RESERVED_6, 1, 6)
    DEP_FIELD(DX6GSR4, RESERVED_5, 1, 5)
    DEP_FIELD(DX6GSR4, RESERVED_4, 1, 4)
    DEP_FIELD(DX6GSR4, RESERVED_3, 1, 3)
    DEP_FIELD(DX6GSR4, RESERVED_2, 1, 2)
    DEP_FIELD(DX6GSR4, RESERVED_1, 1, 1)
    DEP_FIELD(DX6GSR4, RESERVED_0, 1, 0)
DEP_REG32(DX6GSR5, 0xdf4)
    DEP_FIELD(DX6GSR5, RESERVED_31_23, 9, 23)
    DEP_FIELD(DX6GSR5, RESERVED_22, 1, 22)
    DEP_FIELD(DX6GSR5, RESERVED_21, 1, 21)
    DEP_FIELD(DX6GSR5, RESERVED_20, 1, 20)
    DEP_FIELD(DX6GSR5, RESERVED_19_12, 8, 12)
    DEP_FIELD(DX6GSR5, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX6GSR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX6GSR5, RESERVED_6, 1, 6)
    DEP_FIELD(DX6GSR5, RESERVED_5, 1, 5)
    DEP_FIELD(DX6GSR5, RESERVED_4, 1, 4)
    DEP_FIELD(DX6GSR5, RESERVED_3, 1, 3)
    DEP_FIELD(DX6GSR5, RESERVED_2, 1, 2)
    DEP_FIELD(DX6GSR5, RESERVED_1, 1, 1)
    DEP_FIELD(DX6GSR5, RESERVED_0, 1, 0)
DEP_REG32(DX6GSR6, 0xdf8)
    DEP_FIELD(DX6GSR6, RESERVED_31_24, 8, 24)
    DEP_FIELD(DX6GSR6, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX6GSR6, RESERVED_19_15, 4, 16)
    DEP_FIELD(DX6GSR6, RESERVED_15_12, 4, 12)
    DEP_FIELD(DX6GSR6, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX6GSR6, RESERVED_7_4, 4, 4)
    DEP_FIELD(DX6GSR6, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX6GSR6, RESERVED_1_0, 2, 0)
DEP_REG32(DX7GCR0, 0xe00)
    DEP_FIELD(DX7GCR0, CALBYP, 1, 31)
    DEP_FIELD(DX7GCR0, MDLEN, 1, 30)
    DEP_FIELD(DX7GCR0, CODTSHFT, 2, 28)
    DEP_FIELD(DX7GCR0, DQSDCC, 4, 24)
    DEP_FIELD(DX7GCR0, RDDLY, 4, 20)
    DEP_FIELD(DX7GCR0, RESERVED_19_14, 6, 14)
    DEP_FIELD(DX7GCR0, DQSNSEPDR, 1, 13)
    DEP_FIELD(DX7GCR0, DQSSEPDR, 1, 12)
    DEP_FIELD(DX7GCR0, RTTOAL, 1, 11)
    DEP_FIELD(DX7GCR0, RTTOH, 2, 9)
    DEP_FIELD(DX7GCR0, CPDRSHFT, 2, 7)
    DEP_FIELD(DX7GCR0, DQSRPD, 1, 6)
    DEP_FIELD(DX7GCR0, DQSGPDR, 1, 5)
    DEP_FIELD(DX7GCR0, RESERVED_4, 1, 4)
    DEP_FIELD(DX7GCR0, DQSGODT, 1, 3)
    DEP_FIELD(DX7GCR0, DQSGOE, 1, 2)
    DEP_FIELD(DX7GCR0, RESERVED_1_0, 2, 0)
DEP_REG32(DX7GCR1, 0xe04)
    DEP_FIELD(DX7GCR1, DXPDRMODE, 16, 16)
    DEP_FIELD(DX7GCR1, RESERVED_15, 1, 15)
    DEP_FIELD(DX7GCR1, QSNSEL, 1, 14)
    DEP_FIELD(DX7GCR1, QSSEL, 1, 13)
    DEP_FIELD(DX7GCR1, OEEN, 1, 12)
    DEP_FIELD(DX7GCR1, PDREN, 1, 11)
    DEP_FIELD(DX7GCR1, TEEN, 1, 10)
    DEP_FIELD(DX7GCR1, DSEN, 1, 9)
    DEP_FIELD(DX7GCR1, DMEN, 1, 8)
    DEP_FIELD(DX7GCR1, DQEN, 8, 0)
DEP_REG32(DX7GCR2, 0xe08)
    DEP_FIELD(DX7GCR2, DXOEMODE, 16, 16)
    DEP_FIELD(DX7GCR2, DXTEMODE, 16, 0)
DEP_REG32(DX7GCR3, 0xe0c)
    DEP_FIELD(DX7GCR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX7GCR3, RDBVT, 1, 29)
    DEP_FIELD(DX7GCR3, WDBVT, 1, 28)
    DEP_FIELD(DX7GCR3, RGLVT, 1, 27)
    DEP_FIELD(DX7GCR3, RDLVT, 1, 26)
    DEP_FIELD(DX7GCR3, WDLVT, 1, 25)
    DEP_FIELD(DX7GCR3, WLLVT, 1, 24)
    DEP_FIELD(DX7GCR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX7GCR3, DSNOEMODE, 2, 20)
    DEP_FIELD(DX7GCR3, DSNTEMODE, 2, 18)
    DEP_FIELD(DX7GCR3, DSNPDRMODE, 2, 16)
    DEP_FIELD(DX7GCR3, DMOEMODE, 2, 14)
    DEP_FIELD(DX7GCR3, DMTEMODE, 2, 12)
    DEP_FIELD(DX7GCR3, DMPDRMODE, 2, 10)
    DEP_FIELD(DX7GCR3, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX7GCR3, DSOEMODE, 2, 6)
    DEP_FIELD(DX7GCR3, DSTEMODE, 2, 4)
    DEP_FIELD(DX7GCR3, DSPDRMODE, 2, 2)
    DEP_FIELD(DX7GCR3, RESERVED_1_0, 2, 0)
DEP_REG32(DX7GCR4, 0xe10)
    DEP_FIELD(DX7GCR4, RESERVED_31_29, 3, 29)
    DEP_FIELD(DX7GCR4, DXREFPEN, 1, 28)
    DEP_FIELD(DX7GCR4, DXREFEEN, 2, 26)
    DEP_FIELD(DX7GCR4, DXREFSEN, 1, 25)
    DEP_FIELD(DX7GCR4, RESERVED_24, 1, 24)
    DEP_FIELD(DX7GCR4, DXREFESELRANGE, 1, 23)
    DEP_FIELD(DX7GCR4, DXREFESEL, 7, 16)
    DEP_FIELD(DX7GCR4, DXREFSSELRANGE, 1, 15)
    DEP_FIELD(DX7GCR4, DXREFSSEL, 7, 8)
    DEP_FIELD(DX7GCR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX7GCR4, DXREFIEN, 4, 2)
    DEP_FIELD(DX7GCR4, DXREFIMON, 2, 0)
DEP_REG32(DX7GCR5, 0xe14)
    DEP_FIELD(DX7GCR5, RESERVED_31, 1, 31)
    DEP_FIELD(DX7GCR5, DXREFISELR3, 7, 24)
    DEP_FIELD(DX7GCR5, RESERVED_23, 1, 23)
    DEP_FIELD(DX7GCR5, DXREFISELR2, 7, 16)
    DEP_FIELD(DX7GCR5, RESERVED_15, 1, 15)
    DEP_FIELD(DX7GCR5, DXREFISELR1, 7, 8)
    DEP_FIELD(DX7GCR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX7GCR5, DXREFISELR0, 7, 0)
DEP_REG32(DX7GCR6, 0xe18)
    DEP_FIELD(DX7GCR6, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX7GCR6, DXDQVREFR3, 6, 24)
    DEP_FIELD(DX7GCR6, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX7GCR6, DXDQVREFR2, 6, 16)
    DEP_FIELD(DX7GCR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX7GCR6, DXDQVREFR1, 6, 8)
    DEP_FIELD(DX7GCR6, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX7GCR6, DXDQVREFR0, 6, 0)
DEP_REG32(DX7GCR7, 0xe1c)
    DEP_FIELD(DX7GCR7, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX7GCR7, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX7GCR7, RESERVED_25, 1, 25)
    DEP_FIELD(DX7GCR7, RESERVED_24_23, 2, 23)
    DEP_FIELD(DX7GCR7, RESERVED_22, 1, 22)
    DEP_FIELD(DX7GCR7, RESERVED_21, 1, 21)
    DEP_FIELD(DX7GCR7, RESERVED_20, 1, 20)
    DEP_FIELD(DX7GCR7, RESERVED_19, 1, 19)
    DEP_FIELD(DX7GCR7, RESERVED_18, 1, 18)
    DEP_FIELD(DX7GCR7, RESERVED_17, 1, 17)
    DEP_FIELD(DX7GCR7, RESERVED_16, 1, 16)
    DEP_FIELD(DX7GCR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX7GCR7, RESERVED_13_12, 2, 12)
    DEP_FIELD(DX7GCR7, RESERVED_11_10, 2, 10)
    DEP_FIELD(DX7GCR7, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX7GCR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX7GCR7, RESERVED_5_4, 2, 4)
    DEP_FIELD(DX7GCR7, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX7GCR7, RESERVED_1_0, 2, 0)
DEP_REG32(DX7GCR8, 0xe20)
    DEP_FIELD(DX7GCR8, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX7GCR8, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX7GCR8, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX7GCR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX7GCR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX7GCR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX7GCR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX7GCR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX7GCR9, 0xe24)
    DEP_FIELD(DX7GCR9, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX7GCR9, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX7GCR9, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX7GCR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX7GCR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX7GCR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX7GCR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX7GCR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX7BDLR0, 0xe40)
    DEP_FIELD(DX7BDLR0, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX7BDLR0, DQ3WBD, 6, 24)
    DEP_FIELD(DX7BDLR0, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX7BDLR0, DQ2WBD, 6, 16)
    DEP_FIELD(DX7BDLR0, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX7BDLR0, DQ1WBD, 6, 8)
    DEP_FIELD(DX7BDLR0, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX7BDLR0, DQ0WBD, 6, 0)
DEP_REG32(DX7BDLR1, 0xe44)
    DEP_FIELD(DX7BDLR1, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX7BDLR1, DQ7WBD, 6, 24)
    DEP_FIELD(DX7BDLR1, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX7BDLR1, DQ6WBD, 6, 16)
    DEP_FIELD(DX7BDLR1, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX7BDLR1, DQ5WBD, 6, 8)
    DEP_FIELD(DX7BDLR1, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX7BDLR1, DQ4WBD, 6, 0)
DEP_REG32(DX7BDLR2, 0xe48)
    DEP_FIELD(DX7BDLR2, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX7BDLR2, DSNWBD, 6, 24)
    DEP_FIELD(DX7BDLR2, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX7BDLR2, DSOEBD, 6, 16)
    DEP_FIELD(DX7BDLR2, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX7BDLR2, DSWBD, 6, 8)
    DEP_FIELD(DX7BDLR2, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX7BDLR2, DMWBD, 6, 0)
DEP_REG32(DX7BDLR3, 0xe50)
    DEP_FIELD(DX7BDLR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX7BDLR3, DQ3RBD, 6, 24)
    DEP_FIELD(DX7BDLR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX7BDLR3, DQ2RBD, 6, 16)
    DEP_FIELD(DX7BDLR3, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX7BDLR3, DQ1RBD, 6, 8)
    DEP_FIELD(DX7BDLR3, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX7BDLR3, DQ0RBD, 6, 0)
DEP_REG32(DX7BDLR4, 0xe54)
    DEP_FIELD(DX7BDLR4, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX7BDLR4, DQ7RBD, 6, 24)
    DEP_FIELD(DX7BDLR4, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX7BDLR4, DQ6RBD, 6, 16)
    DEP_FIELD(DX7BDLR4, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX7BDLR4, DQ5RBD, 6, 8)
    DEP_FIELD(DX7BDLR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX7BDLR4, DQ4RBD, 6, 0)
DEP_REG32(DX7BDLR5, 0xe58)
    DEP_FIELD(DX7BDLR5, RESERVED_31_6, 26, 6)
    DEP_FIELD(DX7BDLR5, DMRBD, 6, 0)
DEP_REG32(DX7BDLR6, 0xe60)
    DEP_FIELD(DX7BDLR6, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX7BDLR6, TERBD, 6, 16)
    DEP_FIELD(DX7BDLR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX7BDLR6, PDRBD, 6, 8)
    DEP_FIELD(DX7BDLR6, RESERVED_7_0, 8, 0)
DEP_REG32(DX7BDLR7, 0xe64)
    DEP_FIELD(DX7BDLR7, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX7BDLR7, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX7BDLR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX7BDLR7, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX7BDLR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX7BDLR7, RESERVED_5_0, 6, 0)
DEP_REG32(DX7BDLR8, 0xe68)
    DEP_FIELD(DX7BDLR8, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX7BDLR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX7BDLR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX7BDLR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX7BDLR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX7BDLR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX7BDLR9, 0xe6c)
    DEP_FIELD(DX7BDLR9, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX7BDLR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX7BDLR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX7BDLR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX7BDLR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX7BDLR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX7LCDLR0, 0xe80)
    DEP_FIELD(DX7LCDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX7LCDLR0, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX7LCDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX7LCDLR0, WLD, 9, 0)
DEP_REG32(DX7LCDLR1, 0xe84)
    DEP_FIELD(DX7LCDLR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX7LCDLR1, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX7LCDLR1, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX7LCDLR1, WDQD, 9, 0)
DEP_REG32(DX7LCDLR2, 0xe88)
    DEP_FIELD(DX7LCDLR2, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX7LCDLR2, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX7LCDLR2, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX7LCDLR2, DQSGD, 9, 0)
DEP_REG32(DX7LCDLR3, 0xe8c)
    DEP_FIELD(DX7LCDLR3, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX7LCDLR3, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX7LCDLR3, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX7LCDLR3, RDQSD, 9, 0)
DEP_REG32(DX7LCDLR4, 0xe90)
    DEP_FIELD(DX7LCDLR4, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX7LCDLR4, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX7LCDLR4, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX7LCDLR4, RDQSND, 9, 0)
DEP_REG32(DX7LCDLR5, 0xe94)
    DEP_FIELD(DX7LCDLR5, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX7LCDLR5, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX7LCDLR5, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX7LCDLR5, DQSGSD, 9, 0)
DEP_REG32(DX7MDLR0, 0xea0)
    DEP_FIELD(DX7MDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX7MDLR0, TPRD, 9, 16)
    DEP_FIELD(DX7MDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX7MDLR0, IPRD, 9, 0)
DEP_REG32(DX7MDLR1, 0xea4)
    DEP_FIELD(DX7MDLR1, RESERVED_31_9, 23, 9)
    DEP_FIELD(DX7MDLR1, MDLD, 9, 0)
DEP_REG32(DX7GTR0, 0xec0)
    DEP_FIELD(DX7GTR0, RESERVED_31_24, 5, 27)
    DEP_FIELD(DX7GTR0, WDQSL, 3, 24)
    DEP_FIELD(DX7GTR0, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX7GTR0, WLSL, 4, 16)
    DEP_FIELD(DX7GTR0, RESERVED_15_13, 3, 13)
    DEP_FIELD(DX7GTR0, RESERVED_12_8, 5, 8)
    DEP_FIELD(DX7GTR0, RESERVED_7_5, 3, 5)
    DEP_FIELD(DX7GTR0, DGSL, 5, 0)
DEP_REG32(DX7RSR0, 0xed0)
    DEP_FIELD(DX7RSR0, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX7RSR0, QSGERR, 16, 0)
DEP_REG32(DX7RSR1, 0xed4)
    DEP_FIELD(DX7RSR1, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX7RSR1, RDLVLERR, 16, 0)
DEP_REG32(DX7RSR2, 0xed8)
    DEP_FIELD(DX7RSR2, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX7RSR2, WLAWN, 16, 0)
DEP_REG32(DX7RSR3, 0xedc)
    DEP_FIELD(DX7RSR3, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX7RSR3, WLAERR, 16, 0)
DEP_REG32(DX7GSR0, 0xee0)
    DEP_FIELD(DX7GSR0, RESERVED_31, 1, 31)
    DEP_FIELD(DX7GSR0, WLDQ, 1, 30)
    DEP_FIELD(DX7GSR0, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX7GSR0, GDQSPRD, 9, 17)
    DEP_FIELD(DX7GSR0, DPLOCK, 1, 16)
    DEP_FIELD(DX7GSR0, WLPRD, 9, 7)
    DEP_FIELD(DX7GSR0, WLERR, 1, 6)
    DEP_FIELD(DX7GSR0, WLDONE, 1, 5)
    DEP_FIELD(DX7GSR0, WLCAL, 1, 4)
    DEP_FIELD(DX7GSR0, GDQSCAL, 1, 3)
    DEP_FIELD(DX7GSR0, RDQSNCAL, 1, 2)
    DEP_FIELD(DX7GSR0, RDQSCAL, 1, 1)
    DEP_FIELD(DX7GSR0, WDQCAL, 1, 0)
DEP_REG32(DX7GSR1, 0xee4)
    DEP_FIELD(DX7GSR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX7GSR1, DLTCODE, 24, 1)
    DEP_FIELD(DX7GSR1, DLTDONE, 1, 0)
DEP_REG32(DX7GSR2, 0xee8)
    DEP_FIELD(DX7GSR2, GSDQSPRD, 9, 23)
    DEP_FIELD(DX7GSR2, GSDQSCAL, 1, 22)
    DEP_FIELD(DX7GSR2, RESERVED_21, 1, 21)
    DEP_FIELD(DX7GSR2, SRDERR, 1, 20)
    DEP_FIELD(DX7GSR2, DQS2DQERR, 8, 12)
    DEP_FIELD(DX7GSR2, ESTAT, 4, 8)
    DEP_FIELD(DX7GSR2, WEWN, 1, 7)
    DEP_FIELD(DX7GSR2, WEERR, 1, 6)
    DEP_FIELD(DX7GSR2, REWN, 1, 5)
    DEP_FIELD(DX7GSR2, REERR, 1, 4)
    DEP_FIELD(DX7GSR2, WDWN, 1, 3)
    DEP_FIELD(DX7GSR2, WDERR, 1, 2)
    DEP_FIELD(DX7GSR2, RDWN, 1, 1)
    DEP_FIELD(DX7GSR2, RDERR, 1, 0)
DEP_REG32(DX7GSR3, 0xeec)
    DEP_FIELD(DX7GSR3, RESERVED_31_27, 5, 27)
    DEP_FIELD(DX7GSR3, ESTAT, 3, 24)
    DEP_FIELD(DX7GSR3, DVWRN, 4, 20)
    DEP_FIELD(DX7GSR3, DVERR, 4, 16)
    DEP_FIELD(DX7GSR3, HVWRN, 4, 12)
    DEP_FIELD(DX7GSR3, HVERR, 4, 8)
    DEP_FIELD(DX7GSR3, RESERVED_7_2, 6, 2)
    DEP_FIELD(DX7GSR3, SRDPC, 2, 0)
DEP_REG32(DX7GSR4, 0xef0)
    DEP_FIELD(DX7GSR4, RESERVED_31_26, 6, 26)
    DEP_FIELD(DX7GSR4, RESERVED_25_17, 9, 17)
    DEP_FIELD(DX7GSR4, RESERVED_16, 1, 16)
    DEP_FIELD(DX7GSR4, RESERVED_15_7, 9, 7)
    DEP_FIELD(DX7GSR4, RESERVED_6, 1, 6)
    DEP_FIELD(DX7GSR4, RESERVED_5, 1, 5)
    DEP_FIELD(DX7GSR4, RESERVED_4, 1, 4)
    DEP_FIELD(DX7GSR4, RESERVED_3, 1, 3)
    DEP_FIELD(DX7GSR4, RESERVED_2, 1, 2)
    DEP_FIELD(DX7GSR4, RESERVED_1, 1, 1)
    DEP_FIELD(DX7GSR4, RESERVED_0, 1, 0)
DEP_REG32(DX7GSR5, 0xef4)
    DEP_FIELD(DX7GSR5, RESERVED_31_23, 9, 23)
    DEP_FIELD(DX7GSR5, RESERVED_22, 1, 22)
    DEP_FIELD(DX7GSR5, RESERVED_21, 1, 21)
    DEP_FIELD(DX7GSR5, RESERVED_20, 1, 20)
    DEP_FIELD(DX7GSR5, RESERVED_19_12, 8, 12)
    DEP_FIELD(DX7GSR5, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX7GSR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX7GSR5, RESERVED_6, 1, 6)
    DEP_FIELD(DX7GSR5, RESERVED_5, 1, 5)
    DEP_FIELD(DX7GSR5, RESERVED_4, 1, 4)
    DEP_FIELD(DX7GSR5, RESERVED_3, 1, 3)
    DEP_FIELD(DX7GSR5, RESERVED_2, 1, 2)
    DEP_FIELD(DX7GSR5, RESERVED_1, 1, 1)
    DEP_FIELD(DX7GSR5, RESERVED_0, 1, 0)
DEP_REG32(DX7GSR6, 0xef8)
    DEP_FIELD(DX7GSR6, RESERVED_31_24, 8, 24)
    DEP_FIELD(DX7GSR6, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX7GSR6, RESERVED_19_15, 4, 16)
    DEP_FIELD(DX7GSR6, RESERVED_15_12, 4, 12)
    DEP_FIELD(DX7GSR6, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX7GSR6, RESERVED_7_4, 4, 4)
    DEP_FIELD(DX7GSR6, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX7GSR6, RESERVED_1_0, 2, 0)
DEP_REG32(DX8GCR0, 0xf00)
    DEP_FIELD(DX8GCR0, CALBYP, 1, 31)
    DEP_FIELD(DX8GCR0, MDLEN, 1, 30)
    DEP_FIELD(DX8GCR0, CODTSHFT, 2, 28)
    DEP_FIELD(DX8GCR0, DQSDCC, 4, 24)
    DEP_FIELD(DX8GCR0, RDDLY, 4, 20)
    DEP_FIELD(DX8GCR0, RESERVED_19_14, 6, 14)
    DEP_FIELD(DX8GCR0, DQSNSEPDR, 1, 13)
    DEP_FIELD(DX8GCR0, DQSSEPDR, 1, 12)
    DEP_FIELD(DX8GCR0, RTTOAL, 1, 11)
    DEP_FIELD(DX8GCR0, RTTOH, 2, 9)
    DEP_FIELD(DX8GCR0, CPDRSHFT, 2, 7)
    DEP_FIELD(DX8GCR0, DQSRPD, 1, 6)
    DEP_FIELD(DX8GCR0, DQSGPDR, 1, 5)
    DEP_FIELD(DX8GCR0, RESERVED_4, 1, 4)
    DEP_FIELD(DX8GCR0, DQSGODT, 1, 3)
    DEP_FIELD(DX8GCR0, DQSGOE, 1, 2)
    DEP_FIELD(DX8GCR0, RESERVED_1_0, 2, 0)
DEP_REG32(DX8GCR1, 0xf04)
    DEP_FIELD(DX8GCR1, DXPDRMODE, 16, 16)
    DEP_FIELD(DX8GCR1, RESERVED_15, 1, 15)
    DEP_FIELD(DX8GCR1, QSNSEL, 1, 14)
    DEP_FIELD(DX8GCR1, QSSEL, 1, 13)
    DEP_FIELD(DX8GCR1, OEEN, 1, 12)
    DEP_FIELD(DX8GCR1, PDREN, 1, 11)
    DEP_FIELD(DX8GCR1, TEEN, 1, 10)
    DEP_FIELD(DX8GCR1, DSEN, 1, 9)
    DEP_FIELD(DX8GCR1, DMEN, 1, 8)
    DEP_FIELD(DX8GCR1, DQEN, 8, 0)
DEP_REG32(DX8GCR2, 0xf08)
    DEP_FIELD(DX8GCR2, DXOEMODE, 16, 16)
    DEP_FIELD(DX8GCR2, DXTEMODE, 16, 0)
DEP_REG32(DX8GCR3, 0xf0c)
    DEP_FIELD(DX8GCR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8GCR3, RDBVT, 1, 29)
    DEP_FIELD(DX8GCR3, WDBVT, 1, 28)
    DEP_FIELD(DX8GCR3, RGLVT, 1, 27)
    DEP_FIELD(DX8GCR3, RDLVT, 1, 26)
    DEP_FIELD(DX8GCR3, WDLVT, 1, 25)
    DEP_FIELD(DX8GCR3, WLLVT, 1, 24)
    DEP_FIELD(DX8GCR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX8GCR3, DSNOEMODE, 2, 20)
    DEP_FIELD(DX8GCR3, DSNTEMODE, 2, 18)
    DEP_FIELD(DX8GCR3, DSNPDRMODE, 2, 16)
    DEP_FIELD(DX8GCR3, DMOEMODE, 2, 14)
    DEP_FIELD(DX8GCR3, DMTEMODE, 2, 12)
    DEP_FIELD(DX8GCR3, DMPDRMODE, 2, 10)
    DEP_FIELD(DX8GCR3, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX8GCR3, DSOEMODE, 2, 6)
    DEP_FIELD(DX8GCR3, DSTEMODE, 2, 4)
    DEP_FIELD(DX8GCR3, DSPDRMODE, 2, 2)
    DEP_FIELD(DX8GCR3, RESERVED_1_0, 2, 0)
DEP_REG32(DX8GCR4, 0xf10)
    DEP_FIELD(DX8GCR4, RESERVED_31_29, 3, 29)
    DEP_FIELD(DX8GCR4, DXREFPEN, 1, 28)
    DEP_FIELD(DX8GCR4, DXREFEEN, 2, 26)
    DEP_FIELD(DX8GCR4, DXREFSEN, 1, 25)
    DEP_FIELD(DX8GCR4, RESERVED_24, 1, 24)
    DEP_FIELD(DX8GCR4, DXREFESELRANGE, 1, 23)
    DEP_FIELD(DX8GCR4, DXREFESEL, 7, 16)
    DEP_FIELD(DX8GCR4, DXREFSSELRANGE, 1, 15)
    DEP_FIELD(DX8GCR4, DXREFSSEL, 7, 8)
    DEP_FIELD(DX8GCR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX8GCR4, DXREFIEN, 4, 2)
    DEP_FIELD(DX8GCR4, DXREFIMON, 2, 0)
DEP_REG32(DX8GCR5, 0xf14)
    DEP_FIELD(DX8GCR5, RESERVED_31, 1, 31)
    DEP_FIELD(DX8GCR5, DXREFISELR3, 7, 24)
    DEP_FIELD(DX8GCR5, RESERVED_23, 1, 23)
    DEP_FIELD(DX8GCR5, DXREFISELR2, 7, 16)
    DEP_FIELD(DX8GCR5, RESERVED_15, 1, 15)
    DEP_FIELD(DX8GCR5, DXREFISELR1, 7, 8)
    DEP_FIELD(DX8GCR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX8GCR5, DXREFISELR0, 7, 0)
DEP_REG32(DX8GCR6, 0xf18)
    DEP_FIELD(DX8GCR6, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8GCR6, DXDQVREFR3, 6, 24)
    DEP_FIELD(DX8GCR6, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX8GCR6, DXDQVREFR2, 6, 16)
    DEP_FIELD(DX8GCR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX8GCR6, DXDQVREFR1, 6, 8)
    DEP_FIELD(DX8GCR6, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX8GCR6, DXDQVREFR0, 6, 0)
DEP_REG32(DX8GCR7, 0xf1c)
    DEP_FIELD(DX8GCR7, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8GCR7, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX8GCR7, RESERVED_25, 1, 25)
    DEP_FIELD(DX8GCR7, RESERVED_24_23, 2, 23)
    DEP_FIELD(DX8GCR7, RESERVED_22, 1, 22)
    DEP_FIELD(DX8GCR7, RESERVED_21, 1, 21)
    DEP_FIELD(DX8GCR7, RESERVED_20, 1, 20)
    DEP_FIELD(DX8GCR7, RESERVED_19, 1, 19)
    DEP_FIELD(DX8GCR7, RESERVED_18, 1, 18)
    DEP_FIELD(DX8GCR7, RESERVED_17, 1, 17)
    DEP_FIELD(DX8GCR7, RESERVED_16, 1, 16)
    DEP_FIELD(DX8GCR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX8GCR7, RESERVED_13_12, 2, 12)
    DEP_FIELD(DX8GCR7, RESERVED_11_10, 2, 10)
    DEP_FIELD(DX8GCR7, RESERVED_9_8, 2, 8)
    DEP_FIELD(DX8GCR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX8GCR7, RESERVED_5_4, 2, 4)
    DEP_FIELD(DX8GCR7, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX8GCR7, RESERVED_1_0, 2, 0)
DEP_REG32(DX8GCR8, 0xf20)
    DEP_FIELD(DX8GCR8, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8GCR8, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX8GCR8, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX8GCR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX8GCR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX8GCR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX8GCR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX8GCR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX8GCR9, 0xf24)
    DEP_FIELD(DX8GCR9, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8GCR9, RESERVED_29_24, 6, 24)
    DEP_FIELD(DX8GCR9, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX8GCR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX8GCR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX8GCR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX8GCR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX8GCR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX8BDLR0, 0xf40)
    DEP_FIELD(DX8BDLR0, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8BDLR0, DQ3WBD, 6, 24)
    DEP_FIELD(DX8BDLR0, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX8BDLR0, DQ2WBD, 6, 16)
    DEP_FIELD(DX8BDLR0, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX8BDLR0, DQ1WBD, 6, 8)
    DEP_FIELD(DX8BDLR0, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX8BDLR0, DQ0WBD, 6, 0)
DEP_REG32(DX8BDLR1, 0xf44)
    DEP_FIELD(DX8BDLR1, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8BDLR1, DQ7WBD, 6, 24)
    DEP_FIELD(DX8BDLR1, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX8BDLR1, DQ6WBD, 6, 16)
    DEP_FIELD(DX8BDLR1, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX8BDLR1, DQ5WBD, 6, 8)
    DEP_FIELD(DX8BDLR1, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX8BDLR1, DQ4WBD, 6, 0)
DEP_REG32(DX8BDLR2, 0xf48)
    DEP_FIELD(DX8BDLR2, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8BDLR2, DSNWBD, 6, 24)
    DEP_FIELD(DX8BDLR2, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX8BDLR2, DSOEBD, 6, 16)
    DEP_FIELD(DX8BDLR2, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX8BDLR2, DSWBD, 6, 8)
    DEP_FIELD(DX8BDLR2, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX8BDLR2, DMWBD, 6, 0)
DEP_REG32(DX8BDLR3, 0xf50)
    DEP_FIELD(DX8BDLR3, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8BDLR3, DQ3RBD, 6, 24)
    DEP_FIELD(DX8BDLR3, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX8BDLR3, DQ2RBD, 6, 16)
    DEP_FIELD(DX8BDLR3, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX8BDLR3, DQ1RBD, 6, 8)
    DEP_FIELD(DX8BDLR3, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX8BDLR3, DQ0RBD, 6, 0)
DEP_REG32(DX8BDLR4, 0xf54)
    DEP_FIELD(DX8BDLR4, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8BDLR4, DQ7RBD, 6, 24)
    DEP_FIELD(DX8BDLR4, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX8BDLR4, DQ6RBD, 6, 16)
    DEP_FIELD(DX8BDLR4, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX8BDLR4, DQ5RBD, 6, 8)
    DEP_FIELD(DX8BDLR4, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX8BDLR4, DQ4RBD, 6, 0)
DEP_REG32(DX8BDLR5, 0xf58)
    DEP_FIELD(DX8BDLR5, RESERVED_31_6, 26, 6)
    DEP_FIELD(DX8BDLR5, DMRBD, 6, 0)
DEP_REG32(DX8BDLR6, 0xf60)
    DEP_FIELD(DX8BDLR6, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX8BDLR6, TERBD, 6, 16)
    DEP_FIELD(DX8BDLR6, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX8BDLR6, PDRBD, 6, 8)
    DEP_FIELD(DX8BDLR6, RESERVED_7_0, 8, 0)
DEP_REG32(DX8BDLR7, 0xf64)
    DEP_FIELD(DX8BDLR7, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX8BDLR7, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX8BDLR7, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX8BDLR7, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX8BDLR7, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX8BDLR7, RESERVED_5_0, 6, 0)
DEP_REG32(DX8BDLR8, 0xf68)
    DEP_FIELD(DX8BDLR8, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX8BDLR8, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX8BDLR8, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX8BDLR8, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX8BDLR8, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX8BDLR8, RESERVED_5_0, 6, 0)
DEP_REG32(DX8BDLR9, 0xf6c)
    DEP_FIELD(DX8BDLR9, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX8BDLR9, RESERVED_21_16, 6, 16)
    DEP_FIELD(DX8BDLR9, RESERVED_15_14, 2, 14)
    DEP_FIELD(DX8BDLR9, RESERVED_13_8, 6, 8)
    DEP_FIELD(DX8BDLR9, RESERVED_7_6, 2, 6)
    DEP_FIELD(DX8BDLR9, RESERVED_5_0, 6, 0)
DEP_REG32(DX8LCDLR0, 0xf80)
    DEP_FIELD(DX8LCDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8LCDLR0, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX8LCDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX8LCDLR0, WLD, 9, 0)
DEP_REG32(DX8LCDLR1, 0xf84)
    DEP_FIELD(DX8LCDLR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8LCDLR1, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX8LCDLR1, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX8LCDLR1, WDQD, 9, 0)
DEP_REG32(DX8LCDLR2, 0xf88)
    DEP_FIELD(DX8LCDLR2, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8LCDLR2, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX8LCDLR2, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX8LCDLR2, DQSGD, 9, 0)
DEP_REG32(DX8LCDLR3, 0xf8c)
    DEP_FIELD(DX8LCDLR3, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8LCDLR3, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX8LCDLR3, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX8LCDLR3, RDQSD, 9, 0)
DEP_REG32(DX8LCDLR4, 0xf90)
    DEP_FIELD(DX8LCDLR4, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8LCDLR4, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX8LCDLR4, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX8LCDLR4, RDQSND, 9, 0)
DEP_REG32(DX8LCDLR5, 0xf94)
    DEP_FIELD(DX8LCDLR5, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8LCDLR5, RESERVED_24_16, 9, 16)
    DEP_FIELD(DX8LCDLR5, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX8LCDLR5, DQSGSD, 9, 0)
DEP_REG32(DX8MDLR0, 0xfa0)
    DEP_FIELD(DX8MDLR0, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8MDLR0, TPRD, 9, 16)
    DEP_FIELD(DX8MDLR0, RESERVED_15_9, 7, 9)
    DEP_FIELD(DX8MDLR0, IPRD, 9, 0)
DEP_REG32(DX8MDLR1, 0xfa4)
    DEP_FIELD(DX8MDLR1, RESERVED_31_9, 23, 9)
    DEP_FIELD(DX8MDLR1, MDLD, 9, 0)
DEP_REG32(DX8GTR0, 0xfc0)
    DEP_FIELD(DX8GTR0, RESERVED_31_24, 5, 27)
    DEP_FIELD(DX8GTR0, WDQSL, 3, 24)
    DEP_FIELD(DX8GTR0, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX8GTR0, WLSL, 4, 16)
    DEP_FIELD(DX8GTR0, RESERVED_15_13, 3, 13)
    DEP_FIELD(DX8GTR0, RESERVED_12_8, 5, 8)
    DEP_FIELD(DX8GTR0, RESERVED_7_5, 3, 5)
    DEP_FIELD(DX8GTR0, DGSL, 5, 0)
DEP_REG32(DX8RSR0, 0xfd0)
    DEP_FIELD(DX8RSR0, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX8RSR0, QSGERR, 16, 0)
DEP_REG32(DX8RSR1, 0xfd4)
    DEP_FIELD(DX8RSR1, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX8RSR1, RDLVLERR, 16, 0)
DEP_REG32(DX8RSR2, 0xfd8)
    DEP_FIELD(DX8RSR2, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX8RSR2, WLAWN, 16, 0)
DEP_REG32(DX8RSR3, 0xfdc)
    DEP_FIELD(DX8RSR3, RESERVED_31_16, 16, 16)
    DEP_FIELD(DX8RSR3, WLAERR, 16, 0)
DEP_REG32(DX8GSR0, 0xfe0)
    DEP_FIELD(DX8GSR0, RESERVED_31, 1, 31)
    DEP_FIELD(DX8GSR0, WLDQ, 1, 30)
    DEP_FIELD(DX8GSR0, RESERVED_29_26, 4, 26)
    DEP_FIELD(DX8GSR0, GDQSPRD, 9, 17)
    DEP_FIELD(DX8GSR0, DPLOCK, 1, 16)
    DEP_FIELD(DX8GSR0, WLPRD, 9, 7)
    DEP_FIELD(DX8GSR0, WLERR, 1, 6)
    DEP_FIELD(DX8GSR0, WLDONE, 1, 5)
    DEP_FIELD(DX8GSR0, WLCAL, 1, 4)
    DEP_FIELD(DX8GSR0, GDQSCAL, 1, 3)
    DEP_FIELD(DX8GSR0, RDQSNCAL, 1, 2)
    DEP_FIELD(DX8GSR0, RDQSCAL, 1, 1)
    DEP_FIELD(DX8GSR0, WDQCAL, 1, 0)
DEP_REG32(DX8GSR1, 0xfe4)
    DEP_FIELD(DX8GSR1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8GSR1, DLTCODE, 24, 1)
    DEP_FIELD(DX8GSR1, DLTDONE, 1, 0)
DEP_REG32(DX8GSR2, 0xfe8)
    DEP_FIELD(DX8GSR2, GSDQSPRD, 9, 23)
    DEP_FIELD(DX8GSR2, GSDQSCAL, 1, 22)
    DEP_FIELD(DX8GSR2, RESERVED_21, 1, 21)
    DEP_FIELD(DX8GSR2, SRDERR, 1, 20)
    DEP_FIELD(DX8GSR2, DQS2DQERR, 8, 12)
    DEP_FIELD(DX8GSR2, ESTAT, 4, 8)
    DEP_FIELD(DX8GSR2, WEWN, 1, 7)
    DEP_FIELD(DX8GSR2, WEERR, 1, 6)
    DEP_FIELD(DX8GSR2, REWN, 1, 5)
    DEP_FIELD(DX8GSR2, REERR, 1, 4)
    DEP_FIELD(DX8GSR2, WDWN, 1, 3)
    DEP_FIELD(DX8GSR2, WDERR, 1, 2)
    DEP_FIELD(DX8GSR2, RDWN, 1, 1)
    DEP_FIELD(DX8GSR2, RDERR, 1, 0)
DEP_REG32(DX8GSR3, 0xfec)
    DEP_FIELD(DX8GSR3, RESERVED_31_27, 5, 27)
    DEP_FIELD(DX8GSR3, ESTAT, 3, 24)
    DEP_FIELD(DX8GSR3, DVWRN, 4, 20)
    DEP_FIELD(DX8GSR3, DVERR, 4, 16)
    DEP_FIELD(DX8GSR3, HVWRN, 4, 12)
    DEP_FIELD(DX8GSR3, HVERR, 4, 8)
    DEP_FIELD(DX8GSR3, RESERVED_7_2, 6, 2)
    DEP_FIELD(DX8GSR3, SRDPC, 2, 0)
DEP_REG32(DX8GSR4, 0xff0)
    DEP_FIELD(DX8GSR4, RESERVED_31_26, 6, 26)
    DEP_FIELD(DX8GSR4, RESERVED_25_17, 9, 17)
    DEP_FIELD(DX8GSR4, RESERVED_16, 1, 16)
    DEP_FIELD(DX8GSR4, RESERVED_15_7, 9, 7)
    DEP_FIELD(DX8GSR4, RESERVED_6, 1, 6)
    DEP_FIELD(DX8GSR4, RESERVED_5, 1, 5)
    DEP_FIELD(DX8GSR4, RESERVED_4, 1, 4)
    DEP_FIELD(DX8GSR4, RESERVED_3, 1, 3)
    DEP_FIELD(DX8GSR4, RESERVED_2, 1, 2)
    DEP_FIELD(DX8GSR4, RESERVED_1, 1, 1)
    DEP_FIELD(DX8GSR4, RESERVED_0, 1, 0)
DEP_REG32(DX8GSR5, 0xff4)
    DEP_FIELD(DX8GSR5, RESERVED_31_23, 9, 23)
    DEP_FIELD(DX8GSR5, RESERVED_22, 1, 22)
    DEP_FIELD(DX8GSR5, RESERVED_21, 1, 21)
    DEP_FIELD(DX8GSR5, RESERVED_20, 1, 20)
    DEP_FIELD(DX8GSR5, RESERVED_19_12, 8, 12)
    DEP_FIELD(DX8GSR5, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX8GSR5, RESERVED_7, 1, 7)
    DEP_FIELD(DX8GSR5, RESERVED_6, 1, 6)
    DEP_FIELD(DX8GSR5, RESERVED_5, 1, 5)
    DEP_FIELD(DX8GSR5, RESERVED_4, 1, 4)
    DEP_FIELD(DX8GSR5, RESERVED_3, 1, 3)
    DEP_FIELD(DX8GSR5, RESERVED_2, 1, 2)
    DEP_FIELD(DX8GSR5, RESERVED_1, 1, 1)
    DEP_FIELD(DX8GSR5, RESERVED_0, 1, 0)
DEP_REG32(DX8GSR6, 0xff8)
    DEP_FIELD(DX8GSR6, RESERVED_31_24, 8, 24)
    DEP_FIELD(DX8GSR6, RESERVED_23_20, 4, 20)
    DEP_FIELD(DX8GSR6, RESERVED_19_15, 4, 16)
    DEP_FIELD(DX8GSR6, RESERVED_15_12, 4, 12)
    DEP_FIELD(DX8GSR6, RESERVED_11_8, 4, 8)
    DEP_FIELD(DX8GSR6, RESERVED_7_4, 4, 4)
    DEP_FIELD(DX8GSR6, RESERVED_3_2, 2, 2)
    DEP_FIELD(DX8GSR6, RESERVED_1_0, 2, 0)
DEP_REG32(DX8SL0OSC, 0x1400)
    DEP_FIELD(DX8SL0OSC, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8SL0OSC, GATEDXRDCLK, 2, 28)
    DEP_FIELD(DX8SL0OSC, GATEDXDDRCLK, 2, 26)
    DEP_FIELD(DX8SL0OSC, GATEDXCTLCLK, 2, 24)
    DEP_FIELD(DX8SL0OSC, CLKLEVEL, 2, 22)
    DEP_FIELD(DX8SL0OSC, LBMODE, 1, 21)
    DEP_FIELD(DX8SL0OSC, LBGSDQS, 1, 20)
    DEP_FIELD(DX8SL0OSC, LBGDQS, 2, 18)
    DEP_FIELD(DX8SL0OSC, LBDQSS, 1, 17)
    DEP_FIELD(DX8SL0OSC, PHYHRST, 1, 16)
    DEP_FIELD(DX8SL0OSC, PHYFRST, 1, 15)
    DEP_FIELD(DX8SL0OSC, DLTST, 1, 14)
    DEP_FIELD(DX8SL0OSC, DLTMODE, 1, 13)
    DEP_FIELD(DX8SL0OSC, RESERVED_12_11, 2, 11)
    DEP_FIELD(DX8SL0OSC, OSCWDDL, 2, 9)
    DEP_FIELD(DX8SL0OSC, RESERVED_8_7, 2, 7)
    DEP_FIELD(DX8SL0OSC, OSCWDL, 2, 5)
    DEP_FIELD(DX8SL0OSC, OSCDIV, 4, 1)
    DEP_FIELD(DX8SL0OSC, OSCEN, 1, 0)
DEP_REG32(DX8SL0PLLCR0, 0x1404)
    DEP_FIELD(DX8SL0PLLCR0, PLLBYP, 1, 31)
    DEP_FIELD(DX8SL0PLLCR0, PLLRST, 1, 30)
    DEP_FIELD(DX8SL0PLLCR0, PLLPD, 1, 29)
    DEP_FIELD(DX8SL0PLLCR0, RSTOPM, 1, 28)
    DEP_FIELD(DX8SL0PLLCR0, FRQSEL, 4, 24)
    DEP_FIELD(DX8SL0PLLCR0, RLOCKM, 1, 23)
    DEP_FIELD(DX8SL0PLLCR0, CPPC, 6, 17)
    DEP_FIELD(DX8SL0PLLCR0, CPIC, 4, 13)
    DEP_FIELD(DX8SL0PLLCR0, GSHIFT, 1, 12)
    DEP_FIELD(DX8SL0PLLCR0, RESERVED_11_9, 3, 9)
    DEP_FIELD(DX8SL0PLLCR0, ATOEN, 1, 8)
    DEP_FIELD(DX8SL0PLLCR0, ATC, 4, 4)
    DEP_FIELD(DX8SL0PLLCR0, DTC, 4, 0)
DEP_REG32(DX8SL0PLLCR1, 0x1408)
    DEP_FIELD(DX8SL0PLLCR1, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX8SL0PLLCR1, PLLPROG, 16, 6)
    DEP_FIELD(DX8SL0PLLCR1, BYPVREGCP, 1, 5)
    DEP_FIELD(DX8SL0PLLCR1, BYPVREGDIG, 1, 4)
    DEP_FIELD(DX8SL0PLLCR1, BYPVDD, 1, 3)
    DEP_FIELD(DX8SL0PLLCR1, LOCKPS, 1, 2)
    DEP_FIELD(DX8SL0PLLCR1, LOCKCS, 1, 1)
    DEP_FIELD(DX8SL0PLLCR1, LOCKDS, 1, 0)
DEP_REG32(DX8SL0PLLCR2, 0x140c)
DEP_REG32(DX8SL0PLLCR3, 0x1410)
DEP_REG32(DX8SL0PLLCR4, 0x1414)
DEP_REG32(DX8SL0PLLCR5, 0x1418)
    DEP_FIELD(DX8SL0PLLCR5, RESERVED_31_8, 24, 8)
    DEP_FIELD(DX8SL0PLLCR5, PLLCTRL_103_96, 8, 0)
DEP_REG32(DX8SL0DQSCTL, 0x141c)
    DEP_FIELD(DX8SL0DQSCTL, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8SL0DQSCTL, RRRMODE, 1, 24)
    DEP_FIELD(DX8SL0DQSCTL, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX8SL0DQSCTL, WRRMODE, 1, 21)
    DEP_FIELD(DX8SL0DQSCTL, DQSGX, 2, 19)
    DEP_FIELD(DX8SL0DQSCTL, LPPLLPD, 1, 18)
    DEP_FIELD(DX8SL0DQSCTL, LPIOPD, 1, 17)
    DEP_FIELD(DX8SL0DQSCTL, RESERVED_16_15, 2, 15)
    DEP_FIELD(DX8SL0DQSCTL, QSCNTEN, 1, 14)
    DEP_FIELD(DX8SL0DQSCTL, UDQIOM, 1, 13)
    DEP_FIELD(DX8SL0DQSCTL, RESERVED_12_10, 3, 10)
    DEP_FIELD(DX8SL0DQSCTL, DXSR, 2, 8)
    DEP_FIELD(DX8SL0DQSCTL, DQSNRES, 4, 4)
    DEP_FIELD(DX8SL0DQSCTL, DQSRES, 4, 0)
DEP_REG32(DX8SL0TRNCTL, 0x1420)
DEP_REG32(DX8SL0DDLCTL, 0x1424)
    DEP_FIELD(DX8SL0DDLCTL, RESERVED_31_27, 5, 27)
    DEP_FIELD(DX8SL0DDLCTL, DLYLDTM, 1, 26)
    DEP_FIELD(DX8SL0DDLCTL, DXDDLLDT, 1, 25)
    DEP_FIELD(DX8SL0DDLCTL, RESERVED_24_23, 2, 23)
    DEP_FIELD(DX8SL0DDLCTL, DXDDLLD, 5, 18)
    DEP_FIELD(DX8SL0DDLCTL, DXDDLBYP, 16, 2)
    DEP_FIELD(DX8SL0DDLCTL, DDLBYPMODE, 2, 0)
DEP_REG32(DX8SL0DXCTL1, 0x1428)
    DEP_FIELD(DX8SL0DXCTL1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8SL0DXCTL1, DXCALCLK, 1, 24)
    DEP_FIELD(DX8SL0DXCTL1, DXRCLKMD, 1, 23)
    DEP_FIELD(DX8SL0DXCTL1, RESERVED_22, 1, 22)
    DEP_FIELD(DX8SL0DXCTL1, DXDTOSEL, 2, 20)
    DEP_FIELD(DX8SL0DXCTL1, DXGSMD, 1, 19)
    DEP_FIELD(DX8SL0DXCTL1, DXQSDBYP, 1, 18)
    DEP_FIELD(DX8SL0DXCTL1, DXGDBYP, 1, 17)
    DEP_FIELD(DX8SL0DXCTL1, DXTMODE, 1, 16)
    DEP_FIELD(DX8SL0DXCTL1, RESERVED_15_0, 16, 0)
DEP_REG32(DX8SL0DXCTL2, 0x142c)
    DEP_FIELD(DX8SL0DXCTL2, RESERVED_31_24, 8, 24)
    DEP_FIELD(DX8SL0DXCTL2, CRDEN, 1, 23)
    DEP_FIELD(DX8SL0DXCTL2, POSOEX, 3, 20)
    DEP_FIELD(DX8SL0DXCTL2, PREOEX, 2, 18)
    DEP_FIELD(DX8SL0DXCTL2, RESERVED_17, 1, 17)
    DEP_FIELD(DX8SL0DXCTL2, IOAG, 1, 16)
    DEP_FIELD(DX8SL0DXCTL2, IOLB, 1, 15)
    DEP_FIELD(DX8SL0DXCTL2, RESERVED_14_13, 2, 13)
    DEP_FIELD(DX8SL0DXCTL2, LPWAKEUP_THRSH, 4, 9)
    DEP_FIELD(DX8SL0DXCTL2, RDBI, 1, 8)
    DEP_FIELD(DX8SL0DXCTL2, WDBI, 1, 7)
    DEP_FIELD(DX8SL0DXCTL2, PRFBYP, 1, 6)
    DEP_FIELD(DX8SL0DXCTL2, RDMODE, 2, 4)
    DEP_FIELD(DX8SL0DXCTL2, DISRST, 1, 3)
    DEP_FIELD(DX8SL0DXCTL2, DQSGLB, 2, 1)
    DEP_FIELD(DX8SL0DXCTL2, RESERVED_0, 1, 0)
DEP_REG32(DX8SL0IOCR, 0x1430)
    DEP_FIELD(DX8SL0IOCR, RESERVED_31, 1, 31)
    DEP_FIELD(DX8SL0IOCR, DXDACRANGE, 3, 28)
    DEP_FIELD(DX8SL0IOCR, DXVREFIOM, 3, 25)
    DEP_FIELD(DX8SL0IOCR, DXIOM, 3, 22)
    DEP_FIELD(DX8SL0IOCR, DXTXM, 11, 11)
    DEP_FIELD(DX8SL0IOCR, DXRXM, 11, 0)
DEP_REG32(DX4SL0IOCR, 0x1434)
DEP_REG32(DX8SL1OSC, 0x1440)
    DEP_FIELD(DX8SL1OSC, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8SL1OSC, GATEDXRDCLK, 2, 28)
    DEP_FIELD(DX8SL1OSC, GATEDXDDRCLK, 2, 26)
    DEP_FIELD(DX8SL1OSC, GATEDXCTLCLK, 2, 24)
    DEP_FIELD(DX8SL1OSC, CLKLEVEL, 2, 22)
    DEP_FIELD(DX8SL1OSC, LBMODE, 1, 21)
    DEP_FIELD(DX8SL1OSC, LBGSDQS, 1, 20)
    DEP_FIELD(DX8SL1OSC, LBGDQS, 2, 18)
    DEP_FIELD(DX8SL1OSC, LBDQSS, 1, 17)
    DEP_FIELD(DX8SL1OSC, PHYHRST, 1, 16)
    DEP_FIELD(DX8SL1OSC, PHYFRST, 1, 15)
    DEP_FIELD(DX8SL1OSC, DLTST, 1, 14)
    DEP_FIELD(DX8SL1OSC, DLTMODE, 1, 13)
    DEP_FIELD(DX8SL1OSC, RESERVED_12_11, 2, 11)
    DEP_FIELD(DX8SL1OSC, OSCWDDL, 2, 9)
    DEP_FIELD(DX8SL1OSC, RESERVED_8_7, 2, 7)
    DEP_FIELD(DX8SL1OSC, OSCWDL, 2, 5)
    DEP_FIELD(DX8SL1OSC, OSCDIV, 4, 1)
    DEP_FIELD(DX8SL1OSC, OSCEN, 1, 0)
DEP_REG32(DX8SL1PLLCR0, 0x1444)
    DEP_FIELD(DX8SL1PLLCR0, PLLBYP, 1, 31)
    DEP_FIELD(DX8SL1PLLCR0, PLLRST, 1, 30)
    DEP_FIELD(DX8SL1PLLCR0, PLLPD, 1, 29)
    DEP_FIELD(DX8SL1PLLCR0, RSTOPM, 1, 28)
    DEP_FIELD(DX8SL1PLLCR0, FRQSEL, 4, 24)
    DEP_FIELD(DX8SL1PLLCR0, RLOCKM, 1, 23)
    DEP_FIELD(DX8SL1PLLCR0, CPPC, 6, 17)
    DEP_FIELD(DX8SL1PLLCR0, CPIC, 4, 13)
    DEP_FIELD(DX8SL1PLLCR0, GSHIFT, 1, 12)
    DEP_FIELD(DX8SL1PLLCR0, RESERVED_11_9, 3, 9)
    DEP_FIELD(DX8SL1PLLCR0, ATOEN, 1, 8)
    DEP_FIELD(DX8SL1PLLCR0, ATC, 4, 4)
    DEP_FIELD(DX8SL1PLLCR0, DTC, 4, 0)
DEP_REG32(DX8SL1PLLCR1, 0x1448)
    DEP_FIELD(DX8SL1PLLCR1, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX8SL1PLLCR1, PLLPROG, 16, 6)
    DEP_FIELD(DX8SL1PLLCR1, BYPVREGCP, 1, 5)
    DEP_FIELD(DX8SL1PLLCR1, BYPVREGDIG, 1, 4)
    DEP_FIELD(DX8SL1PLLCR1, BYPVDD, 1, 3)
    DEP_FIELD(DX8SL1PLLCR1, LOCKPS, 1, 2)
    DEP_FIELD(DX8SL1PLLCR1, LOCKCS, 1, 1)
    DEP_FIELD(DX8SL1PLLCR1, LOCKDS, 1, 0)
DEP_REG32(DX8SL1PLLCR2, 0x144c)
DEP_REG32(DX8SL1PLLCR3, 0x1450)
DEP_REG32(DX8SL1PLLCR4, 0x1454)
DEP_REG32(DX8SL1PLLCR5, 0x1458)
    DEP_FIELD(DX8SL1PLLCR5, RESERVED_31_8, 24, 8)
    DEP_FIELD(DX8SL1PLLCR5, PLLCTRL_103_96, 8, 0)
DEP_REG32(DX8SL1DQSCTL, 0x145c)
    DEP_FIELD(DX8SL1DQSCTL, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8SL1DQSCTL, RRRMODE, 1, 24)
    DEP_FIELD(DX8SL1DQSCTL, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX8SL1DQSCTL, WRRMODE, 1, 21)
    DEP_FIELD(DX8SL1DQSCTL, DQSGX, 2, 19)
    DEP_FIELD(DX8SL1DQSCTL, LPPLLPD, 1, 18)
    DEP_FIELD(DX8SL1DQSCTL, LPIOPD, 1, 17)
    DEP_FIELD(DX8SL1DQSCTL, RESERVED_16_15, 2, 15)
    DEP_FIELD(DX8SL1DQSCTL, QSCNTEN, 1, 14)
    DEP_FIELD(DX8SL1DQSCTL, UDQIOM, 1, 13)
    DEP_FIELD(DX8SL1DQSCTL, RESERVED_12_10, 3, 10)
    DEP_FIELD(DX8SL1DQSCTL, DXSR, 2, 8)
    DEP_FIELD(DX8SL1DQSCTL, DQSNRES, 4, 4)
    DEP_FIELD(DX8SL1DQSCTL, DQSRES, 4, 0)
DEP_REG32(DX8SL1TRNCTL, 0x1460)
DEP_REG32(DX8SL1DDLCTL, 0x1464)
    DEP_FIELD(DX8SL1DDLCTL, RESERVED_31_27, 5, 27)
    DEP_FIELD(DX8SL1DDLCTL, DLYLDTM, 1, 26)
    DEP_FIELD(DX8SL1DDLCTL, DXDDLLDT, 1, 25)
    DEP_FIELD(DX8SL1DDLCTL, RESERVED_24_23, 2, 23)
    DEP_FIELD(DX8SL1DDLCTL, DXDDLLD, 5, 18)
    DEP_FIELD(DX8SL1DDLCTL, DXDDLBYP, 16, 2)
    DEP_FIELD(DX8SL1DDLCTL, DDLBYPMODE, 2, 0)
DEP_REG32(DX8SL1DXCTL1, 0x1468)
    DEP_FIELD(DX8SL1DXCTL1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8SL1DXCTL1, DXCALCLK, 1, 24)
    DEP_FIELD(DX8SL1DXCTL1, DXRCLKMD, 1, 23)
    DEP_FIELD(DX8SL1DXCTL1, RESERVED_22, 1, 22)
    DEP_FIELD(DX8SL1DXCTL1, DXDTOSEL, 2, 20)
    DEP_FIELD(DX8SL1DXCTL1, DXGSMD, 1, 19)
    DEP_FIELD(DX8SL1DXCTL1, DXQSDBYP, 1, 18)
    DEP_FIELD(DX8SL1DXCTL1, DXGDBYP, 1, 17)
    DEP_FIELD(DX8SL1DXCTL1, DXTMODE, 1, 16)
    DEP_FIELD(DX8SL1DXCTL1, RESERVED_15_0, 16, 0)
DEP_REG32(DX8SL1DXCTL2, 0x146c)
    DEP_FIELD(DX8SL1DXCTL2, RESERVED_31_24, 8, 24)
    DEP_FIELD(DX8SL1DXCTL2, CRDEN, 1, 23)
    DEP_FIELD(DX8SL1DXCTL2, POSOEX, 3, 20)
    DEP_FIELD(DX8SL1DXCTL2, PREOEX, 2, 18)
    DEP_FIELD(DX8SL1DXCTL2, RESERVED_17, 1, 17)
    DEP_FIELD(DX8SL1DXCTL2, IOAG, 1, 16)
    DEP_FIELD(DX8SL1DXCTL2, IOLB, 1, 15)
    DEP_FIELD(DX8SL1DXCTL2, RESERVED_14_13, 2, 13)
    DEP_FIELD(DX8SL1DXCTL2, LPWAKEUP_THRSH, 4, 9)
    DEP_FIELD(DX8SL1DXCTL2, RDBI, 1, 8)
    DEP_FIELD(DX8SL1DXCTL2, WDBI, 1, 7)
    DEP_FIELD(DX8SL1DXCTL2, PRFBYP, 1, 6)
    DEP_FIELD(DX8SL1DXCTL2, RDMODE, 2, 4)
    DEP_FIELD(DX8SL1DXCTL2, DISRST, 1, 3)
    DEP_FIELD(DX8SL1DXCTL2, DQSGLB, 2, 1)
    DEP_FIELD(DX8SL1DXCTL2, RESERVED_0, 1, 0)
DEP_REG32(DX8SL1IOCR, 0x1470)
    DEP_FIELD(DX8SL1IOCR, RESERVED_31, 1, 31)
    DEP_FIELD(DX8SL1IOCR, DXDACRANGE, 3, 28)
    DEP_FIELD(DX8SL1IOCR, DXVREFIOM, 3, 25)
    DEP_FIELD(DX8SL1IOCR, DXIOM, 3, 22)
    DEP_FIELD(DX8SL1IOCR, DXTXM, 11, 11)
    DEP_FIELD(DX8SL1IOCR, DXRXM, 11, 0)
DEP_REG32(DX4SL1IOCR, 0x1474)
DEP_REG32(DX8SL2OSC, 0x1480)
    DEP_FIELD(DX8SL2OSC, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8SL2OSC, GATEDXRDCLK, 2, 28)
    DEP_FIELD(DX8SL2OSC, GATEDXDDRCLK, 2, 26)
    DEP_FIELD(DX8SL2OSC, GATEDXCTLCLK, 2, 24)
    DEP_FIELD(DX8SL2OSC, CLKLEVEL, 2, 22)
    DEP_FIELD(DX8SL2OSC, LBMODE, 1, 21)
    DEP_FIELD(DX8SL2OSC, LBGSDQS, 1, 20)
    DEP_FIELD(DX8SL2OSC, LBGDQS, 2, 18)
    DEP_FIELD(DX8SL2OSC, LBDQSS, 1, 17)
    DEP_FIELD(DX8SL2OSC, PHYHRST, 1, 16)
    DEP_FIELD(DX8SL2OSC, PHYFRST, 1, 15)
    DEP_FIELD(DX8SL2OSC, DLTST, 1, 14)
    DEP_FIELD(DX8SL2OSC, DLTMODE, 1, 13)
    DEP_FIELD(DX8SL2OSC, RESERVED_12_11, 2, 11)
    DEP_FIELD(DX8SL2OSC, OSCWDDL, 2, 9)
    DEP_FIELD(DX8SL2OSC, RESERVED_8_7, 2, 7)
    DEP_FIELD(DX8SL2OSC, OSCWDL, 2, 5)
    DEP_FIELD(DX8SL2OSC, OSCDIV, 4, 1)
    DEP_FIELD(DX8SL2OSC, OSCEN, 1, 0)
DEP_REG32(DX8SL2PLLCR0, 0x1484)
    DEP_FIELD(DX8SL2PLLCR0, PLLBYP, 1, 31)
    DEP_FIELD(DX8SL2PLLCR0, PLLRST, 1, 30)
    DEP_FIELD(DX8SL2PLLCR0, PLLPD, 1, 29)
    DEP_FIELD(DX8SL2PLLCR0, RSTOPM, 1, 28)
    DEP_FIELD(DX8SL2PLLCR0, FRQSEL, 4, 24)
    DEP_FIELD(DX8SL2PLLCR0, RLOCKM, 1, 23)
    DEP_FIELD(DX8SL2PLLCR0, CPPC, 6, 17)
    DEP_FIELD(DX8SL2PLLCR0, CPIC, 4, 13)
    DEP_FIELD(DX8SL2PLLCR0, GSHIFT, 1, 12)
    DEP_FIELD(DX8SL2PLLCR0, RESERVED_11_9, 3, 9)
    DEP_FIELD(DX8SL2PLLCR0, ATOEN, 1, 8)
    DEP_FIELD(DX8SL2PLLCR0, ATC, 4, 4)
    DEP_FIELD(DX8SL2PLLCR0, DTC, 4, 0)
DEP_REG32(DX8SL2PLLCR1, 0x1488)
    DEP_FIELD(DX8SL2PLLCR1, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX8SL2PLLCR1, PLLPROG, 16, 6)
    DEP_FIELD(DX8SL2PLLCR1, BYPVREGCP, 1, 5)
    DEP_FIELD(DX8SL2PLLCR1, BYPVREGDIG, 1, 4)
    DEP_FIELD(DX8SL2PLLCR1, BYPVDD, 1, 3)
    DEP_FIELD(DX8SL2PLLCR1, LOCKPS, 1, 2)
    DEP_FIELD(DX8SL2PLLCR1, LOCKCS, 1, 1)
    DEP_FIELD(DX8SL2PLLCR1, LOCKDS, 1, 0)
DEP_REG32(DX8SL2PLLCR2, 0x148c)
DEP_REG32(DX8SL2PLLCR3, 0x1490)
DEP_REG32(DX8SL2PLLCR4, 0x1494)
DEP_REG32(DX8SL2PLLCR5, 0x1498)
    DEP_FIELD(DX8SL2PLLCR5, RESERVED_31_8, 24, 8)
    DEP_FIELD(DX8SL2PLLCR5, PLLCTRL_103_96, 8, 0)
DEP_REG32(DX8SL2DQSCTL, 0x149c)
    DEP_FIELD(DX8SL2DQSCTL, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8SL2DQSCTL, RRRMODE, 1, 24)
    DEP_FIELD(DX8SL2DQSCTL, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX8SL2DQSCTL, WRRMODE, 1, 21)
    DEP_FIELD(DX8SL2DQSCTL, DQSGX, 2, 19)
    DEP_FIELD(DX8SL2DQSCTL, LPPLLPD, 1, 18)
    DEP_FIELD(DX8SL2DQSCTL, LPIOPD, 1, 17)
    DEP_FIELD(DX8SL2DQSCTL, RESERVED_16_15, 2, 15)
    DEP_FIELD(DX8SL2DQSCTL, QSCNTEN, 1, 14)
    DEP_FIELD(DX8SL2DQSCTL, UDQIOM, 1, 13)
    DEP_FIELD(DX8SL2DQSCTL, RESERVED_12_10, 3, 10)
    DEP_FIELD(DX8SL2DQSCTL, DXSR, 2, 8)
    DEP_FIELD(DX8SL2DQSCTL, DQSNRES, 4, 4)
    DEP_FIELD(DX8SL2DQSCTL, DQSRES, 4, 0)
DEP_REG32(DX8SL2TRNCTL, 0x14a0)
DEP_REG32(DX8SL2DDLCTL, 0x14a4)
    DEP_FIELD(DX8SL2DDLCTL, RESERVED_31_27, 5, 27)
    DEP_FIELD(DX8SL2DDLCTL, DLYLDTM, 1, 26)
    DEP_FIELD(DX8SL2DDLCTL, DXDDLLDT, 1, 25)
    DEP_FIELD(DX8SL2DDLCTL, RESERVED_24_23, 2, 23)
    DEP_FIELD(DX8SL2DDLCTL, DXDDLLD, 5, 18)
    DEP_FIELD(DX8SL2DDLCTL, DXDDLBYP, 16, 2)
    DEP_FIELD(DX8SL2DDLCTL, DDLBYPMODE, 2, 0)
DEP_REG32(DX8SL2DXCTL1, 0x14a8)
    DEP_FIELD(DX8SL2DXCTL1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8SL2DXCTL1, DXCALCLK, 1, 24)
    DEP_FIELD(DX8SL2DXCTL1, DXRCLKMD, 1, 23)
    DEP_FIELD(DX8SL2DXCTL1, RESERVED_22, 1, 22)
    DEP_FIELD(DX8SL2DXCTL1, DXDTOSEL, 2, 20)
    DEP_FIELD(DX8SL2DXCTL1, DXGSMD, 1, 19)
    DEP_FIELD(DX8SL2DXCTL1, DXQSDBYP, 1, 18)
    DEP_FIELD(DX8SL2DXCTL1, DXGDBYP, 1, 17)
    DEP_FIELD(DX8SL2DXCTL1, DXTMODE, 1, 16)
    DEP_FIELD(DX8SL2DXCTL1, RESERVED_15_0, 16, 0)
DEP_REG32(DX8SL2DXCTL2, 0x14ac)
    DEP_FIELD(DX8SL2DXCTL2, RESERVED_31_24, 8, 24)
    DEP_FIELD(DX8SL2DXCTL2, CRDEN, 1, 23)
    DEP_FIELD(DX8SL2DXCTL2, POSOEX, 3, 20)
    DEP_FIELD(DX8SL2DXCTL2, PREOEX, 2, 18)
    DEP_FIELD(DX8SL2DXCTL2, RESERVED_17, 1, 17)
    DEP_FIELD(DX8SL2DXCTL2, IOAG, 1, 16)
    DEP_FIELD(DX8SL2DXCTL2, IOLB, 1, 15)
    DEP_FIELD(DX8SL2DXCTL2, RESERVED_14_13, 2, 13)
    DEP_FIELD(DX8SL2DXCTL2, LPWAKEUP_THRSH, 4, 9)
    DEP_FIELD(DX8SL2DXCTL2, RDBI, 1, 8)
    DEP_FIELD(DX8SL2DXCTL2, WDBI, 1, 7)
    DEP_FIELD(DX8SL2DXCTL2, PRFBYP, 1, 6)
    DEP_FIELD(DX8SL2DXCTL2, RDMODE, 2, 4)
    DEP_FIELD(DX8SL2DXCTL2, DISRST, 1, 3)
    DEP_FIELD(DX8SL2DXCTL2, DQSGLB, 2, 1)
    DEP_FIELD(DX8SL2DXCTL2, RESERVED_0, 1, 0)
DEP_REG32(DX8SL2IOCR, 0x14b0)
    DEP_FIELD(DX8SL2IOCR, RESERVED_31, 1, 31)
    DEP_FIELD(DX8SL2IOCR, DXDACRANGE, 3, 28)
    DEP_FIELD(DX8SL2IOCR, DXVREFIOM, 3, 25)
    DEP_FIELD(DX8SL2IOCR, DXIOM, 3, 22)
    DEP_FIELD(DX8SL2IOCR, DXTXM, 11, 11)
    DEP_FIELD(DX8SL2IOCR, DXRXM, 11, 0)
DEP_REG32(DX4SL2IOCR, 0x14b4)
DEP_REG32(DX8SL3OSC, 0x14c0)
    DEP_FIELD(DX8SL3OSC, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8SL3OSC, GATEDXRDCLK, 2, 28)
    DEP_FIELD(DX8SL3OSC, GATEDXDDRCLK, 2, 26)
    DEP_FIELD(DX8SL3OSC, GATEDXCTLCLK, 2, 24)
    DEP_FIELD(DX8SL3OSC, CLKLEVEL, 2, 22)
    DEP_FIELD(DX8SL3OSC, LBMODE, 1, 21)
    DEP_FIELD(DX8SL3OSC, LBGSDQS, 1, 20)
    DEP_FIELD(DX8SL3OSC, LBGDQS, 2, 18)
    DEP_FIELD(DX8SL3OSC, LBDQSS, 1, 17)
    DEP_FIELD(DX8SL3OSC, PHYHRST, 1, 16)
    DEP_FIELD(DX8SL3OSC, PHYFRST, 1, 15)
    DEP_FIELD(DX8SL3OSC, DLTST, 1, 14)
    DEP_FIELD(DX8SL3OSC, DLTMODE, 1, 13)
    DEP_FIELD(DX8SL3OSC, RESERVED_12_11, 2, 11)
    DEP_FIELD(DX8SL3OSC, OSCWDDL, 2, 9)
    DEP_FIELD(DX8SL3OSC, RESERVED_8_7, 2, 7)
    DEP_FIELD(DX8SL3OSC, OSCWDL, 2, 5)
    DEP_FIELD(DX8SL3OSC, OSCDIV, 4, 1)
    DEP_FIELD(DX8SL3OSC, OSCEN, 1, 0)
DEP_REG32(DX8SL3PLLCR0, 0x14c4)
    DEP_FIELD(DX8SL3PLLCR0, PLLBYP, 1, 31)
    DEP_FIELD(DX8SL3PLLCR0, PLLRST, 1, 30)
    DEP_FIELD(DX8SL3PLLCR0, PLLPD, 1, 29)
    DEP_FIELD(DX8SL3PLLCR0, RSTOPM, 1, 28)
    DEP_FIELD(DX8SL3PLLCR0, FRQSEL, 4, 24)
    DEP_FIELD(DX8SL3PLLCR0, RLOCKM, 1, 23)
    DEP_FIELD(DX8SL3PLLCR0, CPPC, 6, 17)
    DEP_FIELD(DX8SL3PLLCR0, CPIC, 4, 13)
    DEP_FIELD(DX8SL3PLLCR0, GSHIFT, 1, 12)
    DEP_FIELD(DX8SL3PLLCR0, RESERVED_11_9, 3, 9)
    DEP_FIELD(DX8SL3PLLCR0, ATOEN, 1, 8)
    DEP_FIELD(DX8SL3PLLCR0, ATC, 4, 4)
    DEP_FIELD(DX8SL3PLLCR0, DTC, 4, 0)
DEP_REG32(DX8SL3PLLCR1, 0x14c8)
    DEP_FIELD(DX8SL3PLLCR1, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX8SL3PLLCR1, PLLPROG, 16, 6)
    DEP_FIELD(DX8SL3PLLCR1, BYPVREGCP, 1, 5)
    DEP_FIELD(DX8SL3PLLCR1, BYPVREGDIG, 1, 4)
    DEP_FIELD(DX8SL3PLLCR1, BYPVDD, 1, 3)
    DEP_FIELD(DX8SL3PLLCR1, LOCKPS, 1, 2)
    DEP_FIELD(DX8SL3PLLCR1, LOCKCS, 1, 1)
    DEP_FIELD(DX8SL3PLLCR1, LOCKDS, 1, 0)
DEP_REG32(DX8SL3PLLCR2, 0x14cc)
DEP_REG32(DX8SL3PLLCR3, 0x14d0)
DEP_REG32(DX8SL3PLLCR4, 0x14d4)
DEP_REG32(DX8SL3PLLCR5, 0x14d8)
    DEP_FIELD(DX8SL3PLLCR5, RESERVED_31_8, 24, 8)
    DEP_FIELD(DX8SL3PLLCR5, PLLCTRL_103_96, 8, 0)
DEP_REG32(DX8SL3DQSCTL, 0x14dc)
    DEP_FIELD(DX8SL3DQSCTL, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8SL3DQSCTL, RRRMODE, 1, 24)
    DEP_FIELD(DX8SL3DQSCTL, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX8SL3DQSCTL, WRRMODE, 1, 21)
    DEP_FIELD(DX8SL3DQSCTL, DQSGX, 2, 19)
    DEP_FIELD(DX8SL3DQSCTL, LPPLLPD, 1, 18)
    DEP_FIELD(DX8SL3DQSCTL, LPIOPD, 1, 17)
    DEP_FIELD(DX8SL3DQSCTL, RESERVED_16_15, 2, 15)
    DEP_FIELD(DX8SL3DQSCTL, QSCNTEN, 1, 14)
    DEP_FIELD(DX8SL3DQSCTL, UDQIOM, 1, 13)
    DEP_FIELD(DX8SL3DQSCTL, RESERVED_12_10, 3, 10)
    DEP_FIELD(DX8SL3DQSCTL, DXSR, 2, 8)
    DEP_FIELD(DX8SL3DQSCTL, DQSNRES, 4, 4)
    DEP_FIELD(DX8SL3DQSCTL, DQSRES, 4, 0)
DEP_REG32(DX8SL3TRNCTL, 0x14e0)
DEP_REG32(DX8SL3DDLCTL, 0x14e4)
    DEP_FIELD(DX8SL3DDLCTL, RESERVED_31_27, 5, 27)
    DEP_FIELD(DX8SL3DDLCTL, DLYLDTM, 1, 26)
    DEP_FIELD(DX8SL3DDLCTL, DXDDLLDT, 1, 25)
    DEP_FIELD(DX8SL3DDLCTL, RESERVED_24_23, 2, 23)
    DEP_FIELD(DX8SL3DDLCTL, DXDDLLD, 5, 18)
    DEP_FIELD(DX8SL3DDLCTL, DXDDLBYP, 16, 2)
    DEP_FIELD(DX8SL3DDLCTL, DDLBYPMODE, 2, 0)
DEP_REG32(DX8SL3DXCTL1, 0x14e8)
    DEP_FIELD(DX8SL3DXCTL1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8SL3DXCTL1, DXCALCLK, 1, 24)
    DEP_FIELD(DX8SL3DXCTL1, DXRCLKMD, 1, 23)
    DEP_FIELD(DX8SL3DXCTL1, RESERVED_22, 1, 22)
    DEP_FIELD(DX8SL3DXCTL1, DXDTOSEL, 2, 20)
    DEP_FIELD(DX8SL3DXCTL1, DXGSMD, 1, 19)
    DEP_FIELD(DX8SL3DXCTL1, DXQSDBYP, 1, 18)
    DEP_FIELD(DX8SL3DXCTL1, DXGDBYP, 1, 17)
    DEP_FIELD(DX8SL3DXCTL1, DXTMODE, 1, 16)
    DEP_FIELD(DX8SL3DXCTL1, RESERVED_15_0, 16, 0)
DEP_REG32(DX8SL3DXCTL2, 0x14ec)
    DEP_FIELD(DX8SL3DXCTL2, RESERVED_31_24, 8, 24)
    DEP_FIELD(DX8SL3DXCTL2, CRDEN, 1, 23)
    DEP_FIELD(DX8SL3DXCTL2, POSOEX, 3, 20)
    DEP_FIELD(DX8SL3DXCTL2, PREOEX, 2, 18)
    DEP_FIELD(DX8SL3DXCTL2, RESERVED_17, 1, 17)
    DEP_FIELD(DX8SL3DXCTL2, IOAG, 1, 16)
    DEP_FIELD(DX8SL3DXCTL2, IOLB, 1, 15)
    DEP_FIELD(DX8SL3DXCTL2, RESERVED_14_13, 2, 13)
    DEP_FIELD(DX8SL3DXCTL2, LPWAKEUP_THRSH, 4, 9)
    DEP_FIELD(DX8SL3DXCTL2, RDBI, 1, 8)
    DEP_FIELD(DX8SL3DXCTL2, WDBI, 1, 7)
    DEP_FIELD(DX8SL3DXCTL2, PRFBYP, 1, 6)
    DEP_FIELD(DX8SL3DXCTL2, RDMODE, 2, 4)
    DEP_FIELD(DX8SL3DXCTL2, DISRST, 1, 3)
    DEP_FIELD(DX8SL3DXCTL2, DQSGLB, 2, 1)
    DEP_FIELD(DX8SL3DXCTL2, RESERVED_0, 1, 0)
DEP_REG32(DX8SL3IOCR, 0x14f0)
    DEP_FIELD(DX8SL3IOCR, RESERVED_31, 1, 31)
    DEP_FIELD(DX8SL3IOCR, DXDACRANGE, 3, 28)
    DEP_FIELD(DX8SL3IOCR, DXVREFIOM, 3, 25)
    DEP_FIELD(DX8SL3IOCR, DXIOM, 3, 22)
    DEP_FIELD(DX8SL3IOCR, DXTXM, 11, 11)
    DEP_FIELD(DX8SL3IOCR, DXRXM, 11, 0)
DEP_REG32(DX4SL3IOCR, 0x14f4)
DEP_REG32(DX8SL4OSC, 0x1500)
    DEP_FIELD(DX8SL4OSC, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8SL4OSC, GATEDXRDCLK, 2, 28)
    DEP_FIELD(DX8SL4OSC, GATEDXDDRCLK, 2, 26)
    DEP_FIELD(DX8SL4OSC, GATEDXCTLCLK, 2, 24)
    DEP_FIELD(DX8SL4OSC, CLKLEVEL, 2, 22)
    DEP_FIELD(DX8SL4OSC, LBMODE, 1, 21)
    DEP_FIELD(DX8SL4OSC, LBGSDQS, 1, 20)
    DEP_FIELD(DX8SL4OSC, LBGDQS, 2, 18)
    DEP_FIELD(DX8SL4OSC, LBDQSS, 1, 17)
    DEP_FIELD(DX8SL4OSC, PHYHRST, 1, 16)
    DEP_FIELD(DX8SL4OSC, PHYFRST, 1, 15)
    DEP_FIELD(DX8SL4OSC, DLTST, 1, 14)
    DEP_FIELD(DX8SL4OSC, DLTMODE, 1, 13)
    DEP_FIELD(DX8SL4OSC, RESERVED_12_11, 2, 11)
    DEP_FIELD(DX8SL4OSC, OSCWDDL, 2, 9)
    DEP_FIELD(DX8SL4OSC, RESERVED_8_7, 2, 7)
    DEP_FIELD(DX8SL4OSC, OSCWDL, 2, 5)
    DEP_FIELD(DX8SL4OSC, OSCDIV, 4, 1)
    DEP_FIELD(DX8SL4OSC, OSCEN, 1, 0)
DEP_REG32(DX8SL4PLLCR0, 0x1504)
    DEP_FIELD(DX8SL4PLLCR0, PLLBYP, 1, 31)
    DEP_FIELD(DX8SL4PLLCR0, PLLRST, 1, 30)
    DEP_FIELD(DX8SL4PLLCR0, PLLPD, 1, 29)
    DEP_FIELD(DX8SL4PLLCR0, RSTOPM, 1, 28)
    DEP_FIELD(DX8SL4PLLCR0, FRQSEL, 4, 24)
    DEP_FIELD(DX8SL4PLLCR0, RLOCKM, 1, 23)
    DEP_FIELD(DX8SL4PLLCR0, CPPC, 6, 17)
    DEP_FIELD(DX8SL4PLLCR0, CPIC, 4, 13)
    DEP_FIELD(DX8SL4PLLCR0, GSHIFT, 1, 12)
    DEP_FIELD(DX8SL4PLLCR0, RESERVED_11_9, 3, 9)
    DEP_FIELD(DX8SL4PLLCR0, ATOEN, 1, 8)
    DEP_FIELD(DX8SL4PLLCR0, ATC, 4, 4)
    DEP_FIELD(DX8SL4PLLCR0, DTC, 4, 0)
DEP_REG32(DX8SL4PLLCR1, 0x1508)
    DEP_FIELD(DX8SL4PLLCR1, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX8SL4PLLCR1, PLLPROG, 16, 6)
    DEP_FIELD(DX8SL4PLLCR1, BYPVREGCP, 1, 5)
    DEP_FIELD(DX8SL4PLLCR1, BYPVREGDIG, 1, 4)
    DEP_FIELD(DX8SL4PLLCR1, BYPVDD, 1, 3)
    DEP_FIELD(DX8SL4PLLCR1, LOCKPS, 1, 2)
    DEP_FIELD(DX8SL4PLLCR1, LOCKCS, 1, 1)
    DEP_FIELD(DX8SL4PLLCR1, LOCKDS, 1, 0)
DEP_REG32(DX8SL4PLLCR2, 0x150c)
DEP_REG32(DX8SL4PLLCR3, 0x1510)
DEP_REG32(DX8SL4PLLCR4, 0x1514)
DEP_REG32(DX8SL4PLLCR5, 0x1518)
    DEP_FIELD(DX8SL4PLLCR5, RESERVED_31_8, 24, 8)
    DEP_FIELD(DX8SL4PLLCR5, PLLCTRL_103_96, 8, 0)
DEP_REG32(DX8SL4DQSCTL, 0x151c)
    DEP_FIELD(DX8SL4DQSCTL, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8SL4DQSCTL, RRRMODE, 1, 24)
    DEP_FIELD(DX8SL4DQSCTL, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX8SL4DQSCTL, WRRMODE, 1, 21)
    DEP_FIELD(DX8SL4DQSCTL, DQSGX, 2, 19)
    DEP_FIELD(DX8SL4DQSCTL, LPPLLPD, 1, 18)
    DEP_FIELD(DX8SL4DQSCTL, LPIOPD, 1, 17)
    DEP_FIELD(DX8SL4DQSCTL, RESERVED_16_15, 2, 15)
    DEP_FIELD(DX8SL4DQSCTL, QSCNTEN, 1, 14)
    DEP_FIELD(DX8SL4DQSCTL, UDQIOM, 1, 13)
    DEP_FIELD(DX8SL4DQSCTL, RESERVED_12_10, 3, 10)
    DEP_FIELD(DX8SL4DQSCTL, DXSR, 2, 8)
    DEP_FIELD(DX8SL4DQSCTL, DQSNRES, 4, 4)
    DEP_FIELD(DX8SL4DQSCTL, DQSRES, 4, 0)
DEP_REG32(DX8SL4TRNCTL, 0x1520)
DEP_REG32(DX8SL4DDLCTL, 0x1524)
    DEP_FIELD(DX8SL4DDLCTL, RESERVED_31_27, 5, 27)
    DEP_FIELD(DX8SL4DDLCTL, DLYLDTM, 1, 26)
    DEP_FIELD(DX8SL4DDLCTL, DXDDLLDT, 1, 25)
    DEP_FIELD(DX8SL4DDLCTL, RESERVED_24_23, 2, 23)
    DEP_FIELD(DX8SL4DDLCTL, DXDDLLD, 5, 18)
    DEP_FIELD(DX8SL4DDLCTL, DXDDLBYP, 16, 2)
    DEP_FIELD(DX8SL4DDLCTL, DDLBYPMODE, 2, 0)
DEP_REG32(DX8SL4DXCTL1, 0x1528)
    DEP_FIELD(DX8SL4DXCTL1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8SL4DXCTL1, DXCALCLK, 1, 24)
    DEP_FIELD(DX8SL4DXCTL1, DXRCLKMD, 1, 23)
    DEP_FIELD(DX8SL4DXCTL1, RESERVED_22, 1, 22)
    DEP_FIELD(DX8SL4DXCTL1, DXDTOSEL, 2, 20)
    DEP_FIELD(DX8SL4DXCTL1, DXGSMD, 1, 19)
    DEP_FIELD(DX8SL4DXCTL1, DXQSDBYP, 1, 18)
    DEP_FIELD(DX8SL4DXCTL1, DXGDBYP, 1, 17)
    DEP_FIELD(DX8SL4DXCTL1, DXTMODE, 1, 16)
    DEP_FIELD(DX8SL4DXCTL1, RESERVED_15_0, 16, 0)
DEP_REG32(DX8SL4DXCTL2, 0x152c)
    DEP_FIELD(DX8SL4DXCTL2, RESERVED_31_24, 8, 24)
    DEP_FIELD(DX8SL4DXCTL2, CRDEN, 1, 23)
    DEP_FIELD(DX8SL4DXCTL2, POSOEX, 3, 20)
    DEP_FIELD(DX8SL4DXCTL2, PREOEX, 2, 18)
    DEP_FIELD(DX8SL4DXCTL2, RESERVED_17, 1, 17)
    DEP_FIELD(DX8SL4DXCTL2, IOAG, 1, 16)
    DEP_FIELD(DX8SL4DXCTL2, IOLB, 1, 15)
    DEP_FIELD(DX8SL4DXCTL2, RESERVED_14_13, 2, 13)
    DEP_FIELD(DX8SL4DXCTL2, LPWAKEUP_THRSH, 4, 9)
    DEP_FIELD(DX8SL4DXCTL2, RDBI, 1, 8)
    DEP_FIELD(DX8SL4DXCTL2, WDBI, 1, 7)
    DEP_FIELD(DX8SL4DXCTL2, PRFBYP, 1, 6)
    DEP_FIELD(DX8SL4DXCTL2, RDMODE, 2, 4)
    DEP_FIELD(DX8SL4DXCTL2, DISRST, 1, 3)
    DEP_FIELD(DX8SL4DXCTL2, DQSGLB, 2, 1)
    DEP_FIELD(DX8SL4DXCTL2, RESERVED_0, 1, 0)
DEP_REG32(DX8SL4IOCR, 0x1530)
    DEP_FIELD(DX8SL4IOCR, RESERVED_31, 1, 31)
    DEP_FIELD(DX8SL4IOCR, DXDACRANGE, 3, 28)
    DEP_FIELD(DX8SL4IOCR, DXVREFIOM, 3, 25)
    DEP_FIELD(DX8SL4IOCR, DXIOM, 3, 22)
    DEP_FIELD(DX8SL4IOCR, DXTXM, 11, 11)
    DEP_FIELD(DX8SL4IOCR, DXRXM, 11, 0)
DEP_REG32(DX4SL4IOCR, 0x1534)
DEP_REG32(DX8SLBOSC, 0x17c0)
    DEP_FIELD(DX8SLBOSC, RESERVED_31_30, 2, 30)
    DEP_FIELD(DX8SLBOSC, GATEDXRDCLK, 2, 28)
    DEP_FIELD(DX8SLBOSC, GATEDXDDRCLK, 2, 26)
    DEP_FIELD(DX8SLBOSC, GATEDXCTLCLK, 2, 24)
    DEP_FIELD(DX8SLBOSC, CLKLEVEL, 2, 22)
    DEP_FIELD(DX8SLBOSC, LBMODE, 1, 21)
    DEP_FIELD(DX8SLBOSC, LBGSDQS, 1, 20)
    DEP_FIELD(DX8SLBOSC, LBGDQS, 2, 18)
    DEP_FIELD(DX8SLBOSC, LBDQSS, 1, 17)
    DEP_FIELD(DX8SLBOSC, PHYHRST, 1, 16)
    DEP_FIELD(DX8SLBOSC, PHYFRST, 1, 15)
    DEP_FIELD(DX8SLBOSC, DLTST, 1, 14)
    DEP_FIELD(DX8SLBOSC, DLTMODE, 1, 13)
    DEP_FIELD(DX8SLBOSC, RESERVED_12_11, 2, 11)
    DEP_FIELD(DX8SLBOSC, OSCWDDL, 2, 9)
    DEP_FIELD(DX8SLBOSC, RESERVED_8_7, 2, 7)
    DEP_FIELD(DX8SLBOSC, OSCWDL, 2, 5)
    DEP_FIELD(DX8SLBOSC, OSCDIV, 4, 1)
    DEP_FIELD(DX8SLBOSC, OSCEN, 1, 0)
DEP_REG32(DX8SLBPLLCR0, 0x17c4)
    DEP_FIELD(DX8SLBPLLCR0, PLLBYP, 1, 31)
    DEP_FIELD(DX8SLBPLLCR0, PLLRST, 1, 30)
    DEP_FIELD(DX8SLBPLLCR0, PLLPD, 1, 29)
    DEP_FIELD(DX8SLBPLLCR0, RSTOPM, 1, 28)
    DEP_FIELD(DX8SLBPLLCR0, FRQSEL, 4, 24)
    DEP_FIELD(DX8SLBPLLCR0, RLOCKM, 1, 23)
    DEP_FIELD(DX8SLBPLLCR0, CPPC, 6, 17)
    DEP_FIELD(DX8SLBPLLCR0, CPIC, 4, 13)
    DEP_FIELD(DX8SLBPLLCR0, GSHIFT, 1, 12)
    DEP_FIELD(DX8SLBPLLCR0, RESERVED_11_9, 3, 9)
    DEP_FIELD(DX8SLBPLLCR0, ATOEN, 1, 8)
    DEP_FIELD(DX8SLBPLLCR0, ATC, 4, 4)
    DEP_FIELD(DX8SLBPLLCR0, DTC, 4, 0)
DEP_REG32(DX8SLBPLLCR1, 0x17c8)
    DEP_FIELD(DX8SLBPLLCR1, RESERVED_31_22, 10, 22)
    DEP_FIELD(DX8SLBPLLCR1, PLLPROG, 16, 6)
    DEP_FIELD(DX8SLBPLLCR1, BYPVREGCP, 1, 5)
    DEP_FIELD(DX8SLBPLLCR1, BYPVREGDIG, 1, 4)
    DEP_FIELD(DX8SLBPLLCR1, BYPVDD, 1, 3)
    DEP_FIELD(DX8SLBPLLCR1, LOCKPS, 1, 2)
    DEP_FIELD(DX8SLBPLLCR1, LOCKCS, 1, 1)
    DEP_FIELD(DX8SLBPLLCR1, LOCKDS, 1, 0)
DEP_REG32(DX8SLBPLLCR2, 0x17cc)
DEP_REG32(DX8SLBPLLCR3, 0x17d0)
DEP_REG32(DX8SLBPLLCR4, 0x17d4)
DEP_REG32(DX8SLBPLLCR5, 0x17d8)
    DEP_FIELD(DX8SLBPLLCR5, RESERVED_31_8, 24, 8)
    DEP_FIELD(DX8SLBPLLCR5, PLLCTRL_103_96, 8, 0)
DEP_REG32(DX8SLBDQSCTL, 0x17dc)
    DEP_FIELD(DX8SLBDQSCTL, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8SLBDQSCTL, RRRMODE, 1, 24)
    DEP_FIELD(DX8SLBDQSCTL, RESERVED_23_22, 2, 22)
    DEP_FIELD(DX8SLBDQSCTL, WRRMODE, 1, 21)
    DEP_FIELD(DX8SLBDQSCTL, DQSGX, 2, 19)
    DEP_FIELD(DX8SLBDQSCTL, LPPLLPD, 1, 18)
    DEP_FIELD(DX8SLBDQSCTL, LPIOPD, 1, 17)
    DEP_FIELD(DX8SLBDQSCTL, RESERVED_16_15, 2, 15)
    DEP_FIELD(DX8SLBDQSCTL, QSCNTEN, 1, 14)
    DEP_FIELD(DX8SLBDQSCTL, UDQIOM, 1, 13)
    DEP_FIELD(DX8SLBDQSCTL, RESERVED_12_10, 3, 10)
    DEP_FIELD(DX8SLBDQSCTL, DXSR, 2, 8)
    DEP_FIELD(DX8SLBDQSCTL, DQSNRES, 4, 4)
    DEP_FIELD(DX8SLBDQSCTL, DQSRES, 4, 0)
DEP_REG32(DX8SLBTRNCTL, 0x17e0)
DEP_REG32(DX8SLBDDLCTL, 0x17e4)
    DEP_FIELD(DX8SLBDDLCTL, RESERVED_31_27, 5, 27)
    DEP_FIELD(DX8SLBDDLCTL, DLYLDTM, 1, 26)
    DEP_FIELD(DX8SLBDDLCTL, DXDDLLDT, 1, 25)
    DEP_FIELD(DX8SLBDDLCTL, RESERVED_24_23, 2, 23)
    DEP_FIELD(DX8SLBDDLCTL, DXDDLLD, 5, 18)
    DEP_FIELD(DX8SLBDDLCTL, DXDDLBYP, 16, 2)
    DEP_FIELD(DX8SLBDDLCTL, DDLBYPMODE, 2, 0)
DEP_REG32(DX8SLBDXCTL1, 0x17e8)
    DEP_FIELD(DX8SLBDXCTL1, RESERVED_31_25, 7, 25)
    DEP_FIELD(DX8SLBDXCTL1, DXCALCLK, 1, 24)
    DEP_FIELD(DX8SLBDXCTL1, DXRCLKMD, 1, 23)
    DEP_FIELD(DX8SLBDXCTL1, RESERVED_22, 1, 22)
    DEP_FIELD(DX8SLBDXCTL1, DXDTOSEL, 2, 20)
    DEP_FIELD(DX8SLBDXCTL1, DXGSMD, 1, 19)
    DEP_FIELD(DX8SLBDXCTL1, DXQSDBYP, 1, 18)
    DEP_FIELD(DX8SLBDXCTL1, DXGDBYP, 1, 17)
    DEP_FIELD(DX8SLBDXCTL1, DXTMODE, 1, 16)
    DEP_FIELD(DX8SLBDXCTL1, RESERVED_15_0, 16, 0)
DEP_REG32(DX8SLBDXCTL2, 0x17ec)
    DEP_FIELD(DX8SLBDXCTL2, RESERVED_31_24, 8, 24)
    DEP_FIELD(DX8SLBDXCTL2, CRDEN, 1, 23)
    DEP_FIELD(DX8SLBDXCTL2, POSOEX, 3, 20)
    DEP_FIELD(DX8SLBDXCTL2, PREOEX, 2, 18)
    DEP_FIELD(DX8SLBDXCTL2, RESERVED_17, 1, 17)
    DEP_FIELD(DX8SLBDXCTL2, IOAG, 1, 16)
    DEP_FIELD(DX8SLBDXCTL2, IOLB, 1, 15)
    DEP_FIELD(DX8SLBDXCTL2, RESERVED_14_13, 2, 13)
    DEP_FIELD(DX8SLBDXCTL2, LPWAKEUP_THRSH, 4, 9)
    DEP_FIELD(DX8SLBDXCTL2, RDBI, 1, 8)
    DEP_FIELD(DX8SLBDXCTL2, WDBI, 1, 7)
    DEP_FIELD(DX8SLBDXCTL2, PRFBYP, 1, 6)
    DEP_FIELD(DX8SLBDXCTL2, RDMODE, 2, 4)
    DEP_FIELD(DX8SLBDXCTL2, DISRST, 1, 3)
    DEP_FIELD(DX8SLBDXCTL2, DQSGLB, 2, 1)
    DEP_FIELD(DX8SLBDXCTL2, RESERVED_0, 1, 0)
DEP_REG32(DX8SLBIOCR, 0x17f0)
    DEP_FIELD(DX8SLBIOCR, RESERVED_31, 1, 31)
    DEP_FIELD(DX8SLBIOCR, DXDACRANGE, 3, 28)
    DEP_FIELD(DX8SLBIOCR, DXVREFIOM, 3, 25)
    DEP_FIELD(DX8SLBIOCR, DXIOM, 3, 22)
    DEP_FIELD(DX8SLBIOCR, DXTXM, 11, 11)
    DEP_FIELD(DX8SLBIOCR, DXRXM, 11, 0)
DEP_REG32(DX4SLBIOCR, 0x17f4)

#define R_MAX (R_DX4SLBIOCR + 1)

typedef struct DDR_PHY {
    SysBusDevice parent_obj;
    MemoryRegion iomem;

    uint32_t regs[R_MAX];
    DepRegisterInfo regs_info[R_MAX];
} DDR_PHY;

#define DDR_PIR_REACT(val, src, dest) \
    do { \
        if (val & R_PIR_ ## src ## _MASK) { \
            DEP_AF_DP32(s->regs, PGSR0, dest , 0x1);\
        } \
    } while (0)

static uint64_t ddr_phy_pir_pre_write(DepRegisterInfo *reg, uint64_t val)
{
    DDR_PHY *s = reg->opaque;

    /* Set the corresponding bit in the PGSR0 register */
    DDR_PIR_REACT(val, DRAMINIT, DIDONE);
    DDR_PIR_REACT(val, ZCAL, ZCDONE);
    DDR_PIR_REACT(val, DCAL, DCDONE);
    DDR_PIR_REACT(val, PLLINIT, PLDONE);
    DDR_PIR_REACT(val, WLADJ, WLADONE);
    DDR_PIR_REACT(val, RDDSKW, RDDONE);
    DDR_PIR_REACT(val, WRDSKW, WDDONE);
    DDR_PIR_REACT(val, RDEYE, REDONE);
    DDR_PIR_REACT(val, WREYE, WEDONE);
    DDR_PIR_REACT(val, WL, WLDONE);
    DDR_PIR_REACT(val, QSGATE, QSGDONE);
    DDR_PIR_REACT(val, VREF, VDONE);

    return val;
}

static uint64_t ddr_phy_pgsr0_post_read(DepRegisterInfo *reg, uint64_t val)
{
    DDR_PHY *s = reg->opaque;

    /* Flip the bits stored in the register as some guests require the status
     * to change and we don't fully model the device.
     */
    s->regs[R_PGSR0] ^= R_PGSR0_DIDONE_MASK;

    return val;
}

static DepRegisterAccessInfo ddr_phy_regs_info[] = {
    {   .name = "RIDR",  .decode.addr = A_RIDR,
        .reset = 0x112112,
        .ro = 0xffffffff,
    },{ .name = "PIR",  .decode.addr = A_PIR,
        .ro = 0x9fe00008,
        .w1c = 0x60000001,
        .pre_write = ddr_phy_pir_pre_write,
    },{ .name = "PGCR0",  .decode.addr = A_PGCR0,
        .reset = 0x7001e00,
        .ro = 0x78f820ff,
    },{ .name = "PGCR1",  .decode.addr = A_PGCR1,
        .reset = 0x2004600,
        .ro = 0x60080180,
    },{ .name = "PGCR2",  .decode.addr = A_PGCR2,
        .reset = 0xf12480,
        .w1c = 0xe0000000,
    },{ .name = "PGCR3",  .decode.addr = A_PGCR3,
        .reset = 0x55aa0080,
        .ro = 0x8100,
    },{ .name = "PGCR4",  .decode.addr = A_PGCR4,
        .reset = 0x1800c3,
        .ro = 0xc007ff0c,
    },{ .name = "PGCR5",  .decode.addr = A_PGCR5,
        .reset = 0x1010000,
        .ro = 0x8,
    },{ .name = "PGCR6",  .decode.addr = A_PGCR6,
        .reset = 0x13000,
        .ro = 0xff00c0fc,
    },{ .name = "PGCR7",  .decode.addr = A_PGCR7,
        .ro = 0xffffff00,
    },{ .name = "PGSR0",  .decode.addr = A_PGSR0,
        .ro = 0xffffffff,
        /* Report all ready.  */
        .reset = 0x8000000f,
        .post_read = ddr_phy_pgsr0_post_read,
    },{ .name = "PGSR1",  .decode.addr = A_PGSR1,
        .ro = 0xffffffff,
    },{ .name = "PGSR2",  .decode.addr = A_PGSR2,
        .ro = 0xffffffff,
    },{ .name = "PTR0",  .decode.addr = A_PTR0,
        .reset = 0x42c21590,
    },{ .name = "PTR1",  .decode.addr = A_PTR1,
        .reset = 0xd05612c0,
        .ro = 0xe000,
    },{ .name = "PTR2",  .decode.addr = A_PTR2,
        .reset = 0x83def,
        .ro = 0xfff00000,
    },{ .name = "PTR3",  .decode.addr = A_PTR3,
        .reset = 0x411810,
        .ro = 0xff800000,
    },{ .name = "PTR4",  .decode.addr = A_PTR4,
        .reset = 0x10aa,
        .ro = 0xffffe000,
    },{ .name = "PTR5",  .decode.addr = A_PTR5,
        .reset = 0x68268,
        .ro = 0xfff80000,
    },{ .name = "PTR6",  .decode.addr = A_PTR6,
        .reset = 0x4000855,
        .ro = 0xf80ff000,
    },{ .name = "PLLCR0",  .decode.addr = A_PLLCR0,
        .reset = 0x1c0000,
        .ro = 0xe00,
    },{ .name = "PLLCR1",  .decode.addr = A_PLLCR1,
        .ro = 0xffc0,
    },{ .name = "PLLCR2",  .decode.addr = A_PLLCR2,
    },{ .name = "PLLCR3",  .decode.addr = A_PLLCR3,
    },{ .name = "PLLCR4",  .decode.addr = A_PLLCR4,
    },{ .name = "PLLCR5",  .decode.addr = A_PLLCR5,
        .ro = 0xffffff00,
    },{ .name = "DXCCR",  .decode.addr = A_DXCCR,
        .reset = 0x20000038,
        .ro = 0xdfffff87,
    },{ .name = "DSGCR",  .decode.addr = A_DSGCR,
        .reset = 0x2a04101,
        .ro = 0xf0442018,
    },{ .name = "ODTCR",  .decode.addr = A_ODTCR,
        .reset = 0x10000,
        .ro = 0xfffcfffc,
    },{ .name = "AACR",  .decode.addr = A_AACR,
        .reset = 0xff,
    },{ .name = "GPR0",  .decode.addr = A_GPR0,
    },{ .name = "GPR1",  .decode.addr = A_GPR1,
    },{ .name = "DCR",  .decode.addr = A_DCR,
        .reset = 0x40d,
        .ro = 0x7fc0000,
    },{ .name = "DTPR0",  .decode.addr = A_DTPR0,
        .reset = 0x105a2d08,
        .ro = 0xe08080e0,
    },{ .name = "DTPR1",  .decode.addr = A_DTPR1,
        .reset = 0x5656041e,
        .ro = 0x8080f8e0,
    },{ .name = "DTPR2",  .decode.addr = A_DTPR2,
        .reset = 0xb01d0,
        .ro = 0xeef0fc00,
    },{ .name = "DTPR3",  .decode.addr = A_DTPR3,
        .reset = 0x2000804,
        .ro = 0xf0f8,
    },{ .name = "DTPR4",  .decode.addr = A_DTPR4,
        .reset = 0x1c02b10,
        .ro = 0xcc00c0e0,
    },{ .name = "DTPR5",  .decode.addr = A_DTPR5,
        .reset = 0x872716,
        .ro = 0xff0080e0,
    },{ .name = "DTPR6",  .decode.addr = A_DTPR6,
        .reset = 0x505,
        .ro = 0x3fffc0c0,
    },{ .name = "RDIMMGCR0",  .decode.addr = A_RDIMMGCR0,
        .reset = 0x8400020,
        .ro = 0xb711ffc8,
    },{ .name = "RDIMMGCR1",  .decode.addr = A_RDIMMGCR1,
        .reset = 0xc80,
        .ro = 0xe888c000,
    },{ .name = "RDIMMGCR2",  .decode.addr = A_RDIMMGCR2,
        .reset = 0x3ffffbf,
    },{ .name = "RDIMMCR0",  .decode.addr = A_RDIMMCR0,
    },{ .name = "RDIMMCR1",  .decode.addr = A_RDIMMCR1,
    },{ .name = "RDIMMCR2",  .decode.addr = A_RDIMMCR2,
    },{ .name = "RDIMMCR3",  .decode.addr = A_RDIMMCR3,
    },{ .name = "RDIMMCR4",  .decode.addr = A_RDIMMCR4,
    },{ .name = "SCHCR0",  .decode.addr = A_SCHCR0,
        .ro = 0xfe00f000,
        .w1c = 0xf,
    },{ .name = "SCHCR1",  .decode.addr = A_SCHCR1,
        .ro = 0xb,
    },{ .name = "MR0",  .decode.addr = A_MR0,
        .reset = 0x52,
        .ro = 0xffffff80,
    },{ .name = "MR1",  .decode.addr = A_MR1,
        .reset = 0x4,
        .ro = 0xffffff00,
    },{ .name = "MR2",  .decode.addr = A_MR2,
        .ro = 0xffffff00,
    },{ .name = "MR3",  .decode.addr = A_MR3,
        .reset = 0x31,
        .ro = 0xffffff00,
    },{ .name = "MR4",  .decode.addr = A_MR4,
        .ro = 0xffff0000,
    },{ .name = "MR5",  .decode.addr = A_MR5,
        .ro = 0xffff0000,
    },{ .name = "MR6",  .decode.addr = A_MR6,
        .ro = 0xffffe000,
    },{ .name = "MR7",  .decode.addr = A_MR7,
        .ro = 0xffff0000,
    },{ .name = "MR11",  .decode.addr = A_MR11,
        .ro = 0xffffff00,
    },{ .name = "MR12",  .decode.addr = A_MR12,
        .reset = 0x4d,
        .ro = 0xffffff00,
    },{ .name = "MR13",  .decode.addr = A_MR13,
        .ro = 0xffffff00,
    },{ .name = "MR14",  .decode.addr = A_MR14,
        .reset = 0x4d,
        .ro = 0xffffff80,
    },{ .name = "MR22",  .decode.addr = A_MR22,
        .ro = 0xffffff00,
    },{ .name = "DTCR0",  .decode.addr = A_DTCR0,
        .reset = 0x800091c7,
        .ro = 0xc002030,
    },{ .name = "DTCR1",  .decode.addr = A_DTCR1,
        .reset = 0x30237,
        .ro = 0xfffcc888,
    },{ .name = "DTAR0",  .decode.addr = A_DTAR0,
        .reset = 0x4000000,
        .ro = 0xc00c0000,
    },{ .name = "DTAR1",  .decode.addr = A_DTAR1,
        .reset = 0x10000,
        .ro = 0xfe00fe00,
    },{ .name = "DTAR2",  .decode.addr = A_DTAR2,
        .reset = 0x30002,
        .ro = 0xfe00fe00,
    },{ .name = "DTDR0",  .decode.addr = A_DTDR0,
        .reset = 0xdd22ee11,
    },{ .name = "DTDR1",  .decode.addr = A_DTDR1,
        .reset = 0x7788bb44,
    },{ .name = "DTEDR0",  .decode.addr = A_DTEDR0,
        .ro = 0xffffffff,
    },{ .name = "DTEDR1",  .decode.addr = A_DTEDR1,
        .ro = 0xffffffff,
    },{ .name = "DTEDR2",  .decode.addr = A_DTEDR2,
        .ro = 0xffffffff,
    },{ .name = "VTDR",  .decode.addr = A_VTDR,
        .reset = 0x7f003f00,
        .ro = 0xffffffff,
    },{ .name = "CATR0",  .decode.addr = A_CATR0,
        .reset = 0x141054,
        .ro = 0xffe0e000,
    },{ .name = "CATR1",  .decode.addr = A_CATR1,
        .reset = 0x103aaaa,
        .ro = 0xf0000000,
    },{ .name = "DQSDR0",  .decode.addr = A_DQSDR0,
        .reset = 0x88000,
        .ro = 0x3c00f00,
    },{ .name = "DQSDR1",  .decode.addr = A_DQSDR1,
        .ro = 0xff000000,
    },{ .name = "DQSDR2",  .decode.addr = A_DQSDR2,
        .ro = 0xff000000,
    },{ .name = "DCUAR",  .decode.addr = A_DCUAR,
        .ro = 0xfff00000,
    },{ .name = "DCUDR",  .decode.addr = A_DCUDR,
    },{ .name = "DCURR",  .decode.addr = A_DCURR,
        .ro = 0xff000000,
    },{ .name = "DCULR",  .decode.addr = A_DCULR,
        .reset = 0xf0000000,
        .ro = 0xffc0000,
    },{ .name = "DCUGCR",  .decode.addr = A_DCUGCR,
        .ro = 0xffff0000,
    },{ .name = "DCUTPR",  .decode.addr = A_DCUTPR,
    },{ .name = "DCUSR0",  .decode.addr = A_DCUSR0,
        .ro = 0xffffffff,
    },{ .name = "DCUSR1",  .decode.addr = A_DCUSR1,
        .ro = 0xffffffff,
    },{ .name = "BISTRR",  .decode.addr = A_BISTRR,
        .reset = 0x780000,
        .ro = 0xc0000000,
    },{ .name = "BISTWCR",  .decode.addr = A_BISTWCR,
        .reset = 0x200020,
    },{ .name = "BISTMSKR0",  .decode.addr = A_BISTMSKR0,
        .ro = 0xffc40000,
    },{ .name = "BISTMSKR1",  .decode.addr = A_BISTMSKR1,
        .ro = 0x6fcfc0f,
    },{ .name = "BISTMSKR2",  .decode.addr = A_BISTMSKR2,
    },{ .name = "BISTLSR",  .decode.addr = A_BISTLSR,
        .reset = 0x1234abcd,
    },{ .name = "BISTAR0",  .decode.addr = A_BISTAR0,
        .ro = 0xffff000,
    },{ .name = "BISTAR1",  .decode.addr = A_BISTAR1,
        .reset = 0xf0000,
        .ro = 0xfff00000,
    },{ .name = "BISTAR2",  .decode.addr = A_BISTAR2,
        .reset = 0xf0000fff,
        .ro = 0xffff000,
    },{ .name = "BISTAR3",  .decode.addr = A_BISTAR3,
        .ro = 0xfffc0000,
    },{ .name = "BISTAR4",  .decode.addr = A_BISTAR4,
        .reset = 0x3ffff,
        .ro = 0xfffc0000,
    },{ .name = "BISTUDPR",  .decode.addr = A_BISTUDPR,
        .reset = 0xffff0000,
    },{ .name = "BISTGSR",  .decode.addr = A_BISTGSR,
        .ro = 0xffffffff,
    },{ .name = "BISTWER0",  .decode.addr = A_BISTWER0,
        .ro = 0xffffffff,
    },{ .name = "BISTWER1",  .decode.addr = A_BISTWER1,
        .ro = 0xffffffff,
    },{ .name = "BISTBER0",  .decode.addr = A_BISTBER0,
        .ro = 0xffffffff,
    },{ .name = "BISTBER1",  .decode.addr = A_BISTBER1,
        .ro = 0xffffffff,
    },{ .name = "BISTBER2",  .decode.addr = A_BISTBER2,
        .ro = 0xffffffff,
    },{ .name = "BISTBER3",  .decode.addr = A_BISTBER3,
        .ro = 0xffffffff,
    },{ .name = "BISTBER4",  .decode.addr = A_BISTBER4,
        .ro = 0xffffffff,
    },{ .name = "BISTWCSR",  .decode.addr = A_BISTWCSR,
        .ro = 0xffffffff,
    },{ .name = "BISTFWR0",  .decode.addr = A_BISTFWR0,
        .ro = 0xffffffff,
    },{ .name = "BISTFWR1",  .decode.addr = A_BISTFWR1,
        .ro = 0xffffffff,
    },{ .name = "BISTFWR2",  .decode.addr = A_BISTFWR2,
        .ro = 0xffffffff,
    },{ .name = "BISTBER5",  .decode.addr = A_BISTBER5,
        .ro = 0xffffffff,
    },{ .name = "RANKIDR",  .decode.addr = A_RANKIDR,
        .ro = 0xfff0fff0,
    },{ .name = "RIOCR0",  .decode.addr = A_RIOCR0,
        .ro = 0xffffffff,
    },{ .name = "RIOCR1",  .decode.addr = A_RIOCR1,
        .ro = 0xffffffff,
    },{ .name = "RIOCR2",  .decode.addr = A_RIOCR2,
        .ro = 0xfcfffff0,
    },{ .name = "RIOCR3",  .decode.addr = A_RIOCR3,
        .ro = 0xffffffff,
    },{ .name = "RIOCR4",  .decode.addr = A_RIOCR4,
        .reset = 0x5,
        .ro = 0xfffffff0,
    },{ .name = "RIOCR5",  .decode.addr = A_RIOCR5,
        .reset = 0x5,
        .ro = 0xfffffff0,
    },{ .name = "ACIOCR0",  .decode.addr = A_ACIOCR0,
        .reset = 0x30000000,
        .ro = 0xbfffc02,
    },{ .name = "ACIOCR1",  .decode.addr = A_ACIOCR1,
    },{ .name = "ACIOCR2",  .decode.addr = A_ACIOCR2,
    },{ .name = "ACIOCR3",  .decode.addr = A_ACIOCR3,
        .reset = 0x5,
        .ro = 0xfff0,
    },{ .name = "ACIOCR4",  .decode.addr = A_ACIOCR4,
    },{ .name = "ACIOCR5",  .decode.addr = A_ACIOCR5,
        .ro = 0xf0000000,
    },{ .name = "IOVCR0",  .decode.addr = A_IOVCR0,
        .reset = 0xf000000,
        .ro = 0xe0000000,
    },{ .name = "IOVCR1",  .decode.addr = A_IOVCR1,
        .ro = 0xffffffff,
    },{ .name = "VTCR0",  .decode.addr = A_VTCR0,
        .reset = 0x70032019,
        .ro = 0x4000000,
    },{ .name = "VTCR1",  .decode.addr = A_VTCR1,
        .reset = 0x7f00072,
        .ro = 0x8080800,
    },{ .name = "ACBDLR0",  .decode.addr = A_ACBDLR0,
        .ro = 0xc0c0c0c0,
    },{ .name = "ACBDLR1",  .decode.addr = A_ACBDLR1,
        .ro = 0xc0c0c0c0,
    },{ .name = "ACBDLR2",  .decode.addr = A_ACBDLR2,
        .ro = 0xc0c0c0c0,
    },{ .name = "ACBDLR3",  .decode.addr = A_ACBDLR3,
        .ro = 0xffffc0c0,
    },{ .name = "ACBDLR4",  .decode.addr = A_ACBDLR4,
        .ro = 0xffffc0c0,
    },{ .name = "ACBDLR5",  .decode.addr = A_ACBDLR5,
        .ro = 0xffffc0c0,
    },{ .name = "ACBDLR6",  .decode.addr = A_ACBDLR6,
        .ro = 0xc0c0c0c0,
    },{ .name = "ACBDLR7",  .decode.addr = A_ACBDLR7,
        .ro = 0xc0c0c0c0,
    },{ .name = "ACBDLR8",  .decode.addr = A_ACBDLR8,
        .ro = 0xc0c0c0c0,
    },{ .name = "ACBDLR9",  .decode.addr = A_ACBDLR9,
        .ro = 0xc0c0c0c0,
    },{ .name = "ACBDLR10",  .decode.addr = A_ACBDLR10,
        .ro = 0xffffc0ff,
    },{ .name = "ACBDLR11",  .decode.addr = A_ACBDLR11,
        .ro = 0xffffffff,
    },{ .name = "ACBDLR12",  .decode.addr = A_ACBDLR12,
        .ro = 0xffffffff,
    },{ .name = "ACBDLR13",  .decode.addr = A_ACBDLR13,
        .ro = 0xffffffff,
    },{ .name = "ACBDLR14",  .decode.addr = A_ACBDLR14,
        .ro = 0xffffffff,
    },{ .name = "ACBDLR15",  .decode.addr = A_ACBDLR15,
        .ro = 0xffc0c0c0,
    },{ .name = "ACBDLR16",  .decode.addr = A_ACBDLR16,
        .ro = 0xc0c0c0c0,
    },{ .name = "ACLCDLR",  .decode.addr = A_ACLCDLR,
        .ro = 0xfe00fe00,
    },{ .name = "ACMDLR0",  .decode.addr = A_ACMDLR0,
        .ro = 0xfe00fe00,
    },{ .name = "ACMDLR1",  .decode.addr = A_ACMDLR1,
        .ro = 0xfe00fe00,
    },{ .name = "ZQCR",  .decode.addr = A_ZQCR,
        .reset = 0x8a2858,
        .ro = 0xfc000001,
    },{ .name = "ZQ0PR0",  .decode.addr = A_ZQ0PR0,
        .reset = 0x77bb,
    },{ .name = "ZQ0PR1",  .decode.addr = A_ZQ0PR1,
        .reset = 0xb0b,
        .ro = 0xffff8080,
    },{ .name = "ZQ0DR0",  .decode.addr = A_ZQ0DR0,
        .ro = 0xffffffff,
    },{ .name = "ZQ0DR1",  .decode.addr = A_ZQ0DR1,
        .ro = 0xffffffff,
    },{ .name = "ZQ0OR0",  .decode.addr = A_ZQ0OR0,
        .ro = 0xfc00fc00,
    },{ .name = "ZQ0OR1",  .decode.addr = A_ZQ0OR1,
        .ro = 0xfc00fc00,
    },{ .name = "ZQ0SR",  .decode.addr = A_ZQ0SR,
        .ro = 0xffffffff,
    },{ .name = "ZQ1PR0",  .decode.addr = A_ZQ1PR0,
        .reset = 0x77bb,
    },{ .name = "ZQ1PR1",  .decode.addr = A_ZQ1PR1,
        .reset = 0xb0b,
        .ro = 0xffff8080,
    },{ .name = "ZQ1DR0",  .decode.addr = A_ZQ1DR0,
        .ro = 0xffffffff,
    },{ .name = "ZQ1DR1",  .decode.addr = A_ZQ1DR1,
        .ro = 0xffffffff,
    },{ .name = "ZQ1OR0",  .decode.addr = A_ZQ1OR0,
        .ro = 0xfc00fc00,
    },{ .name = "ZQ1OR1",  .decode.addr = A_ZQ1OR1,
        .ro = 0xfc00fc00,
    },{ .name = "ZQ1SR",  .decode.addr = A_ZQ1SR,
        .ro = 0xffffffff,
    },{ .name = "ZQ2PR0",  .decode.addr = A_ZQ2PR0,
        .ro = 0xffffffff,
    },{ .name = "ZQ2PR1",  .decode.addr = A_ZQ2PR1,
        .ro = 0xffffffff,
    },{ .name = "ZQ2DR0",  .decode.addr = A_ZQ2DR0,
        .ro = 0xffffffff,
    },{ .name = "ZQ2DR1",  .decode.addr = A_ZQ2DR1,
        .ro = 0xffffffff,
    },{ .name = "ZQ2OR0",  .decode.addr = A_ZQ2OR0,
        .ro = 0xffffffff,
    },{ .name = "ZQ2OR1",  .decode.addr = A_ZQ2OR1,
        .ro = 0xffffffff,
    },{ .name = "ZQ2SR",  .decode.addr = A_ZQ2SR,
        .ro = 0xffffffff,
    },{ .name = "ZQ3PR0",  .decode.addr = A_ZQ3PR0,
        .ro = 0xffffffff,
    },{ .name = "ZQ3PR1",  .decode.addr = A_ZQ3PR1,
        .ro = 0xffffffff,
    },{ .name = "ZQ3DR0",  .decode.addr = A_ZQ3DR0,
        .ro = 0xffffffff,
    },{ .name = "ZQ3DR1",  .decode.addr = A_ZQ3DR1,
        .ro = 0xffffffff,
    },{ .name = "ZQ3OR0",  .decode.addr = A_ZQ3OR0,
        .ro = 0xffffffff,
    },{ .name = "ZQ3OR1",  .decode.addr = A_ZQ3OR1,
        .ro = 0xffffffff,
    },{ .name = "ZQ3SR",  .decode.addr = A_ZQ3SR,
        .ro = 0xffffffff,
    },{ .name = "DX0GCR0",  .decode.addr = A_DX0GCR0,
        .reset = 0x40200204,
        .ro = 0xfc013,
    },{ .name = "DX0GCR1",  .decode.addr = A_DX0GCR1,
        .reset = 0x7fff,
        .ro = 0x8000,
    },{ .name = "DX0GCR2",  .decode.addr = A_DX0GCR2,
    },{ .name = "DX0GCR3",  .decode.addr = A_DX0GCR3,
        .reset = 0x3f000008,
        .ro = 0xc0c00303,
    },{ .name = "DX0GCR4",  .decode.addr = A_DX0GCR4,
        .reset = 0xe00003c,
        .ro = 0xe10000c0,
    },{ .name = "DX0GCR5",  .decode.addr = A_DX0GCR5,
        .reset = 0x9090909,
        .ro = 0x80808080,
    },{ .name = "DX0GCR6",  .decode.addr = A_DX0GCR6,
        .reset = 0x9090909,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX0GCR7",  .decode.addr = A_DX0GCR7,
        .ro = 0xffffffff,
    },{ .name = "DX0GCR8",  .decode.addr = A_DX0GCR8,
        .ro = 0xffffffff,
    },{ .name = "DX0GCR9",  .decode.addr = A_DX0GCR9,
        .ro = 0xffffffff,
    },{ .name = "DX0BDLR0",  .decode.addr = A_DX0BDLR0,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX0BDLR1",  .decode.addr = A_DX0BDLR1,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX0BDLR2",  .decode.addr = A_DX0BDLR2,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX0BDLR3",  .decode.addr = A_DX0BDLR3,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX0BDLR4",  .decode.addr = A_DX0BDLR4,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX0BDLR5",  .decode.addr = A_DX0BDLR5,
        .ro = 0xffffffc0,
    },{ .name = "DX0BDLR6",  .decode.addr = A_DX0BDLR6,
        .ro = 0xffc0c0ff,
    },{ .name = "DX0BDLR7",  .decode.addr = A_DX0BDLR7,
        .ro = 0xffffffff,
    },{ .name = "DX0BDLR8",  .decode.addr = A_DX0BDLR8,
        .ro = 0xffffffff,
    },{ .name = "DX0BDLR9",  .decode.addr = A_DX0BDLR9,
        .ro = 0xffffffff,
    },{ .name = "DX0LCDLR0",  .decode.addr = A_DX0LCDLR0,
        .ro = 0xfffffe00,
    },{ .name = "DX0LCDLR1",  .decode.addr = A_DX0LCDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX0LCDLR2",  .decode.addr = A_DX0LCDLR2,
        .ro = 0xfffffe00,
    },{ .name = "DX0LCDLR3",  .decode.addr = A_DX0LCDLR3,
        .ro = 0xfffffe00,
    },{ .name = "DX0LCDLR4",  .decode.addr = A_DX0LCDLR4,
        .ro = 0xfffffe00,
    },{ .name = "DX0LCDLR5",  .decode.addr = A_DX0LCDLR5,
        .ro = 0xfffffe00,
    },{ .name = "DX0MDLR0",  .decode.addr = A_DX0MDLR0,
        .ro = 0xfe00fe00,
    },{ .name = "DX0MDLR1",  .decode.addr = A_DX0MDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX0GTR0",  .decode.addr = A_DX0GTR0,
        .reset = 0x20000,
        .ro = 0xf8f0ffe0,
    },{ .name = "DX0RSR0",  .decode.addr = A_DX0RSR0,
        .ro = 0xffffffff,
    },{ .name = "DX0RSR1",  .decode.addr = A_DX0RSR1,
        .ro = 0xffffffff,
    },{ .name = "DX0RSR2",  .decode.addr = A_DX0RSR2,
        .ro = 0xffffffff,
    },{ .name = "DX0RSR3",  .decode.addr = A_DX0RSR3,
        .ro = 0xffffffff,
    },{ .name = "DX0GSR0",  .decode.addr = A_DX0GSR0,
        .ro = 0xffffffff,
    },{ .name = "DX0GSR1",  .decode.addr = A_DX0GSR1,
        .ro = 0xffffffff,
    },{ .name = "DX0GSR2",  .decode.addr = A_DX0GSR2,
        .ro = 0xffffffff,
    },{ .name = "DX0GSR3",  .decode.addr = A_DX0GSR3,
        .ro = 0xffffffff,
    },{ .name = "DX0GSR4",  .decode.addr = A_DX0GSR4,
        .ro = 0xffffffff,
    },{ .name = "DX0GSR5",  .decode.addr = A_DX0GSR5,
        .ro = 0xffffffff,
    },{ .name = "DX0GSR6",  .decode.addr = A_DX0GSR6,
        .ro = 0xffffffff,
    },{ .name = "DX1GCR0",  .decode.addr = A_DX1GCR0,
        .reset = 0x40200204,
        .ro = 0xfc013,
    },{ .name = "DX1GCR1",  .decode.addr = A_DX1GCR1,
        .reset = 0x7fff,
        .ro = 0x8000,
    },{ .name = "DX1GCR2",  .decode.addr = A_DX1GCR2,
    },{ .name = "DX1GCR3",  .decode.addr = A_DX1GCR3,
        .reset = 0x3f000008,
        .ro = 0xc0c00303,
    },{ .name = "DX1GCR4",  .decode.addr = A_DX1GCR4,
        .reset = 0xe00003c,
        .ro = 0xe10000c0,
    },{ .name = "DX1GCR5",  .decode.addr = A_DX1GCR5,
        .reset = 0x9090909,
        .ro = 0x80808080,
    },{ .name = "DX1GCR6",  .decode.addr = A_DX1GCR6,
        .reset = 0x9090909,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX1GCR7",  .decode.addr = A_DX1GCR7,
        .ro = 0xffffffff,
    },{ .name = "DX1GCR8",  .decode.addr = A_DX1GCR8,
        .ro = 0xffffffff,
    },{ .name = "DX1GCR9",  .decode.addr = A_DX1GCR9,
        .ro = 0xffffffff,
    },{ .name = "DX1BDLR0",  .decode.addr = A_DX1BDLR0,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX1BDLR1",  .decode.addr = A_DX1BDLR1,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX1BDLR2",  .decode.addr = A_DX1BDLR2,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX1BDLR3",  .decode.addr = A_DX1BDLR3,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX1BDLR4",  .decode.addr = A_DX1BDLR4,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX1BDLR5",  .decode.addr = A_DX1BDLR5,
        .ro = 0xffffffc0,
    },{ .name = "DX1BDLR6",  .decode.addr = A_DX1BDLR6,
        .ro = 0xffc0c0ff,
    },{ .name = "DX1BDLR7",  .decode.addr = A_DX1BDLR7,
        .ro = 0xffffffff,
    },{ .name = "DX1BDLR8",  .decode.addr = A_DX1BDLR8,
        .ro = 0xffffffff,
    },{ .name = "DX1BDLR9",  .decode.addr = A_DX1BDLR9,
        .ro = 0xffffffff,
    },{ .name = "DX1LCDLR0",  .decode.addr = A_DX1LCDLR0,
        .ro = 0xfffffe00,
    },{ .name = "DX1LCDLR1",  .decode.addr = A_DX1LCDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX1LCDLR2",  .decode.addr = A_DX1LCDLR2,
        .ro = 0xfffffe00,
    },{ .name = "DX1LCDLR3",  .decode.addr = A_DX1LCDLR3,
        .ro = 0xfffffe00,
    },{ .name = "DX1LCDLR4",  .decode.addr = A_DX1LCDLR4,
        .ro = 0xfffffe00,
    },{ .name = "DX1LCDLR5",  .decode.addr = A_DX1LCDLR5,
        .ro = 0xfffffe00,
    },{ .name = "DX1MDLR0",  .decode.addr = A_DX1MDLR0,
        .ro = 0xfe00fe00,
    },{ .name = "DX1MDLR1",  .decode.addr = A_DX1MDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX1GTR0",  .decode.addr = A_DX1GTR0,
        .reset = 0x20000,
        .ro = 0xf8f0ffe0,
    },{ .name = "DX1RSR0",  .decode.addr = A_DX1RSR0,
        .ro = 0xffffffff,
    },{ .name = "DX1RSR1",  .decode.addr = A_DX1RSR1,
        .ro = 0xffffffff,
    },{ .name = "DX1RSR2",  .decode.addr = A_DX1RSR2,
        .ro = 0xffffffff,
    },{ .name = "DX1RSR3",  .decode.addr = A_DX1RSR3,
        .ro = 0xffffffff,
    },{ .name = "DX1GSR0",  .decode.addr = A_DX1GSR0,
        .ro = 0xffffffff,
    },{ .name = "DX1GSR1",  .decode.addr = A_DX1GSR1,
        .ro = 0xffffffff,
    },{ .name = "DX1GSR2",  .decode.addr = A_DX1GSR2,
        .ro = 0xffffffff,
    },{ .name = "DX1GSR3",  .decode.addr = A_DX1GSR3,
        .ro = 0xffffffff,
    },{ .name = "DX1GSR4",  .decode.addr = A_DX1GSR4,
        .ro = 0xffffffff,
    },{ .name = "DX1GSR5",  .decode.addr = A_DX1GSR5,
        .ro = 0xffffffff,
    },{ .name = "DX1GSR6",  .decode.addr = A_DX1GSR6,
        .ro = 0xffffffff,
    },{ .name = "DX2GCR0",  .decode.addr = A_DX2GCR0,
        .reset = 0x40200204,
        .ro = 0xfc013,
    },{ .name = "DX2GCR1",  .decode.addr = A_DX2GCR1,
        .reset = 0x7fff,
        .ro = 0x8000,
    },{ .name = "DX2GCR2",  .decode.addr = A_DX2GCR2,
    },{ .name = "DX2GCR3",  .decode.addr = A_DX2GCR3,
        .reset = 0x3f000008,
        .ro = 0xc0c00303,
    },{ .name = "DX2GCR4",  .decode.addr = A_DX2GCR4,
        .reset = 0xe00003c,
        .ro = 0xe10000c0,
    },{ .name = "DX2GCR5",  .decode.addr = A_DX2GCR5,
        .reset = 0x9090909,
        .ro = 0x80808080,
    },{ .name = "DX2GCR6",  .decode.addr = A_DX2GCR6,
        .reset = 0x9090909,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX2GCR7",  .decode.addr = A_DX2GCR7,
        .ro = 0xffffffff,
    },{ .name = "DX2GCR8",  .decode.addr = A_DX2GCR8,
        .ro = 0xffffffff,
    },{ .name = "DX2GCR9",  .decode.addr = A_DX2GCR9,
        .ro = 0xffffffff,
    },{ .name = "DX2BDLR0",  .decode.addr = A_DX2BDLR0,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX2BDLR1",  .decode.addr = A_DX2BDLR1,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX2BDLR2",  .decode.addr = A_DX2BDLR2,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX2BDLR3",  .decode.addr = A_DX2BDLR3,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX2BDLR4",  .decode.addr = A_DX2BDLR4,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX2BDLR5",  .decode.addr = A_DX2BDLR5,
        .ro = 0xffffffc0,
    },{ .name = "DX2BDLR6",  .decode.addr = A_DX2BDLR6,
        .ro = 0xffc0c0ff,
    },{ .name = "DX2BDLR7",  .decode.addr = A_DX2BDLR7,
        .ro = 0xffffffff,
    },{ .name = "DX2BDLR8",  .decode.addr = A_DX2BDLR8,
        .ro = 0xffffffff,
    },{ .name = "DX2BDLR9",  .decode.addr = A_DX2BDLR9,
        .ro = 0xffffffff,
    },{ .name = "DX2LCDLR0",  .decode.addr = A_DX2LCDLR0,
        .ro = 0xfffffe00,
    },{ .name = "DX2LCDLR1",  .decode.addr = A_DX2LCDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX2LCDLR2",  .decode.addr = A_DX2LCDLR2,
        .ro = 0xfffffe00,
    },{ .name = "DX2LCDLR3",  .decode.addr = A_DX2LCDLR3,
        .ro = 0xfffffe00,
    },{ .name = "DX2LCDLR4",  .decode.addr = A_DX2LCDLR4,
        .ro = 0xfffffe00,
    },{ .name = "DX2LCDLR5",  .decode.addr = A_DX2LCDLR5,
        .ro = 0xfffffe00,
    },{ .name = "DX2MDLR0",  .decode.addr = A_DX2MDLR0,
        .ro = 0xfe00fe00,
    },{ .name = "DX2MDLR1",  .decode.addr = A_DX2MDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX2GTR0",  .decode.addr = A_DX2GTR0,
        .reset = 0x20000,
        .ro = 0xf8f0ffe0,
    },{ .name = "DX2RSR0",  .decode.addr = A_DX2RSR0,
        .ro = 0xffffffff,
    },{ .name = "DX2RSR1",  .decode.addr = A_DX2RSR1,
        .ro = 0xffffffff,
    },{ .name = "DX2RSR2",  .decode.addr = A_DX2RSR2,
        .ro = 0xffffffff,
    },{ .name = "DX2RSR3",  .decode.addr = A_DX2RSR3,
        .ro = 0xffffffff,
    },{ .name = "DX2GSR0",  .decode.addr = A_DX2GSR0,
        .ro = 0xffffffff,
    },{ .name = "DX2GSR1",  .decode.addr = A_DX2GSR1,
        .ro = 0xffffffff,
    },{ .name = "DX2GSR2",  .decode.addr = A_DX2GSR2,
        .ro = 0xffffffff,
    },{ .name = "DX2GSR3",  .decode.addr = A_DX2GSR3,
        .ro = 0xffffffff,
    },{ .name = "DX2GSR4",  .decode.addr = A_DX2GSR4,
        .ro = 0xffffffff,
    },{ .name = "DX2GSR5",  .decode.addr = A_DX2GSR5,
        .ro = 0xffffffff,
    },{ .name = "DX2GSR6",  .decode.addr = A_DX2GSR6,
        .ro = 0xffffffff,
    },{ .name = "DX3GCR0",  .decode.addr = A_DX3GCR0,
        .reset = 0x40200204,
        .ro = 0xfc013,
    },{ .name = "DX3GCR1",  .decode.addr = A_DX3GCR1,
        .reset = 0x7fff,
        .ro = 0x8000,
    },{ .name = "DX3GCR2",  .decode.addr = A_DX3GCR2,
    },{ .name = "DX3GCR3",  .decode.addr = A_DX3GCR3,
        .reset = 0x3f000008,
        .ro = 0xc0c00303,
    },{ .name = "DX3GCR4",  .decode.addr = A_DX3GCR4,
        .reset = 0xe00003c,
        .ro = 0xe10000c0,
    },{ .name = "DX3GCR5",  .decode.addr = A_DX3GCR5,
        .reset = 0x9090909,
        .ro = 0x80808080,
    },{ .name = "DX3GCR6",  .decode.addr = A_DX3GCR6,
        .reset = 0x9090909,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX3GCR7",  .decode.addr = A_DX3GCR7,
        .ro = 0xffffffff,
    },{ .name = "DX3GCR8",  .decode.addr = A_DX3GCR8,
        .ro = 0xffffffff,
    },{ .name = "DX3GCR9",  .decode.addr = A_DX3GCR9,
        .ro = 0xffffffff,
    },{ .name = "DX3BDLR0",  .decode.addr = A_DX3BDLR0,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX3BDLR1",  .decode.addr = A_DX3BDLR1,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX3BDLR2",  .decode.addr = A_DX3BDLR2,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX3BDLR3",  .decode.addr = A_DX3BDLR3,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX3BDLR4",  .decode.addr = A_DX3BDLR4,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX3BDLR5",  .decode.addr = A_DX3BDLR5,
        .ro = 0xffffffc0,
    },{ .name = "DX3BDLR6",  .decode.addr = A_DX3BDLR6,
        .ro = 0xffc0c0ff,
    },{ .name = "DX3BDLR7",  .decode.addr = A_DX3BDLR7,
        .ro = 0xffffffff,
    },{ .name = "DX3BDLR8",  .decode.addr = A_DX3BDLR8,
        .ro = 0xffffffff,
    },{ .name = "DX3BDLR9",  .decode.addr = A_DX3BDLR9,
        .ro = 0xffffffff,
    },{ .name = "DX3LCDLR0",  .decode.addr = A_DX3LCDLR0,
        .ro = 0xfffffe00,
    },{ .name = "DX3LCDLR1",  .decode.addr = A_DX3LCDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX3LCDLR2",  .decode.addr = A_DX3LCDLR2,
        .ro = 0xfffffe00,
    },{ .name = "DX3LCDLR3",  .decode.addr = A_DX3LCDLR3,
        .ro = 0xfffffe00,
    },{ .name = "DX3LCDLR4",  .decode.addr = A_DX3LCDLR4,
        .ro = 0xfffffe00,
    },{ .name = "DX3LCDLR5",  .decode.addr = A_DX3LCDLR5,
        .ro = 0xfffffe00,
    },{ .name = "DX3MDLR0",  .decode.addr = A_DX3MDLR0,
        .ro = 0xfe00fe00,
    },{ .name = "DX3MDLR1",  .decode.addr = A_DX3MDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX3GTR0",  .decode.addr = A_DX3GTR0,
        .reset = 0x20000,
        .ro = 0xf8f0ffe0,
    },{ .name = "DX3RSR0",  .decode.addr = A_DX3RSR0,
        .ro = 0xffffffff,
    },{ .name = "DX3RSR1",  .decode.addr = A_DX3RSR1,
        .ro = 0xffffffff,
    },{ .name = "DX3RSR2",  .decode.addr = A_DX3RSR2,
        .ro = 0xffffffff,
    },{ .name = "DX3RSR3",  .decode.addr = A_DX3RSR3,
        .ro = 0xffffffff,
    },{ .name = "DX3GSR0",  .decode.addr = A_DX3GSR0,
        .ro = 0xffffffff,
    },{ .name = "DX3GSR1",  .decode.addr = A_DX3GSR1,
        .ro = 0xffffffff,
    },{ .name = "DX3GSR2",  .decode.addr = A_DX3GSR2,
        .ro = 0xffffffff,
    },{ .name = "DX3GSR3",  .decode.addr = A_DX3GSR3,
        .ro = 0xffffffff,
    },{ .name = "DX3GSR4",  .decode.addr = A_DX3GSR4,
        .ro = 0xffffffff,
    },{ .name = "DX3GSR5",  .decode.addr = A_DX3GSR5,
        .ro = 0xffffffff,
    },{ .name = "DX3GSR6",  .decode.addr = A_DX3GSR6,
        .ro = 0xffffffff,
    },{ .name = "DX4GCR0",  .decode.addr = A_DX4GCR0,
        .reset = 0x40200204,
        .ro = 0xfc013,
    },{ .name = "DX4GCR1",  .decode.addr = A_DX4GCR1,
        .reset = 0x7fff,
        .ro = 0x8000,
    },{ .name = "DX4GCR2",  .decode.addr = A_DX4GCR2,
    },{ .name = "DX4GCR3",  .decode.addr = A_DX4GCR3,
        .reset = 0x3f000008,
        .ro = 0xc0c00303,
    },{ .name = "DX4GCR4",  .decode.addr = A_DX4GCR4,
        .reset = 0xe00003c,
        .ro = 0xe10000c0,
    },{ .name = "DX4GCR5",  .decode.addr = A_DX4GCR5,
        .reset = 0x9090909,
        .ro = 0x80808080,
    },{ .name = "DX4GCR6",  .decode.addr = A_DX4GCR6,
        .reset = 0x9090909,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX4GCR7",  .decode.addr = A_DX4GCR7,
        .ro = 0xffffffff,
    },{ .name = "DX4GCR8",  .decode.addr = A_DX4GCR8,
        .ro = 0xffffffff,
    },{ .name = "DX4GCR9",  .decode.addr = A_DX4GCR9,
        .ro = 0xffffffff,
    },{ .name = "DX4BDLR0",  .decode.addr = A_DX4BDLR0,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX4BDLR1",  .decode.addr = A_DX4BDLR1,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX4BDLR2",  .decode.addr = A_DX4BDLR2,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX4BDLR3",  .decode.addr = A_DX4BDLR3,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX4BDLR4",  .decode.addr = A_DX4BDLR4,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX4BDLR5",  .decode.addr = A_DX4BDLR5,
        .ro = 0xffffffc0,
    },{ .name = "DX4BDLR6",  .decode.addr = A_DX4BDLR6,
        .ro = 0xffc0c0ff,
    },{ .name = "DX4BDLR7",  .decode.addr = A_DX4BDLR7,
        .ro = 0xffffffff,
    },{ .name = "DX4BDLR8",  .decode.addr = A_DX4BDLR8,
        .ro = 0xffffffff,
    },{ .name = "DX4BDLR9",  .decode.addr = A_DX4BDLR9,
        .ro = 0xffffffff,
    },{ .name = "DX4LCDLR0",  .decode.addr = A_DX4LCDLR0,
        .ro = 0xfffffe00,
    },{ .name = "DX4LCDLR1",  .decode.addr = A_DX4LCDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX4LCDLR2",  .decode.addr = A_DX4LCDLR2,
        .ro = 0xfffffe00,
    },{ .name = "DX4LCDLR3",  .decode.addr = A_DX4LCDLR3,
        .ro = 0xfffffe00,
    },{ .name = "DX4LCDLR4",  .decode.addr = A_DX4LCDLR4,
        .ro = 0xfffffe00,
    },{ .name = "DX4LCDLR5",  .decode.addr = A_DX4LCDLR5,
        .ro = 0xfffffe00,
    },{ .name = "DX4MDLR0",  .decode.addr = A_DX4MDLR0,
        .ro = 0xfe00fe00,
    },{ .name = "DX4MDLR1",  .decode.addr = A_DX4MDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX4GTR0",  .decode.addr = A_DX4GTR0,
        .reset = 0x20000,
        .ro = 0xf8f0ffe0,
    },{ .name = "DX4RSR0",  .decode.addr = A_DX4RSR0,
        .ro = 0xffffffff,
    },{ .name = "DX4RSR1",  .decode.addr = A_DX4RSR1,
        .ro = 0xffffffff,
    },{ .name = "DX4RSR2",  .decode.addr = A_DX4RSR2,
        .ro = 0xffffffff,
    },{ .name = "DX4RSR3",  .decode.addr = A_DX4RSR3,
        .ro = 0xffffffff,
    },{ .name = "DX4GSR0",  .decode.addr = A_DX4GSR0,
        .ro = 0xffffffff,
    },{ .name = "DX4GSR1",  .decode.addr = A_DX4GSR1,
        .ro = 0xffffffff,
    },{ .name = "DX4GSR2",  .decode.addr = A_DX4GSR2,
        .ro = 0xffffffff,
    },{ .name = "DX4GSR3",  .decode.addr = A_DX4GSR3,
        .ro = 0xffffffff,
    },{ .name = "DX4GSR4",  .decode.addr = A_DX4GSR4,
        .ro = 0xffffffff,
    },{ .name = "DX4GSR5",  .decode.addr = A_DX4GSR5,
        .ro = 0xffffffff,
    },{ .name = "DX4GSR6",  .decode.addr = A_DX4GSR6,
        .ro = 0xffffffff,
    },{ .name = "DX5GCR0",  .decode.addr = A_DX5GCR0,
        .reset = 0x40200204,
        .ro = 0xfc013,
    },{ .name = "DX5GCR1",  .decode.addr = A_DX5GCR1,
        .reset = 0x7fff,
        .ro = 0x8000,
    },{ .name = "DX5GCR2",  .decode.addr = A_DX5GCR2,
    },{ .name = "DX5GCR3",  .decode.addr = A_DX5GCR3,
        .reset = 0x3f000008,
        .ro = 0xc0c00303,
    },{ .name = "DX5GCR4",  .decode.addr = A_DX5GCR4,
        .reset = 0xe00003c,
        .ro = 0xe10000c0,
    },{ .name = "DX5GCR5",  .decode.addr = A_DX5GCR5,
        .reset = 0x9090909,
        .ro = 0x80808080,
    },{ .name = "DX5GCR6",  .decode.addr = A_DX5GCR6,
        .reset = 0x9090909,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX5GCR7",  .decode.addr = A_DX5GCR7,
        .ro = 0xffffffff,
    },{ .name = "DX5GCR8",  .decode.addr = A_DX5GCR8,
        .ro = 0xffffffff,
    },{ .name = "DX5GCR9",  .decode.addr = A_DX5GCR9,
        .ro = 0xffffffff,
    },{ .name = "DX5BDLR0",  .decode.addr = A_DX5BDLR0,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX5BDLR1",  .decode.addr = A_DX5BDLR1,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX5BDLR2",  .decode.addr = A_DX5BDLR2,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX5BDLR3",  .decode.addr = A_DX5BDLR3,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX5BDLR4",  .decode.addr = A_DX5BDLR4,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX5BDLR5",  .decode.addr = A_DX5BDLR5,
        .ro = 0xffffffc0,
    },{ .name = "DX5BDLR6",  .decode.addr = A_DX5BDLR6,
        .ro = 0xffc0c0ff,
    },{ .name = "DX5BDLR7",  .decode.addr = A_DX5BDLR7,
        .ro = 0xffffffff,
    },{ .name = "DX5BDLR8",  .decode.addr = A_DX5BDLR8,
        .ro = 0xffffffff,
    },{ .name = "DX5BDLR9",  .decode.addr = A_DX5BDLR9,
        .ro = 0xffffffff,
    },{ .name = "DX5LCDLR0",  .decode.addr = A_DX5LCDLR0,
        .ro = 0xfffffe00,
    },{ .name = "DX5LCDLR1",  .decode.addr = A_DX5LCDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX5LCDLR2",  .decode.addr = A_DX5LCDLR2,
        .ro = 0xfffffe00,
    },{ .name = "DX5LCDLR3",  .decode.addr = A_DX5LCDLR3,
        .ro = 0xfffffe00,
    },{ .name = "DX5LCDLR4",  .decode.addr = A_DX5LCDLR4,
        .ro = 0xfffffe00,
    },{ .name = "DX5LCDLR5",  .decode.addr = A_DX5LCDLR5,
        .ro = 0xfffffe00,
    },{ .name = "DX5MDLR0",  .decode.addr = A_DX5MDLR0,
        .ro = 0xfe00fe00,
    },{ .name = "DX5MDLR1",  .decode.addr = A_DX5MDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX5GTR0",  .decode.addr = A_DX5GTR0,
        .reset = 0x20000,
        .ro = 0xf8f0ffe0,
    },{ .name = "DX5RSR0",  .decode.addr = A_DX5RSR0,
        .ro = 0xffffffff,
    },{ .name = "DX5RSR1",  .decode.addr = A_DX5RSR1,
        .ro = 0xffffffff,
    },{ .name = "DX5RSR2",  .decode.addr = A_DX5RSR2,
        .ro = 0xffffffff,
    },{ .name = "DX5RSR3",  .decode.addr = A_DX5RSR3,
        .ro = 0xffffffff,
    },{ .name = "DX5GSR0",  .decode.addr = A_DX5GSR0,
        .ro = 0xffffffff,
    },{ .name = "DX5GSR1",  .decode.addr = A_DX5GSR1,
        .ro = 0xffffffff,
    },{ .name = "DX5GSR2",  .decode.addr = A_DX5GSR2,
        .ro = 0xffffffff,
    },{ .name = "DX5GSR3",  .decode.addr = A_DX5GSR3,
        .ro = 0xffffffff,
    },{ .name = "DX5GSR4",  .decode.addr = A_DX5GSR4,
        .ro = 0xffffffff,
    },{ .name = "DX5GSR5",  .decode.addr = A_DX5GSR5,
        .ro = 0xffffffff,
    },{ .name = "DX5GSR6",  .decode.addr = A_DX5GSR6,
        .ro = 0xffffffff,
    },{ .name = "DX6GCR0",  .decode.addr = A_DX6GCR0,
        .reset = 0x40200204,
        .ro = 0xfc013,
    },{ .name = "DX6GCR1",  .decode.addr = A_DX6GCR1,
        .reset = 0x7fff,
        .ro = 0x8000,
    },{ .name = "DX6GCR2",  .decode.addr = A_DX6GCR2,
    },{ .name = "DX6GCR3",  .decode.addr = A_DX6GCR3,
        .reset = 0x3f000008,
        .ro = 0xc0c00303,
    },{ .name = "DX6GCR4",  .decode.addr = A_DX6GCR4,
        .reset = 0xe00003c,
        .ro = 0xe10000c0,
    },{ .name = "DX6GCR5",  .decode.addr = A_DX6GCR5,
        .reset = 0x9090909,
        .ro = 0x80808080,
    },{ .name = "DX6GCR6",  .decode.addr = A_DX6GCR6,
        .reset = 0x9090909,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX6GCR7",  .decode.addr = A_DX6GCR7,
        .ro = 0xffffffff,
    },{ .name = "DX6GCR8",  .decode.addr = A_DX6GCR8,
        .ro = 0xffffffff,
    },{ .name = "DX6GCR9",  .decode.addr = A_DX6GCR9,
        .ro = 0xffffffff,
    },{ .name = "DX6BDLR0",  .decode.addr = A_DX6BDLR0,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX6BDLR1",  .decode.addr = A_DX6BDLR1,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX6BDLR2",  .decode.addr = A_DX6BDLR2,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX6BDLR3",  .decode.addr = A_DX6BDLR3,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX6BDLR4",  .decode.addr = A_DX6BDLR4,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX6BDLR5",  .decode.addr = A_DX6BDLR5,
        .ro = 0xffffffc0,
    },{ .name = "DX6BDLR6",  .decode.addr = A_DX6BDLR6,
        .ro = 0xffc0c0ff,
    },{ .name = "DX6BDLR7",  .decode.addr = A_DX6BDLR7,
        .ro = 0xffffffff,
    },{ .name = "DX6BDLR8",  .decode.addr = A_DX6BDLR8,
        .ro = 0xffffffff,
    },{ .name = "DX6BDLR9",  .decode.addr = A_DX6BDLR9,
        .ro = 0xffffffff,
    },{ .name = "DX6LCDLR0",  .decode.addr = A_DX6LCDLR0,
        .ro = 0xfffffe00,
    },{ .name = "DX6LCDLR1",  .decode.addr = A_DX6LCDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX6LCDLR2",  .decode.addr = A_DX6LCDLR2,
        .ro = 0xfffffe00,
    },{ .name = "DX6LCDLR3",  .decode.addr = A_DX6LCDLR3,
        .ro = 0xfffffe00,
    },{ .name = "DX6LCDLR4",  .decode.addr = A_DX6LCDLR4,
        .ro = 0xfffffe00,
    },{ .name = "DX6LCDLR5",  .decode.addr = A_DX6LCDLR5,
        .ro = 0xfffffe00,
    },{ .name = "DX6MDLR0",  .decode.addr = A_DX6MDLR0,
        .ro = 0xfe00fe00,
    },{ .name = "DX6MDLR1",  .decode.addr = A_DX6MDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX6GTR0",  .decode.addr = A_DX6GTR0,
        .reset = 0x20000,
        .ro = 0xf8f0ffe0,
    },{ .name = "DX6RSR0",  .decode.addr = A_DX6RSR0,
        .ro = 0xffffffff,
    },{ .name = "DX6RSR1",  .decode.addr = A_DX6RSR1,
        .ro = 0xffffffff,
    },{ .name = "DX6RSR2",  .decode.addr = A_DX6RSR2,
        .ro = 0xffffffff,
    },{ .name = "DX6RSR3",  .decode.addr = A_DX6RSR3,
        .ro = 0xffffffff,
    },{ .name = "DX6GSR0",  .decode.addr = A_DX6GSR0,
        .ro = 0xffffffff,
    },{ .name = "DX6GSR1",  .decode.addr = A_DX6GSR1,
        .ro = 0xffffffff,
    },{ .name = "DX6GSR2",  .decode.addr = A_DX6GSR2,
        .ro = 0xffffffff,
    },{ .name = "DX6GSR3",  .decode.addr = A_DX6GSR3,
        .ro = 0xffffffff,
    },{ .name = "DX6GSR4",  .decode.addr = A_DX6GSR4,
        .ro = 0xffffffff,
    },{ .name = "DX6GSR5",  .decode.addr = A_DX6GSR5,
        .ro = 0xffffffff,
    },{ .name = "DX6GSR6",  .decode.addr = A_DX6GSR6,
        .ro = 0xffffffff,
    },{ .name = "DX7GCR0",  .decode.addr = A_DX7GCR0,
        .reset = 0x40200204,
        .ro = 0xfc013,
    },{ .name = "DX7GCR1",  .decode.addr = A_DX7GCR1,
        .reset = 0x7fff,
        .ro = 0x8000,
    },{ .name = "DX7GCR2",  .decode.addr = A_DX7GCR2,
    },{ .name = "DX7GCR3",  .decode.addr = A_DX7GCR3,
        .reset = 0x3f000008,
        .ro = 0xc0c00303,
    },{ .name = "DX7GCR4",  .decode.addr = A_DX7GCR4,
        .reset = 0xe00003c,
        .ro = 0xe10000c0,
    },{ .name = "DX7GCR5",  .decode.addr = A_DX7GCR5,
        .reset = 0x9090909,
        .ro = 0x80808080,
    },{ .name = "DX7GCR6",  .decode.addr = A_DX7GCR6,
        .reset = 0x9090909,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX7GCR7",  .decode.addr = A_DX7GCR7,
        .ro = 0xffffffff,
    },{ .name = "DX7GCR8",  .decode.addr = A_DX7GCR8,
        .ro = 0xffffffff,
    },{ .name = "DX7GCR9",  .decode.addr = A_DX7GCR9,
        .ro = 0xffffffff,
    },{ .name = "DX7BDLR0",  .decode.addr = A_DX7BDLR0,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX7BDLR1",  .decode.addr = A_DX7BDLR1,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX7BDLR2",  .decode.addr = A_DX7BDLR2,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX7BDLR3",  .decode.addr = A_DX7BDLR3,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX7BDLR4",  .decode.addr = A_DX7BDLR4,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX7BDLR5",  .decode.addr = A_DX7BDLR5,
        .ro = 0xffffffc0,
    },{ .name = "DX7BDLR6",  .decode.addr = A_DX7BDLR6,
        .ro = 0xffc0c0ff,
    },{ .name = "DX7BDLR7",  .decode.addr = A_DX7BDLR7,
        .ro = 0xffffffff,
    },{ .name = "DX7BDLR8",  .decode.addr = A_DX7BDLR8,
        .ro = 0xffffffff,
    },{ .name = "DX7BDLR9",  .decode.addr = A_DX7BDLR9,
        .ro = 0xffffffff,
    },{ .name = "DX7LCDLR0",  .decode.addr = A_DX7LCDLR0,
        .ro = 0xfffffe00,
    },{ .name = "DX7LCDLR1",  .decode.addr = A_DX7LCDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX7LCDLR2",  .decode.addr = A_DX7LCDLR2,
        .ro = 0xfffffe00,
    },{ .name = "DX7LCDLR3",  .decode.addr = A_DX7LCDLR3,
        .ro = 0xfffffe00,
    },{ .name = "DX7LCDLR4",  .decode.addr = A_DX7LCDLR4,
        .ro = 0xfffffe00,
    },{ .name = "DX7LCDLR5",  .decode.addr = A_DX7LCDLR5,
        .ro = 0xfffffe00,
    },{ .name = "DX7MDLR0",  .decode.addr = A_DX7MDLR0,
        .ro = 0xfe00fe00,
    },{ .name = "DX7MDLR1",  .decode.addr = A_DX7MDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX7GTR0",  .decode.addr = A_DX7GTR0,
        .reset = 0x20000,
        .ro = 0xf8f0ffe0,
    },{ .name = "DX7RSR0",  .decode.addr = A_DX7RSR0,
        .ro = 0xffffffff,
    },{ .name = "DX7RSR1",  .decode.addr = A_DX7RSR1,
        .ro = 0xffffffff,
    },{ .name = "DX7RSR2",  .decode.addr = A_DX7RSR2,
        .ro = 0xffffffff,
    },{ .name = "DX7RSR3",  .decode.addr = A_DX7RSR3,
        .ro = 0xffffffff,
    },{ .name = "DX7GSR0",  .decode.addr = A_DX7GSR0,
        .ro = 0xffffffff,
    },{ .name = "DX7GSR1",  .decode.addr = A_DX7GSR1,
        .ro = 0xffffffff,
    },{ .name = "DX7GSR2",  .decode.addr = A_DX7GSR2,
        .ro = 0xffffffff,
    },{ .name = "DX7GSR3",  .decode.addr = A_DX7GSR3,
        .ro = 0xffffffff,
    },{ .name = "DX7GSR4",  .decode.addr = A_DX7GSR4,
        .ro = 0xffffffff,
    },{ .name = "DX7GSR5",  .decode.addr = A_DX7GSR5,
        .ro = 0xffffffff,
    },{ .name = "DX7GSR6",  .decode.addr = A_DX7GSR6,
        .ro = 0xffffffff,
    },{ .name = "DX8GCR0",  .decode.addr = A_DX8GCR0,
        .reset = 0x40200204,
        .ro = 0xfc013,
    },{ .name = "DX8GCR1",  .decode.addr = A_DX8GCR1,
        .reset = 0x7fff,
        .ro = 0x8000,
    },{ .name = "DX8GCR2",  .decode.addr = A_DX8GCR2,
    },{ .name = "DX8GCR3",  .decode.addr = A_DX8GCR3,
        .reset = 0x3f000008,
        .ro = 0xc0c00303,
    },{ .name = "DX8GCR4",  .decode.addr = A_DX8GCR4,
        .reset = 0xe00003c,
        .ro = 0xe10000c0,
    },{ .name = "DX8GCR5",  .decode.addr = A_DX8GCR5,
        .reset = 0x9090909,
        .ro = 0x80808080,
    },{ .name = "DX8GCR6",  .decode.addr = A_DX8GCR6,
        .reset = 0x9090909,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX8GCR7",  .decode.addr = A_DX8GCR7,
        .ro = 0xffffffff,
    },{ .name = "DX8GCR8",  .decode.addr = A_DX8GCR8,
        .ro = 0xffffffff,
    },{ .name = "DX8GCR9",  .decode.addr = A_DX8GCR9,
        .ro = 0xffffffff,
    },{ .name = "DX8BDLR0",  .decode.addr = A_DX8BDLR0,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX8BDLR1",  .decode.addr = A_DX8BDLR1,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX8BDLR2",  .decode.addr = A_DX8BDLR2,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX8BDLR3",  .decode.addr = A_DX8BDLR3,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX8BDLR4",  .decode.addr = A_DX8BDLR4,
        .ro = 0xc0c0c0c0,
    },{ .name = "DX8BDLR5",  .decode.addr = A_DX8BDLR5,
        .ro = 0xffffffc0,
    },{ .name = "DX8BDLR6",  .decode.addr = A_DX8BDLR6,
        .ro = 0xffc0c0ff,
    },{ .name = "DX8BDLR7",  .decode.addr = A_DX8BDLR7,
        .ro = 0xffffffff,
    },{ .name = "DX8BDLR8",  .decode.addr = A_DX8BDLR8,
        .ro = 0xffffffff,
    },{ .name = "DX8BDLR9",  .decode.addr = A_DX8BDLR9,
        .ro = 0xffffffff,
    },{ .name = "DX8LCDLR0",  .decode.addr = A_DX8LCDLR0,
        .ro = 0xfffffe00,
    },{ .name = "DX8LCDLR1",  .decode.addr = A_DX8LCDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX8LCDLR2",  .decode.addr = A_DX8LCDLR2,
        .ro = 0xfffffe00,
    },{ .name = "DX8LCDLR3",  .decode.addr = A_DX8LCDLR3,
        .ro = 0xfffffe00,
    },{ .name = "DX8LCDLR4",  .decode.addr = A_DX8LCDLR4,
        .ro = 0xfffffe00,
    },{ .name = "DX8LCDLR5",  .decode.addr = A_DX8LCDLR5,
        .ro = 0xfffffe00,
    },{ .name = "DX8MDLR0",  .decode.addr = A_DX8MDLR0,
        .ro = 0xfe00fe00,
    },{ .name = "DX8MDLR1",  .decode.addr = A_DX8MDLR1,
        .ro = 0xfffffe00,
    },{ .name = "DX8GTR0",  .decode.addr = A_DX8GTR0,
        .reset = 0x20000,
        .ro = 0xf8f0ffe0,
    },{ .name = "DX8RSR0",  .decode.addr = A_DX8RSR0,
        .ro = 0xffffffff,
    },{ .name = "DX8RSR1",  .decode.addr = A_DX8RSR1,
        .ro = 0xffffffff,
    },{ .name = "DX8RSR2",  .decode.addr = A_DX8RSR2,
        .ro = 0xffffffff,
    },{ .name = "DX8RSR3",  .decode.addr = A_DX8RSR3,
        .ro = 0xffffffff,
    },{ .name = "DX8GSR0",  .decode.addr = A_DX8GSR0,
        .ro = 0xffffffff,
    },{ .name = "DX8GSR1",  .decode.addr = A_DX8GSR1,
        .ro = 0xffffffff,
    },{ .name = "DX8GSR2",  .decode.addr = A_DX8GSR2,
        .ro = 0xffffffff,
    },{ .name = "DX8GSR3",  .decode.addr = A_DX8GSR3,
        .ro = 0xffffffff,
    },{ .name = "DX8GSR4",  .decode.addr = A_DX8GSR4,
        .ro = 0xffffffff,
    },{ .name = "DX8GSR5",  .decode.addr = A_DX8GSR5,
        .ro = 0xffffffff,
    },{ .name = "DX8GSR6",  .decode.addr = A_DX8GSR6,
        .ro = 0xffffffff,
    },{ .name = "DX8SL0OSC",  .decode.addr = A_DX8SL0OSC,
        .reset = 0x19ffe,
        .ro = 0xc0000000,
        .w1c = 0x100000,
    },{ .name = "DX8SL0PLLCR0",  .decode.addr = A_DX8SL0PLLCR0,
        .reset = 0x1c0000,
        .ro = 0xe00,
    },{ .name = "DX8SL0PLLCR1",  .decode.addr = A_DX8SL0PLLCR1,
        .ro = 0xffc00000,
    },{ .name = "DX8SL0PLLCR2",  .decode.addr = A_DX8SL0PLLCR2,
    },{ .name = "DX8SL0PLLCR3",  .decode.addr = A_DX8SL0PLLCR3,
    },{ .name = "DX8SL0PLLCR4",  .decode.addr = A_DX8SL0PLLCR4,
    },{ .name = "DX8SL0PLLCR5",  .decode.addr = A_DX8SL0PLLCR5,
        .ro = 0xffffff00,
    },{ .name = "DX8SL0DQSCTL",  .decode.addr = A_DX8SL0DQSCTL,
        .reset = 0x1264000,
        .ro = 0xfec19c00,
    },{ .name = "DX8SL0TRNCTL",  .decode.addr = A_DX8SL0TRNCTL,
        .ro = 0xffffffff,
    },{ .name = "DX8SL0DDLCTL",  .decode.addr = A_DX8SL0DDLCTL,
        .reset = 0x2,
        .ro = 0xf9800000,
    },{ .name = "DX8SL0DXCTL1",  .decode.addr = A_DX8SL0DXCTL1,
        .reset = 0x40000,
        .ro = 0xfe40ffff,
    },{ .name = "DX8SL0DXCTL2",  .decode.addr = A_DX8SL0DXCTL2,
        .reset = 0x141800,
        .ro = 0xff026001,
    },{ .name = "DX8SL0IOCR",  .decode.addr = A_DX8SL0IOCR,
        .ro = 0x80000000,
    },{ .name = "DX4SL0IOCR",  .decode.addr = A_DX4SL0IOCR,
        .ro = 0xffffffff,
    },{ .name = "DX8SL1OSC",  .decode.addr = A_DX8SL1OSC,
        .reset = 0x19ffe,
        .ro = 0xc0000000,
        .w1c = 0x100000,
    },{ .name = "DX8SL1PLLCR0",  .decode.addr = A_DX8SL1PLLCR0,
        .reset = 0x1c0000,
        .ro = 0xe00,
    },{ .name = "DX8SL1PLLCR1",  .decode.addr = A_DX8SL1PLLCR1,
        .ro = 0xffc00000,
    },{ .name = "DX8SL1PLLCR2",  .decode.addr = A_DX8SL1PLLCR2,
    },{ .name = "DX8SL1PLLCR3",  .decode.addr = A_DX8SL1PLLCR3,
    },{ .name = "DX8SL1PLLCR4",  .decode.addr = A_DX8SL1PLLCR4,
    },{ .name = "DX8SL1PLLCR5",  .decode.addr = A_DX8SL1PLLCR5,
        .ro = 0xffffff00,
    },{ .name = "DX8SL1DQSCTL",  .decode.addr = A_DX8SL1DQSCTL,
        .reset = 0x1264000,
        .ro = 0xfec19c00,
    },{ .name = "DX8SL1TRNCTL",  .decode.addr = A_DX8SL1TRNCTL,
        .ro = 0xffffffff,
    },{ .name = "DX8SL1DDLCTL",  .decode.addr = A_DX8SL1DDLCTL,
        .reset = 0x2,
        .ro = 0xf9800000,
    },{ .name = "DX8SL1DXCTL1",  .decode.addr = A_DX8SL1DXCTL1,
        .reset = 0x40000,
        .ro = 0xfe40ffff,
    },{ .name = "DX8SL1DXCTL2",  .decode.addr = A_DX8SL1DXCTL2,
        .reset = 0x141800,
        .ro = 0xff026001,
    },{ .name = "DX8SL1IOCR",  .decode.addr = A_DX8SL1IOCR,
        .ro = 0x80000000,
    },{ .name = "DX4SL1IOCR",  .decode.addr = A_DX4SL1IOCR,
        .ro = 0xffffffff,
    },{ .name = "DX8SL2OSC",  .decode.addr = A_DX8SL2OSC,
        .reset = 0x19ffe,
        .ro = 0xc0000000,
        .w1c = 0x100000,
    },{ .name = "DX8SL2PLLCR0",  .decode.addr = A_DX8SL2PLLCR0,
        .reset = 0x1c0000,
        .ro = 0xe00,
    },{ .name = "DX8SL2PLLCR1",  .decode.addr = A_DX8SL2PLLCR1,
        .ro = 0xffc00000,
    },{ .name = "DX8SL2PLLCR2",  .decode.addr = A_DX8SL2PLLCR2,
    },{ .name = "DX8SL2PLLCR3",  .decode.addr = A_DX8SL2PLLCR3,
    },{ .name = "DX8SL2PLLCR4",  .decode.addr = A_DX8SL2PLLCR4,
    },{ .name = "DX8SL2PLLCR5",  .decode.addr = A_DX8SL2PLLCR5,
        .ro = 0xffffff00,
    },{ .name = "DX8SL2DQSCTL",  .decode.addr = A_DX8SL2DQSCTL,
        .reset = 0x1264000,
        .ro = 0xfec19c00,
    },{ .name = "DX8SL2TRNCTL",  .decode.addr = A_DX8SL2TRNCTL,
        .ro = 0xffffffff,
    },{ .name = "DX8SL2DDLCTL",  .decode.addr = A_DX8SL2DDLCTL,
        .reset = 0x2,
        .ro = 0xf9800000,
    },{ .name = "DX8SL2DXCTL1",  .decode.addr = A_DX8SL2DXCTL1,
        .reset = 0x40000,
        .ro = 0xfe40ffff,
    },{ .name = "DX8SL2DXCTL2",  .decode.addr = A_DX8SL2DXCTL2,
        .reset = 0x141800,
        .ro = 0xff026001,
    },{ .name = "DX8SL2IOCR",  .decode.addr = A_DX8SL2IOCR,
        .ro = 0x80000000,
    },{ .name = "DX4SL2IOCR",  .decode.addr = A_DX4SL2IOCR,
        .ro = 0xffffffff,
    },{ .name = "DX8SL3OSC",  .decode.addr = A_DX8SL3OSC,
        .reset = 0x19ffe,
        .ro = 0xc0000000,
        .w1c = 0x100000,
    },{ .name = "DX8SL3PLLCR0",  .decode.addr = A_DX8SL3PLLCR0,
        .reset = 0x1c0000,
        .ro = 0xe00,
    },{ .name = "DX8SL3PLLCR1",  .decode.addr = A_DX8SL3PLLCR1,
        .ro = 0xffc00000,
    },{ .name = "DX8SL3PLLCR2",  .decode.addr = A_DX8SL3PLLCR2,
    },{ .name = "DX8SL3PLLCR3",  .decode.addr = A_DX8SL3PLLCR3,
    },{ .name = "DX8SL3PLLCR4",  .decode.addr = A_DX8SL3PLLCR4,
    },{ .name = "DX8SL3PLLCR5",  .decode.addr = A_DX8SL3PLLCR5,
        .ro = 0xffffff00,
    },{ .name = "DX8SL3DQSCTL",  .decode.addr = A_DX8SL3DQSCTL,
        .reset = 0x1264000,
        .ro = 0xfec19c00,
    },{ .name = "DX8SL3TRNCTL",  .decode.addr = A_DX8SL3TRNCTL,
        .ro = 0xffffffff,
    },{ .name = "DX8SL3DDLCTL",  .decode.addr = A_DX8SL3DDLCTL,
        .reset = 0x2,
        .ro = 0xf9800000,
    },{ .name = "DX8SL3DXCTL1",  .decode.addr = A_DX8SL3DXCTL1,
        .reset = 0x40000,
        .ro = 0xfe40ffff,
    },{ .name = "DX8SL3DXCTL2",  .decode.addr = A_DX8SL3DXCTL2,
        .reset = 0x141800,
        .ro = 0xff026001,
    },{ .name = "DX8SL3IOCR",  .decode.addr = A_DX8SL3IOCR,
        .ro = 0x80000000,
    },{ .name = "DX4SL3IOCR",  .decode.addr = A_DX4SL3IOCR,
        .ro = 0xffffffff,
    },{ .name = "DX8SL4OSC",  .decode.addr = A_DX8SL4OSC,
        .reset = 0x19ffe,
        .ro = 0xc0000000,
        .w1c = 0x100000,
    },{ .name = "DX8SL4PLLCR0",  .decode.addr = A_DX8SL4PLLCR0,
        .reset = 0x1c0000,
        .ro = 0xe00,
    },{ .name = "DX8SL4PLLCR1",  .decode.addr = A_DX8SL4PLLCR1,
        .ro = 0xffc00000,
    },{ .name = "DX8SL4PLLCR2",  .decode.addr = A_DX8SL4PLLCR2,
    },{ .name = "DX8SL4PLLCR3",  .decode.addr = A_DX8SL4PLLCR3,
    },{ .name = "DX8SL4PLLCR4",  .decode.addr = A_DX8SL4PLLCR4,
    },{ .name = "DX8SL4PLLCR5",  .decode.addr = A_DX8SL4PLLCR5,
        .ro = 0xffffff00,
    },{ .name = "DX8SL4DQSCTL",  .decode.addr = A_DX8SL4DQSCTL,
        .reset = 0x1264000,
        .ro = 0xfec19c00,
    },{ .name = "DX8SL4TRNCTL",  .decode.addr = A_DX8SL4TRNCTL,
        .ro = 0xffffffff,
    },{ .name = "DX8SL4DDLCTL",  .decode.addr = A_DX8SL4DDLCTL,
        .reset = 0x2,
        .ro = 0xf9800000,
    },{ .name = "DX8SL4DXCTL1",  .decode.addr = A_DX8SL4DXCTL1,
        .reset = 0x40000,
        .ro = 0xfe40ffff,
    },{ .name = "DX8SL4DXCTL2",  .decode.addr = A_DX8SL4DXCTL2,
        .reset = 0x141800,
        .ro = 0xff026001,
    },{ .name = "DX8SL4IOCR",  .decode.addr = A_DX8SL4IOCR,
        .ro = 0x80000000,
    },{ .name = "DX4SL4IOCR",  .decode.addr = A_DX4SL4IOCR,
        .ro = 0xffffffff,
    },{ .name = "DX8SLBOSC",  .decode.addr = A_DX8SLBOSC,
    },{ .name = "DX8SLBPLLCR0",  .decode.addr = A_DX8SLBPLLCR0,
    },{ .name = "DX8SLBPLLCR1",  .decode.addr = A_DX8SLBPLLCR1,
    },{ .name = "DX8SLBPLLCR2",  .decode.addr = A_DX8SLBPLLCR2,
    },{ .name = "DX8SLBPLLCR3",  .decode.addr = A_DX8SLBPLLCR3,
    },{ .name = "DX8SLBPLLCR4",  .decode.addr = A_DX8SLBPLLCR4,
    },{ .name = "DX8SLBPLLCR5",  .decode.addr = A_DX8SLBPLLCR5,
    },{ .name = "DX8SLBDQSCTL",  .decode.addr = A_DX8SLBDQSCTL,
    },{ .name = "DX8SLBTRNCTL",  .decode.addr = A_DX8SLBTRNCTL,
    },{ .name = "DX8SLBDDLCTL",  .decode.addr = A_DX8SLBDDLCTL,
    },{ .name = "DX8SLBDXCTL1",  .decode.addr = A_DX8SLBDXCTL1,
    },{ .name = "DX8SLBDXCTL2",  .decode.addr = A_DX8SLBDXCTL2,
    },{ .name = "DX8SLBIOCR",  .decode.addr = A_DX8SLBIOCR,
    },{ .name = "DX4SLBIOCR",  .decode.addr = A_DX4SLBIOCR,
    }
};

static void ddr_phy_reset(DeviceState *dev)
{
    DDR_PHY *s = XILINX_DDR_PHY(dev);
    unsigned int i;

    for (i = 0; i < ARRAY_SIZE(s->regs_info); ++i) {
        dep_register_reset(&s->regs_info[i]);
    }

}

static uint64_t ddr_phy_read(void *opaque, hwaddr addr, unsigned size)
{
    DDR_PHY *s = XILINX_DDR_PHY(opaque);
    DepRegisterInfo *r = &s->regs_info[addr / 4];

    if (!r->data) {
        qemu_log("%s: Decode error: read from %" HWADDR_PRIx "\n",
                 object_get_canonical_path(OBJECT(s)),
                 addr);
        return 0;
    }
    return dep_register_read(r);
}

static void ddr_phy_write(void *opaque, hwaddr addr, uint64_t value,
                      unsigned size)
{
    DDR_PHY *s = XILINX_DDR_PHY(opaque);
    DepRegisterInfo *r = &s->regs_info[addr / 4];

    if (!r->data) {
        qemu_log("%s: Decode error: write to %" HWADDR_PRIx "=%" PRIx64 "\n",
                 object_get_canonical_path(OBJECT(s)),
                 addr, value);
        return;
    }
    dep_register_write(r, value, ~0);
}

static const MemoryRegionOps ddr_phy_ops = {
    .read = ddr_phy_read,
    .write = ddr_phy_write,
    .endianness = DEVICE_LITTLE_ENDIAN,
    .valid = {
        .min_access_size = 4,
        .max_access_size = 4,
    },
};

static void ddr_phy_realize(DeviceState *dev, Error **errp)
{
    DDR_PHY *s = XILINX_DDR_PHY(dev);
    const char *prefix = object_get_canonical_path(OBJECT(dev));
    unsigned int i;

    for (i = 0; i < ARRAY_SIZE(ddr_phy_regs_info); ++i) {
        DepRegisterInfo *r = &s->regs_info[ddr_phy_regs_info[i].decode.addr/4];

        *r = (DepRegisterInfo) {
            .data = (uint8_t *)&s->regs[
                    ddr_phy_regs_info[i].decode.addr/4],
            .data_size = sizeof(uint32_t),
            .access = &ddr_phy_regs_info[i],
            .debug = XILINX_DDR_PHY_ERR_DEBUG,
            .prefix = prefix,
            .opaque = s,
        };
    }
}

static void ddr_phy_init(Object *obj)
{
    DDR_PHY *s = XILINX_DDR_PHY(obj);
    SysBusDevice *sbd = SYS_BUS_DEVICE(obj);

    memory_region_init_io(&s->iomem, obj, &ddr_phy_ops, s,
                          TYPE_XILINX_DDR_PHY, R_MAX * 4);
    sysbus_init_mmio(sbd, &s->iomem);
}

static const VMStateDescription vmstate_ddr_phy = {
    .name = TYPE_XILINX_DDR_PHY,
    .version_id = 1,
    .minimum_version_id = 1,
    .minimum_version_id_old = 1,
    .fields = (VMStateField[]) {
        VMSTATE_UINT32_ARRAY(regs, DDR_PHY, R_MAX),
        VMSTATE_END_OF_LIST(),
    }
};

static void ddr_phy_class_init(ObjectClass *klass, void *data)
{
    DeviceClass *dc = DEVICE_CLASS(klass);

    dc->reset = ddr_phy_reset;
    dc->realize = ddr_phy_realize;
    dc->vmsd = &vmstate_ddr_phy;
}

static const TypeInfo ddr_phy_info = {
    .name          = TYPE_XILINX_DDR_PHY,
    .parent        = TYPE_SYS_BUS_DEVICE,
    .instance_size = sizeof(DDR_PHY),
    .class_init    = ddr_phy_class_init,
    .instance_init = ddr_phy_init,
};

static void ddr_phy_register_types(void)
{
    type_register_static(&ddr_phy_info);
}

type_init(ddr_phy_register_types)
